
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 105 "cfg.y"


#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#ifdef SHM_MEM
#include "shm_init.h"
#endif /* SHM_MEM */
#include "route.h"
#include "switch.h"
#include "dprint.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "dset.h"
#include "select.h"
#include "flags.h"
#include "tcp_init.h"
#include "tcp_options.h"
#include "sctp_options.h"
#include "pvar.h"
#include "lvalue.h"
#include "rvalue.h"
#include "sr_compat.h"
#include "msg_translator.h"

#include "config.h"
#include "cfg_core.h"
#include "cfg/cfg.h"
#ifdef CORE_TLS
#include "tls/tls_config.h"
#endif
#include "timer_ticks.h"

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#define onsend_check(s) \
	do{\
		if (rt!=ONSEND_ROUTE) yyerror( s " allowed only in onsend_routes");\
	}while(0)


#ifdef USE_DNS_CACHE
	#define IF_DNS_CACHE(x) x
#else
	#define IF_DNS_CACHE(x) warn("dns cache support not compiled in")
#endif

#ifdef USE_DNS_FAILOVER
	#define IF_DNS_FAILOVER(x) x
#else
	#define IF_DNS_FAILOVER(x) warn("dns failover support not compiled in")
#endif

#ifdef USE_NAPTR
	#define IF_NAPTR(x) x
#else
	#define IF_NAPTR(x) warn("dns naptr support not compiled in")
#endif

#ifdef USE_DST_BLACKLIST
	#define IF_DST_BLACKLIST(x) x
#else
	#define IF_DST_BLACKLIST(x) warn("dst blacklist support not compiled in")
#endif

#ifdef USE_STUN
	#define IF_STUN(x) x
#else 
	#define IF_STUN(x) warn("stun support not compiled in")
#endif

#ifdef USE_SCTP
	#define IF_SCTP(x) x
#else
	#define IF_SCTP(x) warn("sctp support not compiled in")
#endif


extern int yylex();
/* safer then using yytext which can be array or pointer */
extern char* yy_number_str;

static void yyerror(char* s, ...);
static void yyerror_at(struct cfg_pos* pos, char* s, ...);
static char* tmp;
static int i_tmp;
static unsigned u_tmp;
static struct socket_id* lst_tmp;
static struct name_lst*  nl_tmp;
static int rt;  /* Type of route block for find_export */
static str* str_tmp;
static str s_tmp;
static struct ip_addr* ip_tmp;
static struct avp_spec* s_attr;
static select_t sel;
static select_t* sel_ptr;
static pv_spec_t* pv_spec;
static struct action *mod_func_action;
static struct lvalue* lval_tmp;
static struct rvalue* rval_tmp;

static void warn(char* s, ...);
static void warn_at(struct cfg_pos* pos, char* s, ...);
static void get_cpos(struct cfg_pos* pos);
static struct rval_expr* mk_rve_rval(enum rval_type, void* v);
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1);
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2);
static int rval_expr_int_check(struct rval_expr *rve);
static int warn_ct_rve(struct rval_expr *rve, char* name);
static struct socket_id* mk_listen_id(char*, int, int);
static struct name_lst* mk_name_lst(char* name, int flags);
static struct socket_id* mk_listen_id2(struct name_lst*, int, int);
static void free_name_lst(struct name_lst* lst);
static void free_socket_id_lst(struct socket_id* i);

static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re, 
									struct action* a, int* err);
static int case_check_type(struct case_stms* stms);
static int case_check_default(struct case_stms* stms);


extern int line;
extern int column;
extern int startcolumn;
extern int startline;
extern char *finame;

#define set_cfg_pos(x) \
	do{\
		if(x) {\
		(x)->cline = line;\
		(x)->cfile = (finame!=0)?finame:((cfg_file!=0)?cfg_file:"default");\
		}\
	}while(0)




/* Line 189 of yacc.c  */
#line 232 "cfg.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     FORWARD = 258,
     FORWARD_TCP = 259,
     FORWARD_TLS = 260,
     FORWARD_SCTP = 261,
     FORWARD_UDP = 262,
     SEND = 263,
     SEND_TCP = 264,
     EXIT = 265,
     DROP = 266,
     RETURN = 267,
     BREAK = 268,
     LOG_TOK = 269,
     ERROR = 270,
     ROUTE = 271,
     ROUTE_FAILURE = 272,
     ROUTE_ONREPLY = 273,
     ROUTE_BRANCH = 274,
     ROUTE_SEND = 275,
     ROUTE_EVENT = 276,
     EXEC = 277,
     SET_HOST = 278,
     SET_HOSTPORT = 279,
     SET_HOSTPORTTRANS = 280,
     PREFIX = 281,
     STRIP = 282,
     STRIP_TAIL = 283,
     SET_USERPHONE = 284,
     APPEND_BRANCH = 285,
     SET_USER = 286,
     SET_USERPASS = 287,
     SET_PORT = 288,
     SET_URI = 289,
     REVERT_URI = 290,
     FORCE_RPORT = 291,
     ADD_LOCAL_RPORT = 292,
     FORCE_TCP_ALIAS = 293,
     UDP_MTU = 294,
     UDP_MTU_TRY_PROTO = 295,
     IF = 296,
     ELSE = 297,
     SET_ADV_ADDRESS = 298,
     SET_ADV_PORT = 299,
     FORCE_SEND_SOCKET = 300,
     SET_FWD_NO_CONNECT = 301,
     SET_RPL_NO_CONNECT = 302,
     SET_FWD_CLOSE = 303,
     SET_RPL_CLOSE = 304,
     SWITCH = 305,
     CASE = 306,
     DEFAULT = 307,
     WHILE = 308,
     URIHOST = 309,
     URIPORT = 310,
     MAX_LEN = 311,
     SETFLAG = 312,
     RESETFLAG = 313,
     ISFLAGSET = 314,
     SETAVPFLAG = 315,
     RESETAVPFLAG = 316,
     ISAVPFLAGSET = 317,
     METHOD = 318,
     URI = 319,
     FROM_URI = 320,
     TO_URI = 321,
     SRCIP = 322,
     SRCPORT = 323,
     DSTIP = 324,
     DSTPORT = 325,
     TOIP = 326,
     TOPORT = 327,
     SNDIP = 328,
     SNDPORT = 329,
     SNDPROTO = 330,
     SNDAF = 331,
     PROTO = 332,
     AF = 333,
     MYSELF = 334,
     MSGLEN = 335,
     UDP = 336,
     TCP = 337,
     TLS = 338,
     SCTP = 339,
     DEBUG_V = 340,
     FORK = 341,
     LOGSTDERROR = 342,
     LOGFACILITY = 343,
     LOGNAME = 344,
     LISTEN = 345,
     ALIAS = 346,
     SR_AUTO_ALIASES = 347,
     DNS = 348,
     REV_DNS = 349,
     DNS_TRY_IPV6 = 350,
     DNS_TRY_NAPTR = 351,
     DNS_SRV_LB = 352,
     DNS_UDP_PREF = 353,
     DNS_TCP_PREF = 354,
     DNS_TLS_PREF = 355,
     DNS_SCTP_PREF = 356,
     DNS_RETR_TIME = 357,
     DNS_RETR_NO = 358,
     DNS_SERVERS_NO = 359,
     DNS_USE_SEARCH = 360,
     DNS_SEARCH_FMATCH = 361,
     DNS_CACHE_INIT = 362,
     DNS_USE_CACHE = 363,
     DNS_USE_FAILOVER = 364,
     DNS_CACHE_FLAGS = 365,
     DNS_CACHE_NEG_TTL = 366,
     DNS_CACHE_MIN_TTL = 367,
     DNS_CACHE_MAX_TTL = 368,
     DNS_CACHE_MEM = 369,
     DNS_CACHE_GC_INT = 370,
     DNS_CACHE_DEL_NONEXP = 371,
     DST_BLST_INIT = 372,
     USE_DST_BLST = 373,
     DST_BLST_MEM = 374,
     DST_BLST_TTL = 375,
     DST_BLST_GC_INT = 376,
     PORT = 377,
     STAT = 378,
     CHILDREN = 379,
     CHECK_VIA = 380,
     PHONE2TEL = 381,
     SYN_BRANCH = 382,
     MEMLOG = 383,
     MEMDBG = 384,
     MEMSUM = 385,
     SIP_WARNING = 386,
     SERVER_SIGNATURE = 387,
     SERVER_HEADER = 388,
     USER_AGENT_HEADER = 389,
     REPLY_TO_VIA = 390,
     LOADMODULE = 391,
     LOADPATH = 392,
     MODPARAM = 393,
     MAXBUFFER = 394,
     USER = 395,
     GROUP = 396,
     CHROOT = 397,
     WDIR = 398,
     MHOMED = 399,
     DISABLE_TCP = 400,
     TCP_ACCEPT_ALIASES = 401,
     TCP_CHILDREN = 402,
     TCP_CONNECT_TIMEOUT = 403,
     TCP_SEND_TIMEOUT = 404,
     TCP_CON_LIFETIME = 405,
     TCP_POLL_METHOD = 406,
     TCP_MAX_CONNECTIONS = 407,
     TCP_NO_CONNECT = 408,
     TCP_SOURCE_IPV4 = 409,
     TCP_SOURCE_IPV6 = 410,
     TCP_OPT_FD_CACHE = 411,
     TCP_OPT_BUF_WRITE = 412,
     TCP_OPT_CONN_WQ_MAX = 413,
     TCP_OPT_WQ_MAX = 414,
     TCP_OPT_RD_BUF = 415,
     TCP_OPT_WQ_BLK = 416,
     TCP_OPT_DEFER_ACCEPT = 417,
     TCP_OPT_DELAYED_ACK = 418,
     TCP_OPT_SYNCNT = 419,
     TCP_OPT_LINGER2 = 420,
     TCP_OPT_KEEPALIVE = 421,
     TCP_OPT_KEEPIDLE = 422,
     TCP_OPT_KEEPINTVL = 423,
     TCP_OPT_KEEPCNT = 424,
     TCP_OPT_CRLF_PING = 425,
     DISABLE_TLS = 426,
     ENABLE_TLS = 427,
     TLSLOG = 428,
     TLS_PORT_NO = 429,
     TLS_METHOD = 430,
     TLS_HANDSHAKE_TIMEOUT = 431,
     TLS_SEND_TIMEOUT = 432,
     SSLv23 = 433,
     SSLv2 = 434,
     SSLv3 = 435,
     TLSv1 = 436,
     TLS_VERIFY = 437,
     TLS_REQUIRE_CERTIFICATE = 438,
     TLS_CERTIFICATE = 439,
     TLS_PRIVATE_KEY = 440,
     TLS_CA_LIST = 441,
     DISABLE_SCTP = 442,
     ENABLE_SCTP = 443,
     SCTP_CHILDREN = 444,
     SCTP_SOCKET_RCVBUF = 445,
     SCTP_SOCKET_SNDBUF = 446,
     SCTP_AUTOCLOSE = 447,
     SCTP_SEND_TTL = 448,
     SCTP_SEND_RETRIES = 449,
     SCTP_ASSOC_TRACKING = 450,
     SCTP_ASSOC_REUSE = 451,
     SCTP_MAX_ASSOCS = 452,
     SCTP_SRTO_INITIAL = 453,
     SCTP_SRTO_MAX = 454,
     SCTP_SRTO_MIN = 455,
     SCTP_ASOCMAXRXT = 456,
     SCTP_INIT_MAX_ATTEMPTS = 457,
     SCTP_INIT_MAX_TIMEO = 458,
     SCTP_HBINTERVAL = 459,
     SCTP_PATHMAXRXT = 460,
     SCTP_SACK_DELAY = 461,
     SCTP_SACK_FREQ = 462,
     SCTP_MAX_BURST = 463,
     ADVERTISED_ADDRESS = 464,
     ADVERTISED_PORT = 465,
     DISABLE_CORE = 466,
     OPEN_FD_LIMIT = 467,
     SHM_MEM_SZ = 468,
     SHM_FORCE_ALLOC = 469,
     MLOCK_PAGES = 470,
     REAL_TIME = 471,
     RT_PRIO = 472,
     RT_POLICY = 473,
     RT_TIMER1_PRIO = 474,
     RT_TIMER1_POLICY = 475,
     RT_TIMER2_PRIO = 476,
     RT_TIMER2_POLICY = 477,
     MCAST_LOOPBACK = 478,
     MCAST_TTL = 479,
     TOS = 480,
     PMTU_DISCOVERY = 481,
     KILL_TIMEOUT = 482,
     MAX_WLOOPS = 483,
     CFG_DESCRIPTION = 484,
     SERVER_ID = 485,
     FLAGS_DECL = 486,
     AVPFLAGS_DECL = 487,
     ATTR_MARK = 488,
     SELECT_MARK = 489,
     ATTR_FROM = 490,
     ATTR_TO = 491,
     ATTR_FROMURI = 492,
     ATTR_TOURI = 493,
     ATTR_FROMUSER = 494,
     ATTR_TOUSER = 495,
     ATTR_FROMDOMAIN = 496,
     ATTR_TODOMAIN = 497,
     ATTR_GLOBAL = 498,
     ADDEQ = 499,
     STUN_REFRESH_INTERVAL = 500,
     STUN_ALLOW_STUN = 501,
     STUN_ALLOW_FP = 502,
     EQUAL = 503,
     LOG_OR = 504,
     LOG_AND = 505,
     BIN_OR = 506,
     BIN_AND = 507,
     STRDIFF = 508,
     STREQ = 509,
     INTDIFF = 510,
     INTEQ = 511,
     MATCH = 512,
     DIFF = 513,
     EQUAL_T = 514,
     LTE = 515,
     GTE = 516,
     LT = 517,
     GT = 518,
     MINUS = 519,
     PLUS = 520,
     MODULO = 521,
     SLASH = 522,
     STAR = 523,
     UNARY = 524,
     NOT = 525,
     DEFINED = 526,
     STRCAST = 527,
     INTCAST = 528,
     DOT = 529,
     STRLEN = 530,
     STREMPTY = 531,
     NUMBER = 532,
     ID = 533,
     NUM_ID = 534,
     STRING = 535,
     IPV6ADDR = 536,
     PVAR = 537,
     AVP_OR_PVAR = 538,
     EVENT_RT_NAME = 539,
     COMMA = 540,
     SEMICOLON = 541,
     RPAREN = 542,
     LPAREN = 543,
     LBRACE = 544,
     RBRACE = 545,
     LBRACK = 546,
     RBRACK = 547,
     CR = 548,
     COLON = 549
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 263 "cfg.y"

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct case_stms* case_stms;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct name_lst* name_l;
	struct avp_spec* attr;
	struct _pv_spec* pvar;
	struct lvalue* lval;
	struct rvalue* rval;
	struct rval_expr* rv_expr;
	select_t* select;



/* Line 214 of yacc.c  */
#line 583 "cfg.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 595 "cfg.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  364
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   10239

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  295
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  94
/* YYNRULES -- Number of rules.  */
#define YYNRULES  792
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1490

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   549

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    13,    15,    17,    19,
      21,    22,    25,    26,    29,    30,    33,    34,    37,    38,
      41,    42,    45,    47,    49,    51,    53,    55,    57,    61,
      65,    67,    69,    71,    73,    75,    77,    79,    81,    83,
      87,    91,    97,   101,   103,   107,   111,   117,   121,   123,
     126,   128,   131,   134,   137,   139,   143,   145,   149,   151,
     153,   156,   159,   161,   165,   167,   171,   175,   179,   183,
     187,   191,   195,   199,   203,   207,   211,   215,   219,   223,
     227,   230,   234,   237,   241,   244,   248,   251,   255,   258,
     262,   265,   269,   272,   276,   279,   283,   286,   290,   293,
     297,   300,   304,   307,   311,   314,   318,   321,   325,   328,
     332,   335,   339,   342,   346,   349,   353,   356,   360,   363,
     367,   370,   374,   377,   381,   384,   388,   391,   395,   398,
     402,   405,   409,   412,   416,   420,   424,   428,   432,   436,
     440,   444,   448,   452,   456,   460,   464,   468,   472,   476,
     480,   484,   488,   492,   496,   500,   504,   508,   512,   516,
     520,   524,   528,   532,   536,   540,   544,   548,   552,   556,
     560,   564,   568,   572,   576,   580,   584,   588,   592,   596,
     600,   604,   608,   612,   616,   620,   624,   628,   632,   636,
     640,   644,   648,   652,   656,   660,   664,   667,   671,   674,
     678,   681,   685,   688,   692,   696,   700,   704,   708,   712,
     716,   720,   724,   728,   732,   736,   740,   744,   748,   752,
     756,   760,   764,   768,   772,   776,   780,   784,   788,   792,
     796,   800,   804,   808,   812,   816,   820,   824,   828,   832,
     836,   840,   844,   848,   852,   856,   860,   864,   868,   872,
     876,   880,   884,   888,   892,   896,   900,   904,   908,   912,
     916,   920,   924,   928,   932,   936,   940,   944,   948,   952,
     956,   960,   964,   968,   972,   976,   980,   984,   988,   992,
     996,  1000,  1004,  1008,  1012,  1016,  1020,  1024,  1028,  1032,
    1036,  1040,  1044,  1048,  1052,  1056,  1060,  1064,  1068,  1072,
    1076,  1080,  1084,  1088,  1092,  1096,  1100,  1104,  1108,  1112,
    1116,  1120,  1124,  1128,  1132,  1136,  1140,  1144,  1148,  1152,
    1156,  1160,  1164,  1168,  1172,  1176,  1180,  1184,  1188,  1192,
    1196,  1200,  1204,  1208,  1212,  1216,  1220,  1224,  1228,  1232,
    1236,  1240,  1243,  1247,  1251,  1255,  1259,  1263,  1267,  1271,
    1275,  1279,  1283,  1287,  1291,  1295,  1299,  1303,  1307,  1311,
    1313,  1316,  1318,  1320,  1326,  1332,  1340,  1348,  1354,  1357,
    1360,  1363,  1366,  1370,  1374,  1383,  1392,  1395,  1397,  1399,
    1407,  1409,  1411,  1415,  1417,  1419,  1421,  1426,  1434,  1437,
    1442,  1450,  1453,  1458,  1466,  1469,  1474,  1482,  1485,  1490,
    1498,  1501,  1509,  1512,  1514,  1516,  1518,  1520,  1522,  1524,
    1526,  1528,  1530,  1532,  1534,  1536,  1538,  1540,  1542,  1544,
    1546,  1548,  1550,  1552,  1554,  1556,  1558,  1560,  1562,  1564,
    1566,  1568,  1570,  1572,  1574,  1576,  1578,  1580,  1582,  1584,
    1586,  1590,  1594,  1598,  1601,  1605,  1609,  1613,  1616,  1620,
    1624,  1628,  1632,  1635,  1639,  1643,  1647,  1651,  1655,  1659,
    1663,  1667,  1671,  1675,  1679,  1682,  1686,  1690,  1694,  1697,
    1701,  1705,  1707,  1711,  1713,  1717,  1721,  1725,  1729,  1731,
    1733,  1735,  1737,  1741,  1745,  1749,  1753,  1755,  1757,  1761,
    1764,  1766,  1769,  1772,  1774,  1776,  1778,  1781,  1784,  1786,
    1789,  1793,  1799,  1801,  1806,  1812,  1816,  1821,  1825,  1828,
    1833,  1839,  1843,  1848,  1853,  1856,  1858,  1864,  1869,  1872,
    1878,  1882,  1884,  1889,  1894,  1898,  1900,  1901,  1905,  1907,
    1909,  1911,  1913,  1915,  1917,  1919,  1921,  1923,  1925,  1927,
    1931,  1933,  1936,  1942,  1947,  1949,  1951,  1953,  1955,  1957,
    1959,  1961,  1963,  1965,  1967,  1969,  1971,  1973,  1975,  1977,
    1979,  1981,  1983,  1985,  1987,  1989,  1991,  1995,  1999,  2003,
    2007,  2009,  2011,  2013,  2016,  2019,  2022,  2026,  2030,  2034,
    2038,  2042,  2046,  2050,  2054,  2058,  2062,  2066,  2070,  2075,
    2080,  2083,  2086,  2089,  2092,  2096,  2100,  2104,  2108,  2112,
    2116,  2120,  2124,  2128,  2132,  2136,  2141,  2146,  2149,  2153,
    2155,  2157,  2159,  2163,  2168,  2173,  2178,  2185,  2192,  2199,
    2206,  2213,  2218,  2221,  2226,  2231,  2236,  2241,  2248,  2255,
    2262,  2269,  2276,  2281,  2284,  2289,  2294,  2299,  2304,  2311,
    2318,  2325,  2332,  2339,  2344,  2347,  2352,  2357,  2362,  2367,
    2374,  2381,  2388,  2395,  2402,  2407,  2410,  2415,  2420,  2425,
    2430,  2437,  2444,  2451,  2458,  2465,  2470,  2473,  2478,  2483,
    2488,  2493,  2500,  2507,  2514,  2517,  2522,  2527,  2532,  2537,
    2544,  2551,  2558,  2561,  2566,  2571,  2578,  2581,  2586,  2591,
    2596,  2599,  2604,  2609,  2612,  2617,  2622,  2625,  2632,  2639,
    2646,  2651,  2654,  2661,  2664,  2669,  2674,  2677,  2682,  2687,
    2692,  2695,  2700,  2705,  2708,  2713,  2718,  2721,  2726,  2731,
    2734,  2739,  2743,  2746,  2753,  2758,  2762,  2764,  2769,  2772,
    2777,  2782,  2785,  2790,  2795,  2798,  2803,  2808,  2811,  2816,
    2821,  2824,  2829,  2834,  2837,  2842,  2846,  2848,  2852,  2854,
    2858,  2860,  2865,  2869,  2871,  2876,  2881,  2886,  2891,  2896,
    2899,  2904,  2909,  2912,  2917,  2922,  2925,  2929,  2931,  2935,
    2937,  2941,  2943,  2947,  2949,  2950,  2956,  2959,  2960,  2964,
    2966,  2969,  2971,  2973,  2977,  2980,  2982,  2986,  2989,  2991,
    2993,  2997,  3000
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     296,     0,    -1,   297,    -1,   297,   298,    -1,   298,    -1,
     297,     1,    -1,   321,    -1,   314,    -1,   318,    -1,   324,
      -1,    -1,   299,   330,    -1,    -1,   300,   331,    -1,    -1,
     301,   332,    -1,    -1,   302,   333,    -1,    -1,   303,   334,
      -1,    -1,   304,   335,    -1,   286,    -1,   293,    -1,   325,
      -1,   280,    -1,   350,    -1,   305,    -1,   305,   285,   306,
      -1,   288,   306,   287,    -1,   305,    -1,    81,    -1,    82,
      -1,    83,    -1,    84,    -1,   268,    -1,   277,    -1,   268,
      -1,   305,    -1,   305,   294,   309,    -1,   308,   294,   305,
      -1,   308,   294,   305,   294,   309,    -1,   305,   294,     1,
      -1,   307,    -1,   307,   294,   309,    -1,   308,   294,   307,
      -1,   308,   294,   307,   294,   309,    -1,   307,   294,     1,
      -1,   311,    -1,   311,   312,    -1,   277,    -1,   264,   277,
      -1,   231,   315,    -1,   231,     1,    -1,   316,    -1,   316,
     285,   315,    -1,   317,    -1,   317,   294,   277,    -1,   280,
      -1,   278,    -1,   232,   319,    -1,   232,     1,    -1,   320,
      -1,   320,   285,   319,    -1,   317,    -1,    85,   248,   313,
      -1,    85,   248,     1,    -1,    86,   248,   277,    -1,    86,
     248,     1,    -1,    87,   248,   277,    -1,    87,   248,     1,
      -1,    88,   248,   278,    -1,    88,   248,     1,    -1,    89,
     248,   280,    -1,    89,   248,     1,    -1,    93,   248,   277,
      -1,    93,   248,     1,    -1,    94,   248,   277,    -1,    94,
     248,     1,    -1,    95,   248,   277,    -1,    95,     1,    -1,
      96,   248,   277,    -1,    96,     1,    -1,    97,   248,   277,
      -1,    97,     1,    -1,    98,   248,   313,    -1,    98,     1,
      -1,    99,   248,   313,    -1,    99,     1,    -1,   100,   248,
     313,    -1,   100,     1,    -1,   101,   248,   313,    -1,   101,
       1,    -1,   102,   248,   277,    -1,   102,     1,    -1,   103,
     248,   277,    -1,   103,     1,    -1,   104,   248,   277,    -1,
     104,     1,    -1,   105,   248,   277,    -1,   105,     1,    -1,
     106,   248,   277,    -1,   106,     1,    -1,   107,   248,   277,
      -1,   107,     1,    -1,   108,   248,   277,    -1,   108,     1,
      -1,   109,   248,   277,    -1,   109,     1,    -1,   110,   248,
     277,    -1,   110,     1,    -1,   111,   248,   277,    -1,   111,
       1,    -1,   113,   248,   277,    -1,   113,     1,    -1,   112,
     248,   277,    -1,   112,     1,    -1,   114,   248,   277,    -1,
     114,     1,    -1,   115,   248,   277,    -1,   115,     1,    -1,
     116,   248,   277,    -1,   116,     1,    -1,   117,   248,   277,
      -1,   117,     1,    -1,   118,   248,   277,    -1,   118,     1,
      -1,   119,   248,   277,    -1,   119,     1,    -1,   120,   248,
     277,    -1,   120,     1,    -1,   121,   248,   277,    -1,   121,
       1,    -1,   122,   248,   277,    -1,   123,   248,   280,    -1,
     139,   248,   277,    -1,   139,   248,     1,    -1,   122,   248,
       1,    -1,   124,   248,   277,    -1,   124,   248,     1,    -1,
     125,   248,   277,    -1,   125,   248,     1,    -1,   126,   248,
     277,    -1,   126,   248,     1,    -1,   127,   248,   277,    -1,
     127,   248,     1,    -1,   128,   248,   313,    -1,   128,   248,
       1,    -1,   129,   248,   313,    -1,   129,   248,     1,    -1,
     130,   248,   313,    -1,   130,   248,     1,    -1,   131,   248,
     277,    -1,   131,   248,     1,    -1,   140,   248,   280,    -1,
     140,   248,   278,    -1,   140,   248,     1,    -1,   141,   248,
     280,    -1,   141,   248,   278,    -1,   141,   248,     1,    -1,
     142,   248,   280,    -1,   142,   248,   278,    -1,   142,   248,
       1,    -1,   143,   248,   280,    -1,   143,   248,   278,    -1,
     143,   248,     1,    -1,   144,   248,   277,    -1,   144,   248,
       1,    -1,   145,   248,   277,    -1,   145,   248,     1,    -1,
     146,   248,   277,    -1,   146,   248,     1,    -1,   147,   248,
     277,    -1,   147,   248,     1,    -1,   148,   248,   313,    -1,
     148,   248,     1,    -1,   149,   248,   313,    -1,   149,   248,
       1,    -1,   150,   248,   313,    -1,   150,   248,     1,    -1,
     151,   248,   278,    -1,   151,   248,   280,    -1,   151,   248,
       1,    -1,   152,   248,   277,    -1,   152,   248,     1,    -1,
     153,   248,   277,    -1,   153,   248,     1,    -1,   154,   248,
     326,    -1,   154,   248,     1,    -1,   155,   248,   328,    -1,
     155,   248,     1,    -1,   156,   248,   277,    -1,   156,   248,
       1,    -1,   157,   248,   277,    -1,   157,   248,     1,    -1,
     158,   248,   277,    -1,   158,     1,    -1,   159,   248,   277,
      -1,   159,     1,    -1,   160,   248,   277,    -1,   160,     1,
      -1,   161,   248,   277,    -1,   161,     1,    -1,   162,   248,
     277,    -1,   162,   248,     1,    -1,   163,   248,   277,    -1,
     163,   248,     1,    -1,   164,   248,   277,    -1,   164,   248,
       1,    -1,   165,   248,   277,    -1,   165,   248,     1,    -1,
     166,   248,   277,    -1,   166,   248,     1,    -1,   167,   248,
     277,    -1,   167,   248,     1,    -1,   168,   248,   277,    -1,
     168,   248,     1,    -1,   169,   248,   277,    -1,   169,   248,
       1,    -1,   170,   248,   277,    -1,   170,   248,     1,    -1,
     171,   248,   277,    -1,   171,   248,     1,    -1,   172,   248,
     277,    -1,   172,   248,     1,    -1,   173,   248,   277,    -1,
     173,   248,     1,    -1,   174,   248,   277,    -1,   174,   248,
       1,    -1,   175,   248,   178,    -1,   175,   248,   179,    -1,
     175,   248,   180,    -1,   175,   248,   181,    -1,   175,   248,
       1,    -1,   182,   248,   277,    -1,   182,   248,     1,    -1,
     183,   248,   277,    -1,   183,   248,     1,    -1,   184,   248,
     280,    -1,   184,   248,     1,    -1,   185,   248,   280,    -1,
     185,   248,     1,    -1,   186,   248,   280,    -1,   186,   248,
       1,    -1,   176,   248,   277,    -1,   176,   248,     1,    -1,
     177,   248,   277,    -1,   177,   248,     1,    -1,   187,   248,
     277,    -1,   187,   248,     1,    -1,   188,   248,   277,    -1,
     188,   248,     1,    -1,   189,   248,   277,    -1,   189,   248,
       1,    -1,   190,   248,   277,    -1,   190,   248,     1,    -1,
     191,   248,   277,    -1,   191,   248,     1,    -1,   192,   248,
     277,    -1,   192,   248,     1,    -1,   193,   248,   277,    -1,
     193,   248,     1,    -1,   194,   248,   277,    -1,   194,   248,
       1,    -1,   195,   248,   277,    -1,   195,   248,     1,    -1,
     196,   248,   277,    -1,   196,   248,     1,    -1,   197,   248,
     313,    -1,   197,   248,     1,    -1,   198,   248,   277,    -1,
     198,   248,     1,    -1,   199,   248,   277,    -1,   199,   248,
       1,    -1,   200,   248,   277,    -1,   200,   248,     1,    -1,
     201,   248,   277,    -1,   201,   248,     1,    -1,   202,   248,
     277,    -1,   202,   248,     1,    -1,   203,   248,   277,    -1,
     203,   248,     1,    -1,   204,   248,   313,    -1,   204,   248,
       1,    -1,   205,   248,   277,    -1,   205,   248,     1,    -1,
     206,   248,   277,    -1,   206,   248,     1,    -1,   207,   248,
     277,    -1,   207,   248,     1,    -1,   208,   248,   277,    -1,
     208,   248,     1,    -1,   132,   248,   277,    -1,   132,   248,
       1,    -1,   133,   248,   280,    -1,   133,   248,     1,    -1,
     134,   248,   280,    -1,   134,   248,     1,    -1,   135,   248,
     277,    -1,   135,   248,     1,    -1,    90,   248,   312,    -1,
      90,   248,     1,    -1,    91,   248,   312,    -1,    91,   248,
       1,    -1,    92,   248,   277,    -1,    92,   248,     1,    -1,
     209,   248,   305,    -1,   209,   248,     1,    -1,   210,   248,
     277,    -1,   210,   248,     1,    -1,   211,   248,   277,    -1,
     211,   248,     1,    -1,   212,   248,   277,    -1,   212,   248,
       1,    -1,   213,   248,   277,    -1,   213,   248,     1,    -1,
     214,   248,   277,    -1,   214,   248,     1,    -1,   215,   248,
     277,    -1,   215,   248,     1,    -1,   216,   248,   277,    -1,
     216,   248,     1,    -1,   217,   248,   277,    -1,   217,   248,
       1,    -1,   218,   248,   277,    -1,   218,   248,     1,    -1,
     219,   248,   277,    -1,   219,   248,     1,    -1,   220,   248,
     277,    -1,   220,   248,     1,    -1,   221,   248,   277,    -1,
     221,   248,     1,    -1,   222,   248,   277,    -1,   222,   248,
       1,    -1,   223,   248,   277,    -1,   223,   248,     1,    -1,
     224,   248,   277,    -1,   224,   248,     1,    -1,   225,   248,
     277,    -1,   225,   248,     1,    -1,   226,   248,   277,    -1,
     226,     1,    -1,   227,   248,   277,    -1,   227,   248,     1,
      -1,   228,   248,   277,    -1,   228,   248,     1,    -1,   245,
     248,   277,    -1,   245,   248,     1,    -1,   246,   248,   277,
      -1,   246,   248,     1,    -1,   247,   248,   277,    -1,   247,
     248,     1,    -1,   230,   248,   277,    -1,    39,   248,   277,
      -1,    39,   248,     1,    -1,    36,   248,   277,    -1,    36,
     248,     1,    -1,    40,   248,   308,    -1,    40,   248,     1,
      -1,   323,    -1,     1,   248,    -1,   278,    -1,    52,    -1,
     322,   274,   322,   248,   277,    -1,   322,   274,   322,   248,
     280,    -1,   322,   274,   322,   248,   277,   229,   280,    -1,
     322,   274,   322,   248,   280,   229,   280,    -1,   322,   274,
     322,   248,     1,    -1,   136,   280,    -1,   136,     1,    -1,
     137,   280,    -1,   137,     1,    -1,   137,   248,   280,    -1,
     137,   248,     1,    -1,   138,   288,   280,   285,   280,   285,
     280,   287,    -1,   138,   288,   280,   285,   280,   285,   313,
     287,    -1,   138,     1,    -1,   326,    -1,   328,    -1,   277,
     274,   277,   274,   277,   274,   277,    -1,   281,    -1,   327,
      -1,   291,   327,   292,    -1,   277,    -1,   278,    -1,   280,
      -1,    16,   289,   353,   290,    -1,    16,   291,   329,   292,
     289,   353,   290,    -1,    16,     1,    -1,    17,   289,   353,
     290,    -1,    17,   291,   329,   292,   289,   353,   290,    -1,
      17,     1,    -1,    18,   289,   353,   290,    -1,    18,   291,
     329,   292,   289,   353,   290,    -1,    18,     1,    -1,    19,
     289,   353,   290,    -1,    19,   291,   329,   292,   289,   353,
     290,    -1,    19,     1,    -1,    20,   289,   353,   290,    -1,
      20,   291,   329,   292,   289,   353,   290,    -1,    20,     1,
      -1,    21,   291,   284,   292,   289,   353,   290,    -1,    21,
       1,    -1,   259,    -1,   258,    -1,   254,    -1,   253,    -1,
     263,    -1,   262,    -1,   261,    -1,   260,    -1,   336,    -1,
     257,    -1,   259,    -1,   258,    -1,   256,    -1,   255,    -1,
     254,    -1,   253,    -1,   257,    -1,   263,    -1,   262,    -1,
     261,    -1,   260,    -1,    64,    -1,    65,    -1,    66,    -1,
      74,    -1,    72,    -1,    76,    -1,    68,    -1,    70,    -1,
      78,    -1,    80,    -1,   342,    -1,    73,    -1,    71,    -1,
      67,    -1,    69,    -1,   344,    -1,    63,   338,   381,    -1,
      63,   338,   278,    -1,    63,   338,     1,    -1,    63,     1,
      -1,   341,   338,   381,    -1,   341,   338,    79,    -1,   341,
     338,     1,    -1,   341,     1,    -1,   343,   337,   381,    -1,
     343,   336,   381,    -1,   343,   337,     1,    -1,   343,   336,
       1,    -1,   343,     1,    -1,    77,   336,   308,    -1,    77,
     336,   381,    -1,    77,   336,     1,    -1,    75,   336,   308,
      -1,    75,   336,   381,    -1,    75,   336,     1,    -1,   345,
     338,   347,    -1,   345,   338,   381,    -1,   345,   338,   348,
      -1,   345,   338,    79,    -1,   345,   338,     1,    -1,   345,
       1,    -1,    79,   336,   341,    -1,    79,   336,   345,    -1,
      79,   336,     1,    -1,    79,     1,    -1,   325,   267,   325,
      -1,   325,   267,   277,    -1,   325,    -1,   325,   267,     1,
      -1,   278,    -1,   348,   274,   278,    -1,   348,   264,   278,
      -1,   348,   274,     1,    -1,   348,   264,     1,    -1,   278,
      -1,   279,    -1,   277,    -1,   349,    -1,   350,   274,   349,
      -1,   350,   264,   349,    -1,   350,   274,     1,    -1,   350,
     264,     1,    -1,   384,    -1,   354,    -1,   289,   353,   290,
      -1,   353,   354,    -1,   354,    -1,   353,     1,    -1,   351,
     286,    -1,   355,    -1,   359,    -1,   360,    -1,   388,   286,
      -1,   382,   286,    -1,   286,    -1,   351,     1,    -1,    41,
     381,   352,    -1,    41,   381,   352,    42,   352,    -1,   381,
      -1,    51,   356,   294,   353,    -1,    51,   267,   356,   294,
     353,    -1,    51,   356,   294,    -1,    51,   267,   356,   294,
      -1,    52,   294,   353,    -1,    52,   294,    -1,    51,     1,
     294,   353,    -1,    51,   267,     1,   294,   353,    -1,    51,
       1,   294,    -1,    51,   267,     1,   294,    -1,    51,   356,
     294,     1,    -1,   358,   357,    -1,   357,    -1,    50,   381,
     289,   358,   290,    -1,    50,   381,   289,   290,    -1,    50,
       1,    -1,    50,   381,   289,     1,   290,    -1,    53,   381,
     352,    -1,   278,    -1,   278,   291,   313,   292,    -1,   278,
     291,   280,   292,    -1,   362,   274,   361,    -1,   361,    -1,
      -1,   234,   364,   362,    -1,   235,    -1,   236,    -1,   237,
      -1,   238,    -1,   239,    -1,   240,    -1,   241,    -1,   242,
      -1,   243,    -1,   278,    -1,   366,    -1,   365,   274,   366,
      -1,   233,    -1,   368,   367,    -1,   368,   367,   291,   313,
     292,    -1,   368,   367,   291,   292,    -1,   369,    -1,   371,
      -1,   369,    -1,   371,    -1,   370,    -1,   369,    -1,   376,
      -1,   280,    -1,   282,    -1,   283,    -1,   248,    -1,   372,
      -1,   375,    -1,   376,    -1,   313,    -1,   280,    -1,   373,
      -1,   375,    -1,   376,    -1,   363,    -1,   351,    -1,   346,
      -1,   289,   353,   290,    -1,   289,     1,   290,    -1,   288,
     382,   287,    -1,   288,     1,   287,    -1,   270,    -1,   264,
      -1,   379,    -1,   380,   381,    -1,   273,   381,    -1,   272,
     381,    -1,   381,   265,   381,    -1,   381,   264,   381,    -1,
     381,   268,   381,    -1,   381,   267,   381,    -1,   381,   266,
     381,    -1,   381,   251,   381,    -1,   381,   252,   381,    -1,
     381,   340,   381,    -1,   381,   339,   381,    -1,   381,   250,
     381,    -1,   381,   249,   381,    -1,   288,   381,   287,    -1,
     275,   288,   381,   287,    -1,   276,   288,   381,   287,    -1,
     271,   381,    -1,   380,     1,    -1,   273,     1,    -1,   272,
       1,    -1,   381,   265,     1,    -1,   381,   264,     1,    -1,
     381,   268,     1,    -1,   381,   267,     1,    -1,   381,   266,
       1,    -1,   381,   251,     1,    -1,   381,   252,     1,    -1,
     381,   340,     1,    -1,   381,   339,     1,    -1,   381,   250,
       1,    -1,   381,   249,     1,    -1,   275,   288,     1,   287,
      -1,   276,   288,     1,   287,    -1,   271,     1,    -1,   378,
     377,   381,    -1,    60,    -1,    61,    -1,    62,    -1,     3,
     288,   287,    -1,     3,   288,   348,   287,    -1,     3,   288,
     280,   287,    -1,     3,   288,   325,   287,    -1,     3,   288,
     348,   285,   277,   287,    -1,     3,   288,   280,   285,   277,
     287,    -1,     3,   288,   325,   285,   277,   287,    -1,     3,
     288,    54,   285,    55,   287,    -1,     3,   288,    54,   285,
     277,   287,    -1,     3,   288,    54,   287,    -1,     3,     1,
      -1,     3,   288,     1,   287,    -1,     7,   288,   348,   287,
      -1,     7,   288,   280,   287,    -1,     7,   288,   325,   287,
      -1,     7,   288,   348,   285,   277,   287,    -1,     7,   288,
     280,   285,   277,   287,    -1,     7,   288,   325,   285,   277,
     287,    -1,     7,   288,    54,   285,    55,   287,    -1,     7,
     288,    54,   285,   277,   287,    -1,     7,   288,    54,   287,
      -1,     7,     1,    -1,     7,   288,     1,   287,    -1,     4,
     288,   348,   287,    -1,     4,   288,   280,   287,    -1,     4,
     288,   325,   287,    -1,     4,   288,   348,   285,   277,   287,
      -1,     4,   288,   280,   285,   277,   287,    -1,     4,   288,
     325,   285,   277,   287,    -1,     4,   288,    54,   285,    55,
     287,    -1,     4,   288,    54,   285,   277,   287,    -1,     4,
     288,    54,   287,    -1,     4,     1,    -1,     4,   288,     1,
     287,    -1,     5,   288,   348,   287,    -1,     5,   288,   280,
     287,    -1,     5,   288,   325,   287,    -1,     5,   288,   348,
     285,   277,   287,    -1,     5,   288,   280,   285,   277,   287,
      -1,     5,   288,   325,   285,   277,   287,    -1,     5,   288,
      54,   285,    55,   287,    -1,     5,   288,    54,   285,   277,
     287,    -1,     5,   288,    54,   287,    -1,     5,     1,    -1,
       5,   288,     1,   287,    -1,     6,   288,   348,   287,    -1,
       6,   288,   280,   287,    -1,     6,   288,   325,   287,    -1,
       6,   288,   348,   285,   277,   287,    -1,     6,   288,   280,
     285,   277,   287,    -1,     6,   288,   325,   285,   277,   287,
      -1,     6,   288,    54,   285,    55,   287,    -1,     6,   288,
      54,   285,   277,   287,    -1,     6,   288,    54,   287,    -1,
       6,     1,    -1,     6,   288,     1,   287,    -1,     8,   288,
     348,   287,    -1,     8,   288,   280,   287,    -1,     8,   288,
     325,   287,    -1,     8,   288,   348,   285,   277,   287,    -1,
       8,   288,   280,   285,   277,   287,    -1,     8,   288,   325,
     285,   277,   287,    -1,     8,     1,    -1,     8,   288,     1,
     287,    -1,     9,   288,   348,   287,    -1,     9,   288,   280,
     287,    -1,     9,   288,   325,   287,    -1,     9,   288,   348,
     285,   277,   287,    -1,     9,   288,   280,   285,   277,   287,
      -1,     9,   288,   325,   285,   277,   287,    -1,     9,     1,
      -1,     9,   288,     1,   287,    -1,    14,   288,   280,   287,
      -1,    14,   288,   277,   285,   280,   287,    -1,    14,     1,
      -1,    14,   288,     1,   287,    -1,    57,   288,   277,   287,
      -1,    57,   288,   317,   287,    -1,    57,     1,    -1,    58,
     288,   277,   287,    -1,    58,   288,   317,   287,    -1,    58,
       1,    -1,    59,   288,   277,   287,    -1,    59,   288,   317,
     287,    -1,    59,     1,    -1,   383,   288,   374,   285,   317,
     287,    -1,   383,   288,   374,   285,     1,   287,    -1,   383,
     288,     1,   285,   317,   287,    -1,   383,   288,     1,   287,
      -1,   383,     1,    -1,    15,   288,   280,   285,   280,   287,
      -1,    15,     1,    -1,    15,   288,     1,   287,    -1,    16,
     288,   329,   287,    -1,    16,     1,    -1,    16,   288,     1,
     287,    -1,    22,   288,   280,   287,    -1,    23,   288,   280,
     287,    -1,    23,     1,    -1,    23,   288,     1,   287,    -1,
      26,   288,   280,   287,    -1,    26,     1,    -1,    26,   288,
       1,   287,    -1,    28,   288,   277,   287,    -1,    28,     1,
      -1,    28,   288,     1,   287,    -1,    27,   288,   277,   287,
      -1,    27,     1,    -1,    27,   288,     1,   287,    -1,    29,
     288,   287,    -1,    29,     1,    -1,    30,   288,   280,   285,
     280,   287,    -1,    30,   288,   280,   287,    -1,    30,   288,
     287,    -1,    30,    -1,    24,   288,   280,   287,    -1,    24,
       1,    -1,    24,   288,     1,   287,    -1,    25,   288,   280,
     287,    -1,    25,     1,    -1,    25,   288,     1,   287,    -1,
      33,   288,   280,   287,    -1,    33,     1,    -1,    33,   288,
       1,   287,    -1,    31,   288,   280,   287,    -1,    31,     1,
      -1,    31,   288,     1,   287,    -1,    32,   288,   280,   287,
      -1,    32,     1,    -1,    32,   288,     1,   287,    -1,    34,
     288,   280,   287,    -1,    34,     1,    -1,    34,   288,     1,
     287,    -1,    35,   288,   287,    -1,    35,    -1,    36,   288,
     287,    -1,    36,    -1,    37,   288,   287,    -1,    37,    -1,
      38,   288,   277,   287,    -1,    38,   288,   287,    -1,    38,
      -1,    38,   288,     1,   287,    -1,    40,   288,   308,   287,
      -1,    40,   288,     1,   287,    -1,    43,   288,   305,   287,
      -1,    43,   288,     1,   287,    -1,    43,     1,    -1,    44,
     288,   277,   287,    -1,    44,   288,     1,   287,    -1,    44,
       1,    -1,    45,   288,   310,   287,    -1,    45,   288,     1,
     287,    -1,    45,     1,    -1,    46,   288,   287,    -1,    46,
      -1,    47,   288,   287,    -1,    47,    -1,    48,   288,   287,
      -1,    48,    -1,    49,   288,   287,    -1,    49,    -1,    -1,
     278,   385,   288,   386,   287,    -1,   278,     1,    -1,    -1,
     386,   285,   387,    -1,   387,    -1,   386,     1,    -1,   313,
      -1,   280,    -1,    11,   288,   287,    -1,    11,   381,    -1,
      11,    -1,    10,   288,   287,    -1,    10,   381,    -1,    10,
      -1,    12,    -1,    12,   288,   287,    -1,    12,   381,    -1,
      13,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   633,   633,   636,   637,   638,   641,   642,   643,   644,
     645,   645,   646,   646,   647,   647,   648,   648,   649,   649,
     650,   650,   651,   652,   655,   673,   682,   697,   698,   704,
     705,   709,   710,   711,   712,   713,   716,   717,   720,   721,
     722,   723,   724,   728,   729,   730,   731,   732,   736,   737,
     740,   741,   744,   745,   747,   748,   751,   754,   760,   761,
     765,   766,   769,   770,   773,   779,   780,   781,   782,   783,
     784,   785,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   812,   813,   814,   815,   816,   817,   818,   819,
     820,   821,   822,   823,   824,   825,   826,   827,   828,   829,
     830,   831,   832,   833,   834,   835,   836,   837,   838,   839,
     840,   841,   842,   843,   844,   845,   846,   847,   848,   849,
     850,   851,   852,   853,   854,   859,   860,   861,   862,   863,
     864,   865,   866,   867,   868,   869,   870,   871,   872,   873,
     874,   875,   876,   877,   878,   885,   892,   893,   894,   895,
     896,   897,   898,   899,   900,   901,   902,   903,   904,   911,
     912,   919,   920,   927,   928,   935,   936,   943,   944,   954,
     955,   969,   983,   984,   991,   992,   999,  1000,  1009,  1010,
    1023,  1024,  1031,  1032,  1039,  1040,  1047,  1048,  1055,  1056,
    1063,  1064,  1071,  1072,  1079,  1080,  1087,  1088,  1095,  1096,
    1103,  1104,  1111,  1112,  1119,  1120,  1127,  1128,  1135,  1136,
    1143,  1144,  1151,  1152,  1159,  1160,  1167,  1168,  1175,  1176,
    1183,  1190,  1197,  1204,  1211,  1218,  1219,  1226,  1227,  1234,
    1235,  1242,  1243,  1250,  1251,  1258,  1259,  1266,  1267,  1274,
    1275,  1282,  1283,  1290,  1291,  1298,  1299,  1306,  1307,  1314,
    1315,  1322,  1323,  1330,  1331,  1344,  1345,  1358,  1359,  1362,
    1363,  1366,  1367,  1370,  1371,  1374,  1375,  1378,  1379,  1382,
    1383,  1386,  1387,  1390,  1391,  1394,  1395,  1398,  1399,  1402,
    1403,  1406,  1407,  1408,  1409,  1412,  1413,  1416,  1417,  1418,
    1419,  1432,  1434,  1445,  1446,  1447,  1448,  1454,  1455,  1465,
    1466,  1467,  1468,  1469,  1470,  1477,  1478,  1485,  1486,  1487,
    1488,  1489,  1490,  1491,  1492,  1493,  1494,  1495,  1496,  1497,
    1498,  1499,  1500,  1501,  1502,  1509,  1510,  1517,  1518,  1519,
    1520,  1521,  1522,  1523,  1524,  1525,  1526,  1527,  1528,  1529,
    1530,  1531,  1532,  1533,  1534,  1535,  1537,  1538,  1540,  1542,
    1543,  1546,  1547,  1551,  1556,  1561,  1566,  1571,  1577,  1583,
    1584,  1589,  1590,  1595,  1596,  1607,  1618,  1621,  1622,  1625,
    1654,  1674,  1675,  1679,  1689,  1690,  1694,  1703,  1721,  1724,
    1733,  1751,  1754,  1763,  1781,  1784,  1793,  1811,  1813,  1822,
    1840,  1842,  1861,  1883,  1884,  1885,  1886,  1889,  1890,  1891,
    1892,  1895,  1896,  1902,  1903,  1904,  1905,  1906,  1907,  1908,
    1911,  1912,  1913,  1914,  1921,  1922,  1923,  1930,  1931,  1932,
    1936,  1937,  1938,  1939,  1940,  1945,  1946,  1949,  1950,  1951,
    1957,  1959,  1961,  1962,  1964,  1966,  1968,  1970,  1972,  1973,
    1975,  1976,  1977,  1978,  1980,  1982,  1984,  1986,  1988,  1990,
    1991,  2029,  2031,  2033,  2035,  2038,  2040,  2042,  2044,  2061,
    2062,  2073,  2074,  2078,  2079,  2095,  2111,  2112,  2115,  2116,
    2117,  2126,  2127,  2143,  2159,  2161,  2168,  2205,  2206,  2209,
    2210,  2211,  2214,  2215,  2216,  2217,  2218,  2219,  2220,  2221,
    2224,  2232,  2242,  2259,  2266,  2273,  2280,  2287,  2292,  2297,
    2298,  2299,  2300,  2301,  2304,  2313,  2320,  2345,  2361,  2362,
    2367,  2386,  2395,  2407,  2422,  2423,  2426,  2426,  2436,  2437,
    2438,  2439,  2440,  2441,  2442,  2443,  2444,  2447,  2450,  2451,
    2454,  2461,  2464,  2471,  2477,  2478,  2487,  2488,  2489,  2492,
    2493,  2505,  2529,  2547,  2582,  2586,  2596,  2611,  2623,  2624,
    2626,  2627,  2628,  2642,  2643,  2644,  2645,  2646,  2647,  2648,
    2652,  2653,  2666,  2672,  2673,  2674,  2675,  2676,  2677,  2678,
    2679,  2680,  2681,  2682,  2683,  2685,  2686,  2687,  2688,  2689,
    2690,  2691,  2692,  2693,  2694,  2695,  2696,  2697,  2698,  2699,
    2700,  2701,  2703,  2705,  2706,  2707,  2708,  2709,  2712,  2730,
    2731,  2732,  2735,  2736,  2737,  2738,  2739,  2740,  2741,  2742,
    2743,  2744,  2745,  2746,  2747,  2748,  2749,  2750,  2751,  2752,
    2753,  2754,  2755,  2756,  2757,  2758,  2759,  2760,  2761,  2762,
    2763,  2764,  2765,  2766,  2767,  2768,  2769,  2777,  2785,  2793,
    2801,  2809,  2817,  2825,  2833,  2841,  2842,  2844,  2852,  2860,
    2868,  2877,  2886,  2895,  2903,  2912,  2920,  2921,  2923,  2924,
    2925,  2926,  2927,  2928,  2929,  2930,  2931,  2932,  2933,  2934,
    2935,  2936,  2937,  2938,  2939,  2942,  2943,  2944,  2945,  2952,
    2959,  2960,  2966,  2973,  2974,  2980,  2987,  2988,  2994,  2997,
    3000,  3001,  3002,  3005,  3006,  3007,  3016,  3017,  3018,  3019,
    3020,  3021,  3022,  3023,  3024,  3025,  3026,  3027,  3028,  3029,
    3030,  3031,  3032,  3033,  3041,  3042,  3043,  3044,  3045,  3046,
    3047,  3048,  3049,  3050,  3051,  3052,  3053,  3054,  3055,  3056,
    3057,  3058,  3059,  3060,  3061,  3062,  3063,  3064,  3065,  3066,
    3067,  3068,  3076,  3084,  3092,  3093,  3095,  3097,  3108,  3109,
    3110,  3126,  3127,  3128,  3132,  3135,  3136,  3139,  3142,  3145,
    3148,  3151,  3154,  3157,  3160,  3160,  3205,  3207,  3209,  3210,
    3211,  3214,  3225,  3237,  3241,  3245,  3249,  3253,  3257,  3261,
    3265,  3269,  3273
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "FORWARD", "FORWARD_TCP", "FORWARD_TLS",
  "FORWARD_SCTP", "FORWARD_UDP", "SEND", "SEND_TCP", "EXIT", "DROP",
  "RETURN", "BREAK", "LOG_TOK", "ERROR", "ROUTE", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_BRANCH", "ROUTE_SEND", "ROUTE_EVENT", "EXEC",
  "SET_HOST", "SET_HOSTPORT", "SET_HOSTPORTTRANS", "PREFIX", "STRIP",
  "STRIP_TAIL", "SET_USERPHONE", "APPEND_BRANCH", "SET_USER",
  "SET_USERPASS", "SET_PORT", "SET_URI", "REVERT_URI", "FORCE_RPORT",
  "ADD_LOCAL_RPORT", "FORCE_TCP_ALIAS", "UDP_MTU", "UDP_MTU_TRY_PROTO",
  "IF", "ELSE", "SET_ADV_ADDRESS", "SET_ADV_PORT", "FORCE_SEND_SOCKET",
  "SET_FWD_NO_CONNECT", "SET_RPL_NO_CONNECT", "SET_FWD_CLOSE",
  "SET_RPL_CLOSE", "SWITCH", "CASE", "DEFAULT", "WHILE", "URIHOST",
  "URIPORT", "MAX_LEN", "SETFLAG", "RESETFLAG", "ISFLAGSET", "SETAVPFLAG",
  "RESETAVPFLAG", "ISAVPFLAGSET", "METHOD", "URI", "FROM_URI", "TO_URI",
  "SRCIP", "SRCPORT", "DSTIP", "DSTPORT", "TOIP", "TOPORT", "SNDIP",
  "SNDPORT", "SNDPROTO", "SNDAF", "PROTO", "AF", "MYSELF", "MSGLEN", "UDP",
  "TCP", "TLS", "SCTP", "DEBUG_V", "FORK", "LOGSTDERROR", "LOGFACILITY",
  "LOGNAME", "LISTEN", "ALIAS", "SR_AUTO_ALIASES", "DNS", "REV_DNS",
  "DNS_TRY_IPV6", "DNS_TRY_NAPTR", "DNS_SRV_LB", "DNS_UDP_PREF",
  "DNS_TCP_PREF", "DNS_TLS_PREF", "DNS_SCTP_PREF", "DNS_RETR_TIME",
  "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH", "DNS_SEARCH_FMATCH",
  "DNS_CACHE_INIT", "DNS_USE_CACHE", "DNS_USE_FAILOVER", "DNS_CACHE_FLAGS",
  "DNS_CACHE_NEG_TTL", "DNS_CACHE_MIN_TTL", "DNS_CACHE_MAX_TTL",
  "DNS_CACHE_MEM", "DNS_CACHE_GC_INT", "DNS_CACHE_DEL_NONEXP",
  "DST_BLST_INIT", "USE_DST_BLST", "DST_BLST_MEM", "DST_BLST_TTL",
  "DST_BLST_GC_INT", "PORT", "STAT", "CHILDREN", "CHECK_VIA", "PHONE2TEL",
  "SYN_BRANCH", "MEMLOG", "MEMDBG", "MEMSUM", "SIP_WARNING",
  "SERVER_SIGNATURE", "SERVER_HEADER", "USER_AGENT_HEADER", "REPLY_TO_VIA",
  "LOADMODULE", "LOADPATH", "MODPARAM", "MAXBUFFER", "USER", "GROUP",
  "CHROOT", "WDIR", "MHOMED", "DISABLE_TCP", "TCP_ACCEPT_ALIASES",
  "TCP_CHILDREN", "TCP_CONNECT_TIMEOUT", "TCP_SEND_TIMEOUT",
  "TCP_CON_LIFETIME", "TCP_POLL_METHOD", "TCP_MAX_CONNECTIONS",
  "TCP_NO_CONNECT", "TCP_SOURCE_IPV4", "TCP_SOURCE_IPV6",
  "TCP_OPT_FD_CACHE", "TCP_OPT_BUF_WRITE", "TCP_OPT_CONN_WQ_MAX",
  "TCP_OPT_WQ_MAX", "TCP_OPT_RD_BUF", "TCP_OPT_WQ_BLK",
  "TCP_OPT_DEFER_ACCEPT", "TCP_OPT_DELAYED_ACK", "TCP_OPT_SYNCNT",
  "TCP_OPT_LINGER2", "TCP_OPT_KEEPALIVE", "TCP_OPT_KEEPIDLE",
  "TCP_OPT_KEEPINTVL", "TCP_OPT_KEEPCNT", "TCP_OPT_CRLF_PING",
  "DISABLE_TLS", "ENABLE_TLS", "TLSLOG", "TLS_PORT_NO", "TLS_METHOD",
  "TLS_HANDSHAKE_TIMEOUT", "TLS_SEND_TIMEOUT", "SSLv23", "SSLv2", "SSLv3",
  "TLSv1", "TLS_VERIFY", "TLS_REQUIRE_CERTIFICATE", "TLS_CERTIFICATE",
  "TLS_PRIVATE_KEY", "TLS_CA_LIST", "DISABLE_SCTP", "ENABLE_SCTP",
  "SCTP_CHILDREN", "SCTP_SOCKET_RCVBUF", "SCTP_SOCKET_SNDBUF",
  "SCTP_AUTOCLOSE", "SCTP_SEND_TTL", "SCTP_SEND_RETRIES",
  "SCTP_ASSOC_TRACKING", "SCTP_ASSOC_REUSE", "SCTP_MAX_ASSOCS",
  "SCTP_SRTO_INITIAL", "SCTP_SRTO_MAX", "SCTP_SRTO_MIN", "SCTP_ASOCMAXRXT",
  "SCTP_INIT_MAX_ATTEMPTS", "SCTP_INIT_MAX_TIMEO", "SCTP_HBINTERVAL",
  "SCTP_PATHMAXRXT", "SCTP_SACK_DELAY", "SCTP_SACK_FREQ", "SCTP_MAX_BURST",
  "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE", "OPEN_FD_LIMIT",
  "SHM_MEM_SZ", "SHM_FORCE_ALLOC", "MLOCK_PAGES", "REAL_TIME", "RT_PRIO",
  "RT_POLICY", "RT_TIMER1_PRIO", "RT_TIMER1_POLICY", "RT_TIMER2_PRIO",
  "RT_TIMER2_POLICY", "MCAST_LOOPBACK", "MCAST_TTL", "TOS",
  "PMTU_DISCOVERY", "KILL_TIMEOUT", "MAX_WLOOPS", "CFG_DESCRIPTION",
  "SERVER_ID", "FLAGS_DECL", "AVPFLAGS_DECL", "ATTR_MARK", "SELECT_MARK",
  "ATTR_FROM", "ATTR_TO", "ATTR_FROMURI", "ATTR_TOURI", "ATTR_FROMUSER",
  "ATTR_TOUSER", "ATTR_FROMDOMAIN", "ATTR_TODOMAIN", "ATTR_GLOBAL",
  "ADDEQ", "STUN_REFRESH_INTERVAL", "STUN_ALLOW_STUN", "STUN_ALLOW_FP",
  "EQUAL", "LOG_OR", "LOG_AND", "BIN_OR", "BIN_AND", "STRDIFF", "STREQ",
  "INTDIFF", "INTEQ", "MATCH", "DIFF", "EQUAL_T", "LTE", "GTE", "LT", "GT",
  "MINUS", "PLUS", "MODULO", "SLASH", "STAR", "UNARY", "NOT", "DEFINED",
  "STRCAST", "INTCAST", "DOT", "STRLEN", "STREMPTY", "NUMBER", "ID",
  "NUM_ID", "STRING", "IPV6ADDR", "PVAR", "AVP_OR_PVAR", "EVENT_RT_NAME",
  "COMMA", "SEMICOLON", "RPAREN", "LPAREN", "LBRACE", "RBRACE", "LBRACK",
  "RBRACK", "CR", "COLON", "$accept", "cfg", "statements", "statement",
  "$@1", "$@2", "$@3", "$@4", "$@5", "$@6", "listen_id", "listen_id_lst",
  "listen_id2", "proto", "port", "phostport", "listen_phostport", "id_lst",
  "intno", "flags_decl", "flag_list", "flag_spec", "flag_name",
  "avpflags_decl", "avpflag_list", "avpflag_spec", "assign_stm",
  "cfg_var_id", "cfg_var", "module_stm", "ip", "ipv4", "ipv6addr", "ipv6",
  "route_name", "route_stm", "failure_route_stm", "onreply_route_stm",
  "branch_route_stm", "send_route_stm", "event_route_stm", "equalop",
  "cmpop", "strop", "rve_equalop", "rve_cmpop", "uri_type",
  "eint_op_onsend", "eint_op", "eip_op_onsend", "eip_op", "exp_elem",
  "ipnet", "host", "host_if_id", "host_or_if", "fcmd", "stm", "actions",
  "action", "if_cmd", "ct_rval", "single_case", "case_stms", "switch_cmd",
  "while_cmd", "select_param", "select_params", "select_id", "$@7",
  "attr_class_spec", "attr_name_spec", "attr_spec", "attr_mark", "attr_id",
  "attr_id_num_idx", "attr_id_no_idx", "attr_id_ass", "attr_id_any",
  "attr_id_any_str", "pvar", "avp_pvar", "assign_op", "lval", "rval",
  "rve_un_op", "rval_expr", "assign_action", "avpflag_oper", "cmd", "$@8",
  "func_params", "func_param", "ret_cmd", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   295,   296,   297,   297,   297,   298,   298,   298,   298,
     299,   298,   300,   298,   301,   298,   302,   298,   303,   298,
     304,   298,   298,   298,   305,   305,   305,   306,   306,   307,
     307,   308,   308,   308,   308,   308,   309,   309,   310,   310,
     310,   310,   310,   311,   311,   311,   311,   311,   312,   312,
     313,   313,   314,   314,   315,   315,   316,   316,   317,   317,
     318,   318,   319,   319,   320,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   322,   322,   323,   323,   323,   323,   323,   324,   324,
     324,   324,   324,   324,   324,   324,   324,   325,   325,   326,
     327,   328,   328,   329,   329,   329,   330,   330,   330,   331,
     331,   331,   332,   332,   332,   333,   333,   333,   334,   334,
     334,   335,   335,   336,   336,   336,   336,   337,   337,   337,
     337,   338,   338,   339,   339,   339,   339,   339,   339,   339,
     340,   340,   340,   340,   341,   341,   341,   342,   342,   342,
     343,   343,   343,   343,   343,   344,   344,   345,   345,   345,
     346,   346,   346,   346,   346,   346,   346,   346,   346,   346,
     346,   346,   346,   346,   346,   346,   346,   346,   346,   346,
     346,   346,   346,   346,   346,   346,   346,   346,   346,   347,
     347,   347,   347,   348,   348,   348,   348,   348,   349,   349,
     349,   350,   350,   350,   350,   350,   351,   352,   352,   353,
     353,   353,   354,   354,   354,   354,   354,   354,   354,   354,
     355,   355,   356,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   358,   358,   359,   359,   359,   359,
     360,   361,   361,   361,   362,   362,   364,   363,   365,   365,
     365,   365,   365,   365,   365,   365,   365,   366,   367,   367,
     368,   369,   370,   371,   372,   372,   373,   373,   373,   374,
     374,   374,   375,   376,   377,   378,   378,   378,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     380,   380,   381,   381,   381,   381,   381,   381,   381,   381,
     381,   381,   381,   381,   381,   381,   381,   381,   381,   381,
     381,   381,   381,   381,   381,   381,   381,   381,   381,   381,
     381,   381,   381,   381,   381,   381,   381,   381,   382,   383,
     383,   383,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   385,   384,   384,   386,   386,   386,
     386,   387,   387,   388,   388,   388,   388,   388,   388,   388,
     388,   388,   388
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     5,     3,     1,     3,     3,     5,     3,     1,     2,
       1,     2,     2,     2,     1,     3,     1,     3,     1,     1,
       2,     2,     1,     3,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       2,     1,     1,     5,     5,     7,     7,     5,     2,     2,
       2,     2,     3,     3,     8,     8,     2,     1,     1,     7,
       1,     1,     3,     1,     1,     1,     4,     7,     2,     4,
       7,     2,     4,     7,     2,     4,     7,     2,     4,     7,
       2,     7,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     2,     3,     3,     3,     2,     3,     3,
       3,     3,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     3,     3,     2,     3,
       3,     1,     3,     1,     3,     3,     3,     3,     1,     1,
       1,     1,     3,     3,     3,     3,     1,     1,     3,     2,
       1,     2,     2,     1,     1,     1,     2,     2,     1,     2,
       3,     5,     1,     4,     5,     3,     4,     3,     2,     4,
       5,     3,     4,     4,     2,     1,     5,     4,     2,     5,
       3,     1,     4,     4,     3,     1,     0,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     2,     5,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       1,     1,     1,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     4,     4,
       2,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     4,     2,     3,     1,
       1,     1,     3,     4,     4,     4,     6,     6,     6,     6,
       6,     4,     2,     4,     4,     4,     4,     6,     6,     6,
       6,     6,     4,     2,     4,     4,     4,     4,     6,     6,
       6,     6,     6,     4,     2,     4,     4,     4,     4,     6,
       6,     6,     6,     6,     4,     2,     4,     4,     4,     4,
       6,     6,     6,     6,     6,     4,     2,     4,     4,     4,
       4,     6,     6,     6,     2,     4,     4,     4,     4,     6,
       6,     6,     2,     4,     4,     6,     2,     4,     4,     4,
       2,     4,     4,     2,     4,     4,     2,     6,     6,     6,
       4,     2,     6,     2,     4,     4,     2,     4,     4,     4,
       2,     4,     4,     2,     4,     4,     2,     4,     4,     2,
       4,     3,     2,     6,     4,     3,     1,     4,     2,     4,
       4,     2,     4,     4,     2,     4,     4,     2,     4,     4,
       2,     4,     4,     2,     4,     3,     1,     3,     1,     3,
       1,     4,     3,     1,     4,     4,     4,     4,     4,     2,
       4,     4,     2,     4,     4,     2,     3,     1,     3,     1,
       3,     1,     3,     1,     0,     5,     2,     0,     3,     1,
       2,     1,     1,     3,     2,     1,     3,     2,     1,     1,
       3,     2,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,   362,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   361,    22,    23,     0,     0,     4,     0,     0,
       0,     0,     0,     0,     7,     8,     6,     0,   359,     9,
     360,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    80,     0,    82,     0,    84,     0,
      86,     0,    88,     0,    90,     0,    92,     0,    94,     0,
      96,     0,    98,     0,   100,     0,   102,     0,   104,     0,
     106,     0,   108,     0,   110,     0,   112,     0,   116,     0,
     114,     0,   118,     0,   120,     0,   122,     0,   124,     0,
     126,     0,   128,     0,   130,     0,   132,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   369,   368,   371,     0,   370,   376,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   196,     0,
     198,     0,   200,     0,   202,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   341,     0,     0,     0,
       0,    53,    59,    58,    52,    54,    56,    61,    64,    60,
      62,     0,     0,     0,     1,     5,     3,     0,    11,     0,
      13,     0,    15,     0,    17,     0,    19,     0,    21,     0,
     356,   355,   354,   353,   358,    31,    32,    33,    34,    35,
     357,    66,     0,    50,    65,    68,    67,    70,    69,    72,
      71,    74,    73,   301,   480,   478,   479,    25,   380,     0,
       0,    30,    43,     0,    48,   300,    24,   377,   381,   378,
     481,    26,   303,   302,   305,   304,    76,    75,    78,    77,
      79,    81,    83,    85,    87,    89,    91,    93,    95,    97,
      99,   101,   103,   105,   107,   109,   111,   115,   113,   117,
     119,   121,   123,   125,   127,   129,   131,   137,   133,   134,
     139,   138,   141,   140,   143,   142,   145,   144,   147,   146,
     149,   148,   151,   150,   153,   152,   293,   292,   295,   294,
     297,   296,   299,   298,   373,   372,     0,   136,   135,   156,
     155,   154,   159,   158,   157,   162,   161,   160,   165,   164,
     163,   167,   166,   169,   168,   171,   170,   173,   172,   175,
     174,   177,   176,   179,   178,   182,   180,   181,   184,   183,
     186,   185,   188,     0,   187,   190,   189,   192,   191,   194,
     193,   195,   197,   199,   201,   204,   203,   206,   205,   208,
     207,   210,   209,   212,   211,   214,   213,   216,   215,   218,
     217,   220,   219,   222,   221,   224,   223,   226,   225,   228,
     227,   233,   229,   230,   231,   232,   245,   244,   247,   246,
     235,   234,   237,   236,   239,   238,   241,   240,   243,   242,
     249,   248,   251,   250,   253,   252,   255,   254,   257,   256,
     259,   258,   261,   260,   263,   262,   265,   264,   267,   266,
     269,   268,   271,   270,   273,   272,   275,   274,   277,   276,
     279,   278,   281,   280,   283,   282,   285,   284,   287,   286,
     289,   288,   291,   290,   307,   306,   309,   308,   311,   310,
     313,   312,   315,   314,   317,   316,   319,   318,   321,   320,
     323,   322,   325,   324,   327,   326,   329,   328,   331,   330,
     333,   332,   335,   334,   337,   336,   339,   338,   340,   343,
     342,   345,   344,   352,     0,     0,     0,   347,   346,   349,
     348,   351,   350,   388,     0,     0,   391,     0,     0,   394,
       0,     0,   397,     0,     0,   400,     0,     0,   402,     0,
       0,    51,     0,    27,     0,     0,     0,     0,    49,     0,
       0,     0,    55,    57,    63,     0,     0,     0,     0,     0,
       0,     0,   788,   785,   789,   792,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   726,     0,     0,
       0,     0,   746,   748,   750,   753,     0,     0,     0,     0,
       0,   767,   769,   771,   773,     0,     0,     0,     0,     0,
     609,   610,   611,   540,     0,   552,   553,   498,     0,     0,
     490,   493,   494,   495,     0,   544,   545,   555,   556,   557,
       0,     0,     0,   486,     0,   383,   384,   385,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    29,   382,    47,    37,    36,    44,    45,   485,   480,
     483,   484,   482,     0,   622,     0,   644,     0,   655,     0,
     666,     0,   633,     0,   674,     0,   682,     0,     0,   424,
     425,   426,   437,   430,   438,   431,   436,   428,   435,   427,
       0,   429,     0,   432,     0,   433,   526,   571,   570,     0,
       0,     0,     0,     0,   559,     0,     0,   558,     0,   434,
       0,   439,     0,   565,   564,   563,     0,   546,   548,   547,
     560,   561,   562,   572,     0,   787,     0,   784,     0,   791,
     686,     0,   703,     0,   706,     0,     0,   710,     0,   728,
       0,   731,     0,   713,     0,   719,     0,   716,     0,   722,
       0,     0,   737,     0,   740,     0,   734,     0,   743,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   762,
       0,   765,     0,     0,     0,     0,     0,   518,     0,     0,
     690,     0,   693,     0,   696,     0,   776,     0,   499,   492,
     491,   386,   489,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,     0,   538,   541,   554,     0,   497,   701,
       0,   496,     0,   389,     0,   392,     0,   395,     0,   398,
       0,     0,   367,   363,   364,     0,    28,     0,     0,     0,
       0,   473,     0,   612,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   443,   406,   405,   412,   404,   403,
     411,     0,     0,     0,   468,     0,     0,   607,   590,   593,
     575,   592,   574,     0,     0,     0,   786,   546,   547,   561,
     562,     0,     0,     0,     0,   447,     0,   452,   410,   409,
     408,   407,     0,     0,   464,     0,   541,   591,   573,     0,
       0,     0,     0,   418,   417,   416,   415,   419,   414,   413,
     423,   422,   421,   420,     0,     0,     0,     0,     0,     0,
       0,   783,   790,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   721,     0,   725,     0,     0,     0,     0,
       0,     0,     0,     0,   745,   747,   749,     0,     0,   752,
       0,     0,     0,   500,   487,     0,     0,     0,     0,     0,
      38,     0,     0,   766,   768,   770,   772,     0,   520,     0,
       0,     0,     0,     0,     0,   777,     0,     0,   608,     0,
     551,     0,   549,     0,   550,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    46,     0,     0,   623,     0,   621,
       0,   614,     0,   615,     0,     0,     0,   613,   645,     0,
     643,     0,   636,     0,   637,     0,   635,   656,     0,   654,
       0,   647,     0,   648,     0,   646,   667,     0,   665,     0,
     658,     0,   659,     0,   657,   634,     0,   632,     0,   625,
       0,   626,     0,   624,   675,     0,   669,     0,   670,     0,
     668,   683,     0,   677,     0,   678,     0,   676,   442,     0,
     440,   458,   456,   457,   455,   453,   454,   467,   465,   466,
     521,   525,   527,     0,     0,     0,     0,   569,   587,   568,
     567,   566,   446,     0,   444,   451,   449,   450,   448,   463,
       0,    50,     0,   471,   459,   461,   460,     0,   604,   586,
     603,   585,   599,   581,   600,   582,   595,   577,   594,   576,
     598,   580,   597,   579,   596,   578,   602,   584,   601,   583,
     687,     0,   684,   704,     0,   707,   705,   708,   711,   709,
     729,   727,   732,   730,   714,   712,   720,   718,   717,   715,
       0,   724,   738,   736,   741,   739,   735,   733,   744,   742,
     754,   751,   756,   755,     0,     0,   758,   757,   761,   760,
     764,     0,     0,   763,     0,     0,     0,   517,   515,     0,
     688,   689,   691,   692,   694,   695,   782,   781,     0,   779,
     539,   543,     0,   700,   541,     0,     0,     0,     0,     0,
       0,     0,   365,   366,     0,   374,   375,     0,     0,     0,
       0,   477,   475,   476,   474,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   605,   588,   606,   589,     0,     0,
       0,     0,     0,   488,   501,    42,    39,    40,   519,     0,
       0,     0,   502,   508,   516,   514,   780,     0,   775,     0,
       0,     0,   387,   390,   393,   396,   399,   401,   379,   619,
     620,   617,   618,   616,   641,   642,   639,   640,   638,   652,
     653,   650,   651,   649,   663,   664,   661,   662,   660,   630,
     631,   628,   629,   627,   672,   673,   671,   680,   681,   679,
       0,     0,   524,   472,   470,   469,   542,   685,   702,   723,
       0,   511,     0,     0,     0,     0,   778,   699,   698,   697,
     523,   522,    41,     0,   512,   506,   513,     0,     0,     0
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     411,   694,   412,   413,   796,  1122,   414,   415,   847,   164,
     354,   355,   356,   165,   359,   360,   166,   167,   168,   169,
     416,   417,   418,   419,   778,   368,   370,   372,   374,   376,
     378,  1010,  1043,  1011,  1069,  1070,   848,   849,   850,   851,
     852,   853,  1254,   975,   420,   421,   758,  1113,   759,   760,
     761,  1411,  1328,  1329,   762,   763,  1231,  1232,   855,  1016,
     943,   944,   945,   764,   765,   858,   766,   767,   860,  1143,
     768,   769,   947,   770,   863,   864,  1031,   771,   772,   773,
     927,  1338,  1339,   774
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -957
static const yytype_int16 yypact[] =
{
    2127,  -180,  -175,  -172,  -167,  -957,  -131,  -114,  -104,   -88,
     -64,   -59,   -58,   -51,   -47,   -46,    45,   501,   535,   576,
     577,   592,   614,   617,   633,   686,   742,   743,   760,   762,
     764,   765,   766,   785,   831,   840,   844,   847,   848,   857,
     873,   881,   886,   -43,   -28,   -27,   -23,   -20,   -16,   -13,
     -10,     6,    22,    28,    32,   328,   331,    89,   242,    39,
     343,   355,   371,   384,   385,   402,   423,   437,   447,   471,
     498,   507,   514,   521,   525,   531,   536,   537,   541,   903,
     905,   916,   918,   548,   551,   570,   579,   585,   615,   616,
     627,   628,   635,   636,   657,   687,   712,   735,   737,   739,
     741,   818,   839,   849,   865,   866,   868,   869,   888,   900,
     906,   922,   931,   935,   940,   945,   948,   956,   961,   964,
     969,   971,   972,   984,   993,   994,  1003,  1004,  1011,  1043,
    1047,  1051,  1052,  1062,  1082,  1084,  1085,  1086,  1087,  1089,
    1090,  1097,  1098,   919,  1100,  1101,  1102,   221,   240,  1104,
    1107,  1108,  -957,  -957,  -957,   210,  1433,  -957,   213,   197,
     750,   781,   852,   875,  -957,  -957,  -957,   640,  -957,  -957,
    -957,   108,   612,   669,   309,   613,   623,    41,   111,    21,
     174,   624,   625,   638,  -957,   644,  -957,   659,  -957,   661,
    -957,  -214,  -957,  -214,  -957,  -214,  -957,  -214,  -957,   662,
    -957,   682,  -957,   705,  -957,   809,  -957,   878,  -957,   892,
    -957,   947,  -957,  1019,  -957,  1034,  -957,  1076,  -957,  1080,
    -957,  1099,  -957,  1103,  -957,  1148,  -957,  1149,  -957,  1150,
    -957,  1151,  -957,  1152,  -957,  1153,  -957,  1154,   639,   684,
     646,   648,   650,   651,   429,   533,   552,   652,   653,   198,
     199,   654,  -957,  -957,  -957,   205,  -957,  -957,   958,   655,
     247,   263,   264,   274,   663,   664,   665,   666,   573,   574,
     582,   287,   667,   668,   672,     5,   673,   674,  -957,  1159,
    -957,  1160,  -957,  1161,  -957,  1162,   675,   676,   677,   678,
     679,   680,   685,   688,   689,   690,   691,   693,   695,  1134,
     696,   697,   698,   699,   215,   232,   235,   700,   701,   702,
     703,   704,   707,   709,   711,   715,   716,   583,   717,   719,
     720,   722,   724,   725,   593,   727,   729,   730,   732,    37,
     734,   738,   740,   755,   757,   758,   759,   780,   790,   801,
     807,   808,   812,   813,   814,   816,  -957,  1163,   821,   822,
    1166,  -957,  -957,  -957,  -957,  1073,  1088,  -957,  -957,  -957,
    1092,   825,   827,   829,  -957,  -180,  -957,    43,  -957,    51,
    -957,    55,  -957,    61,  -957,    77,  -957,    13,  -957,    -9,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  1167,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  1171,  -957,  -957,  -957,  -957,  1083,
    1165,  -957,  1147,  1168,  1063,  -957,  -957,  -957,  -957,  -957,
    -957,  -199,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  1093,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  1171,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -233,  1170,  -233,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  9953,  -113,  -957,  9953,  -113,  -957,
    9953,  -113,  -957,  9953,  -113,  -957,  9953,  -113,  -957,  1095,
    1133,  -957,  1178,  1172,  1169,  1156,   600,  1048,  -957,   260,
     436,  1179,  -957,  -957,  -957,    53,    65,    68,    79,    84,
      85,    86,  9003,  9081,  9181,  -957,    87,    96,    99,  1173,
     100,   105,   106,   112,   114,   115,   118,  1175,   121,   122,
     131,   132,  1176,  1177,  1182,  1183,  1186,  9468,   135,   138,
     139,  1187,  1188,  1189,  1190,  5269,  9468,   153,   155,   157,
    -957,  -957,  -957,  -957,   160,  -957,  -957,  -957,   109,  3045,
    -957,  -957,  -957,  -957,  1081,  -957,  -957,  -957,  -957,  -957,
    1210,  1174,   176,  -957,  1180,  -957,  -957,  -957,  1191,  3121,
    1192,  3195,  1214,  3333,  1215,  3409,  1216,  1217,   223,  1193,
    1083,  -957,  -957,  -957,  -957,  -957,  -957,  1185,  -957,  -957,
    -957,  -957,  -957,  1195,  -957,   169,  -957,   127,  -957,   144,
    -957,   206,  -957,   230,  -957,   330,  -957,   350,   932,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
     -50,  -957,   -50,  -957,   534,  -957,  -957,  1167,  -957,  5349,
    5447,  5736,  1194,  1222,  -957,  4513,  9893,  -957,   957,  -957,
     879,  -957,   968,  -957,  -957,  -957,  1081,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  5816,  1237,  4802,  1237,  4882,  1237,
    -957,   229,  -957,   248,  -957,   211,  1201,  -957,   249,  -957,
     286,  -957,   289,  -957,   291,  -957,   834,  -957,   835,  -957,
    1224,  -138,  -957,   302,  -957,   307,  -957,   310,  -957,   312,
    1225,  1226,  1227,     8,  1079,  5914,  9546,  -957,   281,  -957,
     838,  -957,   190,  1228,  1229,  1324,  1325,  -957,  1135,  9546,
    -957,   -38,  -957,   -33,  -957,     1,  -957,  1326,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  1339,  -957,  1371,  -957,  9468,  -957,  -957,
     233,  -957,  1377,  -957,  1378,  -957,  1379,  -957,  1380,  -957,
    1381,  1382,  -957,  1443,  1444,  1397,  -957,  -194,  -153,  1388,
    -196,  -957,  -116,  -957,   -34,  -156,  1389,   -19,   361,   442,
    -102,  1390,   460,   495,   520,   490,  1394,   586,   713,   895,
     949,  1395,   907,   915,   921,   975,  1416,   959,   960,   976,
    1417,  1000,  1001,  1020,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  6203,  4335,  4419,  -957,  1164,  1427,  -957,  -957,  -957,
    -957,  -957,  -957,  6283,  6381,  1419,  -957,  1459,  1460,  1461,
    1462,  1155,  1425,  1423,  3483,  -957,  6670,  -957,  -957,  -957,
    -957,  -957,  6750,  6848,  -957,  2403,  1424,  -957,  -957,  7137,
    7217,  7315,  7604,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  7684,  7782,  8071,  8151,  8249,  8538,
    8618,  -957,  -957,  1429,  1432,  1431,  1435,  1438,  1437,  1454,
    1455,  1456,  1457,  1458,  1476,  1479,  1488,  1489,  1491,  1492,
    1493,  1501,  1516,  -957,  1005,  -957,  1517,  1518,  1519,  1520,
    1538,  1541,  1550,  1551,  -957,  -957,  -957,  1553,  1554,  -957,
    1555,  1563,  9953,  1672,  -957,  1578,  1579,  1580,  1581,  1582,
    1426,  1593,  1603,  -957,  -957,  -957,  -957,    47,  -957,  1612,
    1613,  1615,  1616,  1617,  1663,  -139,  1673,  1660,  1237,  1021,
    -957,  1081,  -957,  1668,  -957,  9953,  9953,  9953,  9953,  9953,
    9953,  1674,  1675,  1682,  -957,  1671,  1676,  -957,   -40,  -957,
    1683,  -957,  1684,  -957,   162,   218,  1685,  -957,  -957,   -14,
    -957,  1687,  -957,  1688,  -957,  1689,  -957,  -957,     0,  -957,
    1690,  -957,  1691,  -957,  1692,  -957,  -957,   554,  -957,  1693,
    -957,  1694,  -957,  1695,  -957,  -957,   557,  -957,  1716,  -957,
    1717,  -957,  1718,  -957,  -957,  1719,  -957,  1720,  -957,  1721,
    -957,  -957,  1722,  -957,  1723,  -957,  1726,  -957,  -957,  1724,
    1105,  -957,  -957,  1105,  -957,  -957,  1105,  -957,  -957,  -957,
    1710,  -957,  1730,  1727,  1434,  1728,  1662,  -957,  -957,  -957,
    -957,  -957,  -957,  1786,  1105,  -957,  1105,  -957,   990,  -957,
    1848,  1171,  1015,  1738,  -957,  -197,  1105,  -213,  -957,  1930,
    -957,  1680,  -957,  2123,  -957,  2355,  -957,  -120,  -957,  -120,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  1105,  -957,   990,
    -957,  1679,  -957,  -957,  1729,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    1736,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  3545,  9606,  -957,  -957,  -957,  -957,
    -957,   601,  1083,  -957,  1731,  4980,  1714,  -957,  -957,   571,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,   195,  -957,
    -957,  -957,  -233,  -957,  -957,   290,  3621,  3697,  3833,  3909,
    3985,  4047,  -957,  -957,  1740,  -957,  -957,  1733,  1735,  1737,
    1739,  -957,  -957,  -957,  -957,  1741,  1742,  1743,  1744,  1745,
    1746,  1747,  1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,
    1776,  1778,  1779,  1780,  1783,  1784,  1787,  1789,  1790,  1791,
    1792,  1795,   -98,  1427,  -957,  -957,  -957,  -957,    52,  1793,
    1796,  1797,  1799,  -957,  -957,  -957,  -957,  1794,  -957,  1798,
    8716,  1800,  1237,  9953,  -957,  -957,  -957,  -139,  -957,  1802,
    1803,  1804,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,  -957,
    1801,  1825,  -957,  -957,  1171,  -957,  -957,  -957,  -957,  -957,
    -194,  9953,  1824,  1826,  2483,  2545,  -957,  -957,  -957,  -957,
    -957,  -957,  -957,  2695,  9953,  9953,  -957,  2833,  2907,  2983
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -957,  -957,  -957,  1867,  -957,  -957,  -957,  -957,  -957,  -957,
    -327,  1235,  1330,  -170,  -956,  -957,  -957,  -168,  -174,  -957,
    1463,  -957,  -147,  -957,  1421,  -957,  -957,  1750,  -957,  -957,
    -778,  1821,  1686,  1844,   500,  -957,  -957,  -957,  -957,  -957,
    -957,  -814,  -957,  -722,  -957,  -957,  1106,  -957,  -957,  -957,
    1109,  -957,  -957,   390,  -579,  -957,  -407,  -914,  -673,  -751,
    -957,   723,   793,  -957,  -957,  -957,   745,  -957,  -957,  -957,
    -957,   987,  -697,  -688,  -653,  -957,  -157,  -957,  -957,  -957,
      58,  -519,  -957,  -957,  -957,  -957,   107,  -731,  -957,  -957,
    -957,  -957,   708,  -957
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -775
static const yytype_int16 yytable[] =
{
     394,   358,   625,   390,   779,  1128,   525,   781,   932,  1107,
     783,  1154,   423,   785,   688,  1357,  1012,   433,  1013,   434,
    1015,   435,   403,   436,   856,   856,   856,   974,   932,   979,
     932,   984,   932,   989,   932,   994,  1042,   998,   624,  1002,
     257,  1366,   399,     5,   673,   352,   184,   353,  1324,   856,
     392,   392,   676,  1463,   804,  1371,   679,   856,   856,   857,
     857,   857,   682,   393,   393,   699,   806,  1164,   170,   808,
     469,   471,   473,   171,   794,   700,   172,  1165,   685,  1341,
     810,   173,   693,   795,   857,   812,   814,   816,   870,  1158,
     252,  1159,   857,   857,   510,   512,   514,   872,  1325,  1326,
     874,   877,   385,   386,   387,   388,   879,   881,  1164,   380,
     928,   392,   401,   883,  1032,   885,   887,   174,  1165,   889,
     800,   802,   892,   894,   393,   392,  1036,  1155,   976,  1166,
    1045,  1167,   896,   898,   175,  1032,   907,  1032,   393,   909,
     911,  1336,  1094,   601,   176,   981,  1066,  1067,  1068,  1095,
     615,   856,   856,   856,   920,  1114,   922,   856,   924,  1046,
     177,   926,  1164,  1361,   775,   776,   392,   777,  1114,  1160,
     969,  1161,  1165,  1034,  1032,   422,   856,   949,   856,   393,
     856,   977,  1460,  1175,   178,  1176,   857,   857,   857,   179,
     180,  1119,  1027,   862,   862,   862,  1416,   181,   982,   478,
     480,   182,   183,  1005,  1006,   238,   484,   986,  1008,  1009,
     364,   857,  1078,  1027,   369,  1027,   574,   856,   862,  1363,
     239,   240,   351,   970,   962,   241,   862,   862,   242,   367,
    1073,   991,   243,   576,  1139,   244,   578,  1358,   245,  1129,
     352,   357,   353,   254,  1131,   352,   698,   353,   489,  1076,
    1081,  1162,  1027,  1163,   246,   385,   386,   387,   388,   856,
     987,   798,  1141,  1367,   492,   495,  1169,  1253,  1170,   152,
     247,   385,   386,   387,   388,   498,   248,  1372,  1133,   352,
     249,   353,  1115,   932,   992,  1108,   408,  1083,   515,   389,
    1085,  1420,  1087,   185,   857,  1109,   410,  1142,   404,   405,
     406,   407,   408,  1096,   689,   854,   854,   854,  1098,   409,
     391,  1100,   410,  1102,   404,   405,   406,   407,   408,   400,
     862,   862,   862,   856,   856,   856,  1030,   258,   410,  1464,
     854,   996,   674,   408,   675,   856,   856,  1327,   854,   854,
     677,   805,   678,   410,   680,   862,   681,  1030,   856,  1030,
     683,  1000,   684,   807,   856,   856,   809,   856,   857,   857,
     857,   856,   856,   856,   856,  1406,   686,   811,   687,   253,
     857,   857,   813,   815,   817,   871,   856,   856,   856,   856,
     856,   856,   856,   857,   873,   381,  1030,   875,   878,   857,
     857,   402,   857,   880,   882,   929,   857,   857,   857,   857,
     884,  1404,   886,   888,   523,   971,   890,   978,   408,   893,
     895,   857,   857,   857,   857,   857,   857,   857,   410,   897,
     899,   523,   971,   908,   983,   408,   910,   912,   862,  1015,
     468,  1144,   854,   854,   854,   410,  1015,   801,   854,  1314,
    1362,   921,   389,   923,  1344,   925,   523,   971,  -774,   972,
     408,   404,   405,   406,   407,   408,   973,   854,   389,   854,
     410,   854,   409,   693,   950,   410,   753,   404,   405,   406,
     407,   408,  1346,  1347,  1348,  1349,  1350,  1351,   479,   481,
    1417,   410,  1418,   523,   971,   485,   988,   408,   775,   776,
     255,   777,   862,   862,   862,   575,  1364,   410,   854,   352,
     963,   353,   186,   964,   862,   862,  1074,   523,   971,  1075,
     993,   408,   577,  1140,  1482,   579,   756,   862,   352,   358,
     353,   410,   256,   862,   862,   490,   862,   491,  1077,  1082,
     862,   862,   862,   862,   470,  1014,   188,   799,   405,   406,
     854,   493,   496,   494,   497,   862,   862,   862,   862,   862,
     862,   862,   499,   472,   500,   859,   859,   859,   404,   405,
     406,   407,   408,   932,  1114,   516,  1084,   517,   352,  1086,
     353,  1088,   410,   392,   509,   511,   250,   190,   192,   251,
     859,  1116,  1097,   513,   600,  1120,   393,  1099,   859,   859,
    1101,   259,  1103,   194,   614,   932,   932,   932,   932,   932,
     932,   793,  1405,   260,   854,   854,   854,   523,   971,  1376,
     997,   408,  1381,   382,   395,   196,   854,   854,   198,   261,
    1465,   410,  1325,  1326,   397,   424,   426,   523,   971,   854,
    1001,   408,   262,   263,   200,   854,   854,   856,   854,   428,
     457,   410,   854,   854,   854,   854,  1171,   460,  1172,   462,
     264,   464,   466,   474,   476,   482,   487,   854,   854,   854,
     854,   854,   854,   854,   501,   503,   505,   507,   518,   520,
     384,   265,   857,   522,   527,   529,   535,   537,   539,   541,
     543,   545,   859,   859,   859,   266,   547,   202,  1028,   549,
     551,   553,   555,   392,   557,   267,   559,   566,   568,   570,
     572,   580,   582,   584,   586,   588,   393,   859,   590,  1028,
     592,  1028,   594,   799,   405,   406,   596,   598,   602,   268,
     604,   606,   856,   608,   932,   610,   612,  1173,   616,  1174,
     618,   620,   932,   622,  1111,   626,   932,   932,   932,   628,
    1475,   630,  1121,   204,   206,  1178,   269,  1179,  1028,   187,
     385,   386,   387,   388,  1164,   270,   632,   857,   634,   636,
     638,   208,   271,   210,  1165,   212,   214,   216,   371,   272,
     861,   861,   861,   273,  1130,  1184,  1132,  1185,  1134,   274,
    1180,   640,  1181,   189,   275,   276,   218,  1005,  1006,   277,
     859,   642,  1008,  1009,  1156,   861,   286,   392,  1483,   287,
     373,  1487,   644,   861,   861,  1182,   862,  1183,   646,   648,
     393,  1488,  1489,   650,   652,   654,   392,   656,   288,   865,
     867,   869,   659,   661,   191,   193,   667,   289,   669,   393,
     671,  1377,   220,   290,  1382,  1089,  1091,   392,   392,  1117,
     195,   222,  1222,  1225,   906,   224,   392,   392,   226,   228,
     393,   393,   918,   919,   859,   859,   859,   392,   230,   393,
     393,  1414,   197,   291,   292,   199,   859,   859,   794,   794,
     393,  1187,   375,  1188,   232,   293,   294,   795,   795,   859,
    1037,   201,   234,   295,   296,   859,   859,   236,   859,   383,
     396,   862,   859,   859,   859,   859,   377,   861,   861,   861,
     398,   425,   427,  1029,   278,   297,   280,   859,   859,   859,
     859,   859,   859,   859,   379,   429,   458,   282,   854,   284,
     346,   430,   861,   461,  1029,   463,  1029,   465,   467,   475,
     477,   483,   488,  1004,   203,   298,   431,   389,   432,   437,
     502,   504,   506,   508,   519,   521,  1018,  1020,  1022,   523,
     528,   530,   536,   538,   540,   542,   544,   546,  1035,   438,
     299,  1337,   548,  1029,   459,   550,   552,   554,   556,  1044,
     558,  1048,   560,   567,   569,   571,   573,   581,   583,   585,
     587,   589,   439,   300,   591,   301,   593,   302,   595,   303,
     205,   207,   597,   599,   603,  1407,   605,   607,  1189,   609,
    1190,   611,   613,   854,   617,   861,   619,   621,   209,   623,
     211,   627,   213,   215,   217,   629,   926,   631,  -473,  -473,
    -473,  -473,  -473,  -473,  -473,  -473,  -473,  -473,  -473,  -473,
    -473,  -473,   633,   219,   635,   637,   639,  -473,  -473,  -473,
    -473,  -473,  -473,  -473,  -473,  -473,  -473,  -473,  -473,  -473,
    -473,  -473,  -473,  -473,  1138,  -473,  -473,   641,  -473,  -473,
    -473,  -473,  -473,  -473,  -473,  -473,   304,   643,  -473,   861,
     861,   861,  -473,  -473,  -473,  -473,  -473,  -473,   645,   221,
    1110,   861,   861,  1399,   647,   649,   440,   305,   223,   651,
     653,   655,   225,   657,   861,   227,   229,   306,   660,   662,
     861,   861,   668,   861,   670,   231,   672,   861,   861,   861,
     861,  1090,  1092,   307,   308,  1118,   309,   310,  1220,  1223,
    1226,   233,   861,   861,   861,   861,   861,   861,   861,   235,
    1234,  1236,  1005,  1006,   237,   561,   311,  1008,  1009,  1038,
    1039,  1040,  1041,  1244,   385,   386,   387,   388,   312,  1246,
    1248,   279,  1256,   281,   313,   441,  1259,  1261,  1263,  1265,
     385,   386,   387,   388,   283,  1227,   285,   347,   859,   442,
     314,  1267,  1269,  1271,  1273,  1275,  1277,  1279,   780,   315,
    1191,   782,  1192,   316,   784,  1005,  1006,   786,   317,  1007,
    1008,  1009,  1196,   318,  1197,  1419,   319,   980,  1421,   985,
    1198,   990,  1199,   995,   320,   999,  1200,  1003,  1201,   321,
    1005,  1006,   322,  1164,  1007,  1008,  1009,   323,  1461,   324,
     325,  1005,  1006,  1165,   443,  1007,  1008,  1009,   819,   820,
     821,   822,   326,   824,  1193,   826,  1194,   828,   486,  1164,
    1164,   327,   328,  1337,  1205,  1207,  1206,  1208,  -473,  1165,
    1165,   329,   330,   859,  1064,  1065,  1066,  1067,  1068,   331,
    1202,  1209,  1203,  1210,  -473,  -473,  -473,  -473,  -473,  -473,
    -473,  -473,  -473,  -473,  -473,  -473,  -473,  -473,  -473,  -473,
    -473,  -473,  -473,  -473,  1164,  1212,  1214,  1213,  1215,  -473,
    1300,   332,  1301,  -473,  1165,   333,   444,  -473,  -473,   334,
     335,  -473,  -473,  -774,  -473,  1216,  1342,  1217,  1343,  -473,
     336,   445,   562,   563,   564,   565,   933,   934,   935,   936,
     937,   938,   939,   940,   941,   404,   405,   406,   407,   408,
     337,   389,   338,   339,   340,   341,   409,   342,   343,   410,
     404,   405,   406,   407,   408,   344,   345,   389,   348,   349,
     350,   409,   361,   446,   410,   362,   363,   447,   664,   942,
     404,   405,   406,   407,   408,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,   410,  1079,   448,   666,   701,   787,
     449,   788,   665,   861,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1127,   450,   451,   452,   453,   454,
     455,   456,  1412,    -2,   365,  1255,   531,   532,   533,   534,
     658,   696,  1238,   663,   691,   692,   408,   703,   792,   -10,
     -12,   -14,   -16,   -18,   -20,   789,   791,   790,   946,   803,
     948,   876,   697,   891,   900,   901,   951,   965,   861,     2,
     902,   903,     3,     4,   904,   913,   914,   915,   916,   967,
     968,  1080,  1023,   952,   954,     5,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,   956,   958,   960,   961,
    1024,  1093,  1104,  1105,  1106,  1123,  1124,  1412,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,  1125,  1126,  1136,  1135,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,  1137,   146,   147,   148,  1145,  1146,  1147,  1148,
    1149,  1150,  1151,  1152,  1153,  1157,  1168,  1177,   149,   150,
     151,  1186,  1195,  1049,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,
    1066,  1067,  1068,  1204,  1211,  1230,  1237,  -544,  -545,  -556,
    -557,   152,  1239,  1240,  1315,  1257,  1280,  1281,  1282,   153,
    1321,  1395,  1283,  1284,  1285,   926,   154,  -441,  -441,  -441,
    -441,  -441,  -441,  -441,  -441,  -441,  -441,  -441,  -441,  -441,
    -441,  1286,  1287,  1288,  1289,  1290,  -441,  -441,  -441,  -441,
    -441,  -441,  -441,  -441,  -441,  -441,  -441,  -441,  -441,  -441,
    -441,  -441,  -441,  1291,  -441,  -441,  1292,  -441,  -441,  -441,
    -441,  -441,  -441,  -441,  -441,  1293,  1294,  -441,  1295,  1296,
    1297,  -441,  -441,  -441,  -441,  -441,  -441,  1014,  1298,  -445,
    -445,  -445,  -445,  -445,  -445,  -445,  -445,  -445,  -445,  -445,
    -445,  -445,  -445,  1299,  1302,  1303,  1304,  1305,  -445,  -445,
    -445,  -445,  -445,  -445,  -445,  -445,  -445,  -445,  -445,  -445,
    -445,  -445,  -445,  -445,  -445,  1306,  -445,  -445,  1307,  -445,
    -445,  -445,  -445,  -445,  -445,  -445,  -445,  1308,  1309,  -445,
    1310,  1311,  1312,  -445,  -445,  -445,  -445,  -445,  -445,  1014,
    1313,  -462,  -462,  -462,  -462,  -462,  -462,  -462,  -462,  -462,
    -462,  -462,  -462,  -462,  -462,  1316,  1317,  1318,  1319,  1320,
    -462,  -462,  -462,  -462,  -462,  -462,  -462,  -462,  -462,  -462,
    -462,  -462,  -462,  -462,  -462,  -462,  -462,  1322,  -462,  -462,
    1323,  -462,  -462,  -462,  -462,  -462,  -462,  -462,  -462,  1330,
    1331,  -462,  1332,  1333,  1334,  -462,  -462,  -462,  -462,  -462,
    -462,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
    1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,
    1068,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1397,
    1335,   942,  1341,  1345,  1352,  1353,  1354,  -441,  1355,  1400,
    1359,  1360,  1365,  1356,  1368,  1369,  1370,  1373,  1374,  1375,
    1378,  1379,  1380,  -441,  -441,  -441,  -441,  -441,  -441,  -441,
    -441,  -441,  -441,  -441,  -441,  -441,  -441,  -441,  -441,  -441,
    -441,  -441,  -441,  1383,  1384,  1385,  1386,  1387,  1388,  1389,
    1390,  1392,  -441,  1391,  1393,  1398,  -441,  -441,  1413,  1401,
    -441,  -441,  -774,  -441,  1394,  1396,  1402,  1428,  -441,  -445,
    1429,  1408,  1430,   366,  1431,   966,  1432,   797,  1433,  1434,
    1435,  1436,  1437,  1438,  1439,  -445,  -445,  -445,  -445,  -445,
    -445,  -445,  -445,  -445,  -445,  -445,  -445,  -445,  -445,  -445,
    -445,  -445,  -445,  -445,  -445,  1440,  1441,  1442,  1443,  1444,
    1445,  1446,  1447,  1448,  -445,  1449,  1450,  1451,  -445,  -445,
    1452,  1453,  -445,  -445,  1454,  -445,  1455,  1456,  1457,  1458,
    -445,  -462,  1459,  1467,  1468,  1466,  1469,   704,  1470,  1477,
    1478,  1479,  1471,  1480,  1474,   524,   695,  -462,  -462,  -462,
    -462,  -462,  -462,  -462,  -462,  -462,  -462,  -462,  -462,  -462,
    -462,  -462,  -462,  -462,  -462,  -462,  -462,  1481,  1484,   526,
    1485,  1228,  1415,  1340,  1229,  1476,  -462,   702,     1,   690,
    -462,  -462,     0,  1473,  -462,  -462,     0,  -462,  1462,     0,
       0,     0,  -462,   -10,   -12,   -14,   -16,   -18,   -20,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     2,     0,     0,     3,     4,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     5,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,     0,     0,     0,     0,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,     0,   146,   147,   148,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   149,   150,   151,  1052,  1053,  1054,  1055,  1056,
    1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
    1067,  1068,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1249,   152,   705,   706,   707,   708,
     709,   710,   711,   153,     0,     0,     0,   716,   717,   718,
     154,     0,     0,     0,     0,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,     0,   736,     0,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,     0,     0,     0,     0,     0,
     747,   748,   749,   750,   751,   752,   818,   819,   820,   821,
     822,   823,   824,   825,   826,   827,   828,   829,   830,   831,
     832,   833,  1250,   835,  1486,     0,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
       0,     0,     0,     0,     0,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,     0,   736,   737,     0,   738,   739,   740,   741,
     742,   743,   744,   745,  -505,  -505,   746,     0,     0,     0,
     747,   748,   749,   750,   751,   752,   930,     0,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,     0,     0,     0,     0,     0,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,     0,   736,   737,     0,   738,   739,
     740,   741,   742,   743,   744,   745,  -507,  -507,   746,     0,
       0,     0,   747,   748,   749,   750,   751,   752,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   753,   836,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   837,     0,     0,
       0,     0,     0,   838,   839,   840,   841,     0,   842,   843,
    1251,  1252,     0,   844,   408,   755,   756,     0,     0,     0,
       0,   905,   846,     0,   410,     0,   930,     0,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,     0,     0,     0,     0,   753,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,     0,   736,   737,     0,   738,   739,
     740,   741,   742,   743,   744,   745,  -509,  -509,   746,     0,
       0,     0,   747,   748,   749,   750,   751,   752,     0,     0,
       0,   754,     0,     0,     0,   755,   756,     0,     0,   757,
       0,     0,     0,  -505,     0,     0,     0,     0,   753,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   754,     0,     0,     0,   755,   756,     0,
       0,   757,     0,     0,   930,  -507,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
       0,     0,     0,     0,     0,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,     0,   736,   737,     0,   738,   739,   740,   741,
     742,   743,   744,   745,  -503,  -503,   746,     0,     0,     0,
     747,   748,   749,   750,   751,   752,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   930,     0,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,     0,     0,     0,     0,   753,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,     0,   736,   737,     0,
     738,   739,   740,   741,   742,   743,   744,   745,  -510,  -510,
     746,     0,     0,     0,   747,   748,   749,   750,   751,   752,
       0,     0,     0,   754,     0,     0,     0,   755,   756,     0,
       0,   757,     0,     0,   930,  -509,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
       0,     0,     0,     0,     0,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,     0,   736,   737,     0,   738,   739,   740,   741,
     742,   743,   744,   745,  -504,  -504,   746,     0,     0,     0,
     747,   748,   749,   750,   751,   752,   930,     0,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,     0,     0,     0,     0,   753,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,     0,   736,   737,     0,   738,   739,
     740,   741,   742,   743,   744,   745,     0,     0,   746,     0,
       0,     0,   747,   748,   749,   750,   751,   752,     0,     0,
       0,   754,     0,     0,     0,   755,   756,     0,     0,   757,
       0,     0,   930,  -503,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,     0,     0,
     753,     0,     0,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
       0,   736,   737,     0,   738,   739,   740,   741,   742,   743,
     744,   745,     0,     0,   746,     0,     0,     0,   747,   748,
     749,   750,   751,   752,     0,   754,     0,     0,     0,   755,
     756,     0,     0,   757,     0,     0,   930,  -510,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,     0,     0,     0,     0,   753,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,     0,   736,   737,     0,   738,   739,
     740,   741,   742,   743,   744,   745,     0,     0,   746,     0,
       0,     0,   747,   748,   749,   750,   751,   752,     0,     0,
       0,   754,     0,     0,     0,   755,   756,     0,     0,   757,
       0,     0,     0,  -504,     0,     0,     0,     0,   753,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   754,     0,     0,     0,   755,   756,     0,
       0,   757,     0,     0,   930,   931,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
       0,     0,     0,     0,   753,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,     0,   736,   737,     0,   738,   739,   740,   741,
     742,   743,   744,   745,     0,     0,   746,     0,     0,     0,
     747,   748,   749,   750,   751,   752,     0,     0,     0,   754,
       0,     0,     0,   755,   756,     0,     0,   757,     0,     0,
     930,   953,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,     0,     0,   753,     0,
       0,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,     0,   736,
     737,     0,   738,   739,   740,   741,   742,   743,   744,   745,
       0,     0,   746,     0,     0,     0,   747,   748,   749,   750,
     751,   752,     0,   754,     0,     0,     0,   755,   756,     0,
       0,   757,     0,     0,   930,   955,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
       0,     0,     0,     0,     0,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,     0,   736,   737,     0,   738,   739,   740,   741,
     742,   743,   744,   745,     0,     0,   746,     0,     0,     0,
     747,   748,   749,   750,   751,   752,   930,     0,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,     0,     0,     0,     0,   753,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,     0,   736,   737,     0,   738,   739,
     740,   741,   742,   743,   744,   745,     0,     0,   746,     0,
       0,     0,   747,   748,   749,   750,   751,   752,     0,     0,
       0,   754,     0,     0,     0,   755,   756,     0,     0,   757,
       0,     0,   930,   957,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,     0,     0,
       0,     0,   753,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
       0,   736,   737,     0,   738,   739,   740,   741,   742,   743,
     744,   745,     0,     0,   746,     0,     0,     0,   747,   748,
     749,   750,   751,   752,     0,     0,     0,   754,     0,     0,
       0,   755,   756,     0,     0,   757,     0,     0,   930,   959,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,     0,     0,   753,     0,     0,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,     0,   736,   737,     0,
     738,   739,   740,   741,   742,   743,   744,   745,     0,     0,
     746,     0,     0,     0,   747,   748,   749,   750,   751,   752,
       0,   754,     0,     0,     0,   755,   756,     0,     0,   757,
       0,     0,     0,  1241,     0,     0,     0,     0,   753,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   754,     0,     0,     0,   755,   756,     0,
       0,   757,     0,     0,   930,  1403,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
       0,     0,     0,     0,   753,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,     0,   736,   737,     0,   738,   739,   740,   741,
     742,   743,   744,   745,     0,     0,   746,     0,     0,     0,
     747,   748,   749,   750,   751,   752,     0,     0,     0,   754,
       0,     0,     0,   755,   756,     0,     0,   757,     0,     0,
     930,  1422,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,     0,     0,     0,     0,
     753,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,     0,   736,
     737,     0,   738,   739,   740,   741,   742,   743,   744,   745,
       0,     0,   746,     0,     0,     0,   747,   748,   749,   750,
     751,   752,     0,     0,     0,   754,     0,     0,     0,   755,
     756,     0,     0,   757,     0,     0,   930,  1423,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,     0,     0,     0,     0,     0,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,     0,   736,   737,     0,   738,   739,
     740,   741,   742,   743,   744,   745,     0,     0,   746,     0,
       0,     0,   747,   748,   749,   750,   751,   752,   930,     0,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,     0,     0,   753,     0,     0,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,     0,   736,   737,     0,
     738,   739,   740,   741,   742,   743,   744,   745,     0,     0,
     746,     0,     0,     0,   747,   748,   749,   750,   751,   752,
       0,   754,     0,     0,     0,   755,   756,     0,     0,   757,
       0,     0,     0,  1424,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   753,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   754,     0,     0,
       0,   755,   756,     0,     0,   757,     0,     0,     0,  1425,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   753,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   754,     0,     0,     0,   755,   756,     0,
       0,   757,     0,     0,     0,  1426,     0,     0,     0,     0,
     753,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   754,     0,     0,     0,   755,
     756,     0,     0,   757,     0,     0,  1221,  1427,   705,   706,
     707,   708,   709,   710,   711,     0,     0,     0,     0,   716,
     717,   718,     0,     0,     0,     0,     0,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,     0,   736,     0,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,     0,     0,     0,
       0,     0,   747,   748,   749,   750,   751,   752,   818,   819,
     820,   821,   822,   823,   824,   825,   826,   827,   828,   829,
     830,   831,   832,   833,   834,   835,   385,   386,   387,   388,
    1224,     0,   705,   706,   707,   708,   709,   710,   711,     0,
       0,     0,     0,   716,   717,   718,     0,     0,     0,     0,
       0,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,     0,   736,
       0,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,     0,     0,     0,     0,     0,   747,   748,   749,   750,
     751,   752,   818,   819,   820,   821,   822,   823,   824,   825,
     826,   827,   828,   829,   830,   831,   832,   833,   834,   835,
     385,   386,   387,   388,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1025,     0,   705,   706,   707,   708,
     709,   710,   711,     0,     0,     0,     0,   716,   717,   718,
       0,     0,     0,     0,     0,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,     0,   736,     0,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,     0,     0,     0,   753,   836,
     747,   748,   749,   750,   751,   752,   818,   819,   820,   821,
     822,   823,   824,   825,   826,   827,   828,   829,   830,   831,
     832,   833,   834,   835,     0,     0,     0,     0,     0,   837,
       0,     0,     0,   389,     0,   838,   839,   840,   841,     0,
     842,   843,   393,   754,     0,   844,     0,   755,   756,     0,
       0,     0,     0,   905,   846,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   753,   836,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   837,     0,     0,     0,   389,     0,   838,
     839,   840,   841,     0,   842,   843,   393,   754,     0,   844,
       0,   755,   756,     0,     0,     0,     0,   905,   846,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   753,   836,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   837,     0,     0,
       0,     0,     0,   838,   839,   840,   841,     0,   842,   843,
     393,   754,     0,   844,     0,   755,   756,     0,     0,     0,
    1026,   905,   846,  1025,     0,   705,   706,   707,   708,   709,
     710,   711,     0,     0,     0,     0,   716,   717,   718,     0,
       0,     0,     0,     0,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,     0,   736,     0,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,     0,     0,     0,     0,     0,   747,
     748,   749,   750,   751,   752,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,  1025,     0,   705,   706,   707,   708,   709,
     710,   711,     0,     0,     0,     0,   716,   717,   718,     0,
       0,     0,     0,     0,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,     0,   736,     0,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,     0,     0,     0,     0,     0,   747,
     748,   749,   750,   751,   752,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1409,     0,   705,   706,   707,   708,   709,   710,   711,
       0,     0,     0,     0,   716,   717,   718,     0,     0,     0,
       0,     0,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,     0,
     736,     0,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,     0,     0,     0,   753,   836,   747,   748,   749,
     750,   751,   752,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   832,   833,   834,
     835,     0,     0,     0,     0,     0,   837,     0,     0,     0,
       0,     0,   838,   839,   840,   841,     0,   842,   843,   393,
     754,     0,   844,     0,   755,   756,     0,     0,     0,  1071,
     905,   846,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   753,   836,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   837,     0,     0,     0,
       0,     0,   838,   839,   840,   841,     0,   842,   843,   393,
     754,     0,   844,     0,   755,   756,     0,     0,     0,  1072,
     905,   846,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   753,   836,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   837,     0,     0,  1410,     0,     0,
     838,   839,   840,   841,     0,   842,   843,   393,   754,     0,
     844,     0,   755,   756,     0,     0,     0,     0,   905,   846,
     917,     0,   705,   706,   707,   708,   709,   710,   711,     0,
       0,     0,     0,   716,   717,   718,     0,     0,     0,     0,
       0,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,     0,   736,
       0,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,     0,     0,     0,     0,     0,   747,   748,   749,   750,
     751,   752,   818,   819,   820,   821,   822,   823,   824,   825,
     826,   827,   828,   829,   830,   831,   832,   833,   834,   835,
    1017,     0,   705,   706,   707,   708,   709,   710,   711,     0,
       0,     0,     0,   716,   717,   718,     0,     0,     0,     0,
       0,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,     0,   736,
       0,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,     0,     0,     0,     0,     0,   747,   748,   749,   750,
     751,   752,   818,   819,   820,   821,   822,   823,   824,   825,
     826,   827,   828,   829,   830,   831,   832,   833,   834,   835,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1019,     0,
     705,   706,   707,   708,   709,   710,   711,     0,     0,     0,
       0,   716,   717,   718,     0,     0,     0,     0,     0,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,     0,   736,     0,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,     0,
       0,     0,   753,   836,   747,   748,   749,   750,   751,   752,
     818,   819,   820,   821,   822,   823,   824,   825,   826,   827,
     828,   829,   830,   831,   832,   833,   834,   835,     0,     0,
       0,     0,     0,   837,     0,     0,     0,     0,     0,   838,
     839,   840,   841,     0,   842,   843,   393,   754,     0,   844,
       0,   755,   756,     0,     0,     0,     0,   905,   846,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   753,   836,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   837,     0,     0,     0,     0,     0,   838,
     839,   840,   841,     0,   842,   843,   393,   754,     0,   844,
       0,   755,   756,     0,     0,     0,     0,   905,   846,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     753,   836,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   837,     0,     0,     0,     0,     0,   838,   839,   840,
     841,     0,   842,   843,   393,   754,     0,   844,     0,   755,
     756,     0,     0,     0,     0,   905,   846,  1021,     0,   705,
     706,   707,   708,   709,   710,   711,     0,     0,     0,     0,
     716,   717,   718,     0,     0,     0,     0,     0,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,     0,   736,     0,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,     0,     0,
       0,     0,     0,   747,   748,   749,   750,   751,   752,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,  1047,     0,   705,
     706,   707,   708,   709,   710,   711,     0,     0,     0,     0,
     716,   717,   718,     0,     0,     0,     0,     0,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,     0,   736,     0,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,     0,     0,
       0,     0,     0,   747,   748,   749,   750,   751,   752,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1025,     0,   705,   706,   707,
     708,   709,   710,   711,     0,     0,     0,     0,   716,   717,
     718,     0,     0,     0,     0,     0,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,     0,   736,     0,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,     0,     0,     0,   753,
     836,   747,   748,   749,   750,   751,   752,   818,   819,   820,
     821,   822,   823,   824,   825,   826,   827,   828,   829,   830,
     831,   832,   833,   834,   835,     0,     0,     0,     0,     0,
     837,     0,     0,     0,     0,     0,   838,   839,   840,   841,
       0,   842,   843,   393,   754,     0,   844,     0,   755,   756,
       0,     0,     0,     0,   905,   846,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   753,
     836,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     837,     0,     0,     0,     0,     0,   838,   839,   840,   841,
       0,   842,   843,   393,   754,     0,   844,     0,   755,   756,
       0,     0,     0,     0,   905,   846,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   753,   836,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   837,     0,
       0,     0,     0,     0,   838,   839,   840,   841,     0,   842,
     843,   393,   754,     0,   844,     0,   755,   756,     0,     0,
       0,     0,   905,   846,  1218,     0,   705,   706,   707,   708,
     709,   710,   711,     0,     0,     0,     0,   716,   717,   718,
       0,     0,     0,     0,     0,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,     0,   736,     0,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,     0,     0,     0,     0,     0,
     747,   748,   749,   750,   751,   752,   818,   819,   820,   821,
     822,   823,   824,   825,   826,   827,   828,   829,   830,   831,
     832,   833,   834,   835,  1233,     0,   705,   706,   707,   708,
     709,   710,   711,     0,     0,     0,     0,   716,   717,   718,
       0,     0,     0,     0,     0,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,     0,   736,     0,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,     0,     0,     0,     0,     0,
     747,   748,   749,   750,   751,   752,   818,   819,   820,   821,
     822,   823,   824,   825,   826,   827,   828,   829,   830,   831,
     832,   833,   834,   835,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1235,     0,   705,   706,   707,   708,   709,   710,
     711,     0,     0,     0,     0,   716,   717,   718,     0,     0,
       0,     0,     0,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
       0,   736,     0,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,     0,     0,     0,   753,   836,   747,   748,
     749,   750,   751,   752,   818,   819,   820,   821,   822,   823,
     824,   825,   826,   827,   828,   829,   830,   831,   832,   833,
     834,   835,     0,     0,     0,     0,     0,   837,     0,     0,
       0,     0,     0,   838,   839,   840,   841,     0,   842,   843,
     393,  1219,     0,   844,     0,   755,   756,     0,     0,     0,
       0,   905,   846,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   753,   836,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   837,     0,     0,
       0,     0,     0,   838,   839,   840,   841,     0,   842,   843,
     393,   754,     0,   844,     0,   755,   756,     0,     0,     0,
       0,   905,   846,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   753,   836,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   837,     0,     0,     0,     0,
       0,   838,   839,   840,   841,     0,   842,   843,   393,   754,
       0,   844,     0,   755,   756,     0,     0,     0,     0,   905,
     846,  1242,     0,   705,   706,   707,   708,   709,   710,   711,
       0,     0,     0,     0,   716,   717,   718,     0,     0,     0,
       0,     0,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,     0,
     736,     0,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,     0,     0,     0,     0,     0,   747,   748,   749,
     750,   751,   752,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   832,   833,  1243,
     835,  1245,     0,   705,   706,   707,   708,   709,   710,   711,
       0,     0,     0,     0,   716,   717,   718,     0,     0,     0,
       0,     0,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,     0,
     736,     0,     0,   738,   739,   740,   741,   742,   743,   744,
       0,     0,     0,     0,     0,     0,     0,   747,   748,   749,
     750,   751,   752,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   832,   833,   834,
     835,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1247,
       0,   705,   706,   707,   708,   709,   710,   711,     0,     0,
       0,     0,   716,   717,   718,     0,     0,     0,     0,     0,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,     0,   736,     0,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
       0,     0,     0,   753,   836,   747,   748,   749,   750,   751,
     752,   818,   819,   820,   821,   822,   823,   824,   825,   826,
     827,   828,   829,   830,   831,   832,   833,   834,   835,     0,
       0,     0,     0,     0,   837,     0,     0,     0,     0,     0,
     838,   839,   840,   841,     0,   842,   843,   393,   754,     0,
     844,     0,   755,   756,     0,     0,     0,     0,   905,   846,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   753,   836,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   837,     0,     0,     0,     0,     0,
     838,   839,   840,   841,     0,   842,   843,   393,   754,     0,
     844,     0,   755,   756,     0,     0,     0,     0,   905,   846,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   753,   836,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   837,     0,     0,     0,     0,     0,   838,   839,
     840,   841,     0,   842,   843,   393,   754,     0,   844,     0,
     755,   756,     0,     0,     0,     0,   905,   846,  1258,     0,
     705,   706,   707,   708,   709,   710,   711,     0,     0,     0,
       0,   716,   717,   718,     0,     0,     0,     0,     0,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,     0,   736,     0,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,     0,
       0,     0,     0,     0,   747,   748,   749,   750,   751,   752,
     818,   819,   820,   821,   822,   823,   824,   825,   826,   827,
     828,   829,   830,   831,   832,   833,   834,   835,  1260,     0,
     705,   706,   707,   708,   709,   710,   711,     0,     0,     0,
       0,   716,   717,   718,     0,     0,     0,     0,     0,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,     0,   736,     0,     0,
     738,   739,   740,   741,   742,   743,   744,     0,     0,     0,
       0,     0,     0,     0,   747,   748,   749,   750,   751,   752,
     818,   819,   820,   821,   822,   823,   824,   825,   826,   827,
     828,   829,   830,   831,   832,   833,   834,   835,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1262,     0,   705,   706,
     707,   708,   709,   710,   711,     0,     0,     0,     0,   716,
     717,   718,     0,     0,     0,     0,     0,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,     0,   736,     0,     0,   738,   739,
     740,   741,   742,   743,   744,     0,     0,     0,     0,     0,
     753,   836,   747,   748,   749,   750,   751,   752,   818,   819,
     820,   821,   822,   823,   824,   825,   826,   827,   828,   829,
     830,   831,   832,   833,   834,   835,     0,     0,     0,     0,
       0,   837,     0,     0,     0,     0,     0,   838,   839,   840,
     841,     0,   842,   843,   393,   754,     0,   844,     0,   755,
     756,     0,     0,     0,     0,   905,   846,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     753,   836,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   837,     0,     0,     0,     0,     0,   838,   839,   840,
     841,     0,   842,   843,   393,   754,     0,   844,     0,   755,
     756,     0,     0,     0,     0,   905,   846,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   753,   836,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   837,
       0,     0,     0,     0,     0,   838,   839,   840,   841,     0,
     842,   843,   393,   754,     0,   844,     0,   755,   756,     0,
       0,     0,     0,   905,   846,  1264,     0,   705,   706,   707,
     708,   709,   710,   711,     0,     0,     0,     0,   716,   717,
     718,     0,     0,     0,     0,     0,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,     0,   736,     0,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,     0,     0,     0,     0,
       0,   747,   748,   749,   750,   751,   752,   818,   819,   820,
     821,   822,   823,   824,   825,   826,   827,   828,   829,   830,
     831,   832,   833,   834,   835,  1266,     0,   705,   706,   707,
     708,   709,   710,   711,     0,     0,     0,     0,   716,   717,
     718,     0,     0,     0,     0,     0,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,     0,   736,     0,     0,   738,   739,   740,
     741,   742,   743,   744,     0,     0,     0,     0,     0,     0,
       0,   747,   748,   749,   750,   751,   752,   818,   819,   820,
     821,   822,   823,   824,   825,   826,   827,   828,   829,   830,
     831,   832,   833,   834,   835,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1268,     0,   705,   706,   707,   708,   709,
     710,   711,     0,     0,     0,     0,   716,   717,   718,     0,
       0,     0,     0,     0,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,     0,   736,     0,     0,   738,   739,   740,   741,   742,
     743,   744,     0,     0,     0,     0,     0,   753,   836,   747,
     748,   749,   750,   751,   752,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,     0,     0,     0,     0,     0,   837,     0,
       0,     0,     0,     0,   838,   839,   840,   841,     0,   842,
     843,   393,   754,     0,   844,     0,   755,   756,     0,     0,
       0,     0,   905,   846,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   753,   836,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   837,     0,
       0,     0,     0,     0,   838,   839,   840,   841,     0,   842,
     843,   393,   754,     0,   844,     0,   755,   756,     0,     0,
       0,     0,   905,   846,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   753,   836,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   837,     0,     0,     0,
       0,     0,   838,   839,   840,   841,     0,   842,   843,   393,
     754,     0,   844,     0,   755,   756,     0,     0,     0,     0,
     905,   846,  1270,     0,   705,   706,   707,   708,   709,   710,
     711,     0,     0,     0,     0,   716,   717,   718,     0,     0,
       0,     0,     0,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
       0,   736,     0,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,     0,     0,     0,     0,     0,   747,   748,
     749,   750,   751,   752,   818,   819,   820,   821,   822,   823,
     824,   825,   826,   827,   828,   829,   830,   831,   832,   833,
     834,   835,  1272,     0,   705,   706,   707,   708,   709,   710,
     711,     0,     0,     0,     0,   716,   717,   718,     0,     0,
       0,     0,     0,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
       0,   736,     0,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,     0,     0,     0,     0,     0,   747,   748,
     749,   750,   751,   752,   818,   819,   820,   821,   822,   823,
     824,   825,   826,   827,   828,   829,   830,   831,   832,   833,
     834,   835,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1274,     0,   705,   706,   707,   708,   709,   710,   711,     0,
       0,     0,     0,   716,   717,   718,     0,     0,     0,     0,
       0,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,     0,   736,
       0,     0,   738,   739,   740,   741,   742,   743,   744,     0,
       0,     0,     0,     0,   753,   836,   747,   748,   749,   750,
     751,   752,   818,   819,   820,   821,   822,   823,   824,   825,
     826,   827,   828,   829,   830,   831,   832,   833,   834,   835,
       0,     0,     0,     0,     0,   837,     0,     0,     0,     0,
       0,   838,   839,   840,   841,     0,   842,   843,   393,   754,
       0,   844,     0,   755,   756,     0,     0,     0,     0,   905,
     846,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   753,   836,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   837,     0,     0,     0,     0,
       0,   838,   839,   840,   841,     0,   842,   843,   393,   754,
       0,   844,     0,   755,   756,     0,     0,     0,     0,   905,
     846,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   753,   836,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   837,     0,     0,     0,     0,     0,   838,
     839,   840,   841,     0,   842,   843,   393,   754,     0,   844,
       0,   755,   756,     0,     0,     0,     0,   905,   846,  1276,
       0,   705,   706,   707,   708,   709,   710,   711,     0,     0,
       0,     0,   716,   717,   718,     0,     0,     0,     0,     0,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,     0,   736,     0,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
       0,     0,     0,     0,     0,   747,   748,   749,   750,   751,
     752,   818,   819,   820,   821,   822,   823,   824,   825,   826,
     827,   828,   829,   830,   831,   832,   833,   834,   835,  1278,
       0,   705,   706,   707,   708,   709,   710,   711,     0,     0,
       0,     0,   716,   717,   718,     0,     0,     0,     0,     0,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,     0,   736,     0,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
       0,     0,     0,     0,     0,   747,   748,   749,   750,   751,
     752,   818,   819,   820,   821,   822,   823,   824,   825,   826,
     827,   828,   829,   830,   831,   832,   833,   834,   835,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1472,     0,   705,
     706,   707,   708,   709,   710,   711,     0,     0,     0,     0,
     716,   717,   718,     0,     0,     0,     0,     0,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,     0,   736,     0,     0,   738,
     739,   740,   741,   742,   743,   744,     0,     0,     0,     0,
       0,   753,   836,   747,   748,   749,   750,   751,   752,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,     0,     0,     0,
       0,     0,   837,     0,     0,     0,     0,     0,   838,   839,
     840,   841,     0,   842,   843,   393,   754,     0,   844,     0,
     755,   756,     0,     0,     0,     0,   905,   846,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   753,   836,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   837,     0,     0,     0,     0,     0,   838,   839,
     840,   841,     0,   842,   843,   393,   754,     0,   844,     0,
     755,   756,     0,     0,     0,     0,   905,   846,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   753,
     836,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     837,     0,     0,     0,     0,     0,   838,   839,   840,   841,
       0,   842,   843,   393,   754,     0,   844,     0,   755,   756,
       0,     0,     0,     0,   905,   846,   705,   706,   707,   708,
     709,   710,   711,     0,     0,     0,     0,   716,   717,   718,
       0,     0,     0,     0,     0,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,     0,   736,     0,     0,   738,   739,   740,   741,
     742,   743,   744,     0,     0,     0,     0,     0,     0,     0,
     747,   748,   749,   750,   751,   752,   818,   819,   820,   821,
     822,   823,   824,   825,   826,   827,   828,   829,   830,   831,
     832,   833,   834,   835,   705,   706,   707,   708,   709,   710,
     711,     0,     0,     0,     0,   716,   717,   718,     0,     0,
       0,     0,     0,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
       0,   736,     0,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,     0,     0,     0,     0,     0,   747,   748,
     749,   750,   751,   752,   818,   819,   820,   821,   822,   823,
     824,   825,   826,   827,   828,   829,   830,   831,   832,   833,
     834,   835,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   705,   706,   707,   708,   709,   710,
     711,     0,     0,     0,     0,   716,   717,   718,     0,     0,
       0,     0,     0,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
       0,   736,     0,     0,   738,   739,   740,   741,   742,   743,
     744,     0,     0,     0,     0,     0,   753,   836,   747,   748,
     749,   750,   751,   752,   818,   819,   820,   821,   822,   823,
     824,   825,   826,   827,   828,   829,   830,   831,   832,   833,
     834,   835,     0,     0,     0,     0,     0,   837,     0,     0,
       0,     0,     0,   838,   839,   840,   841,     0,   842,   843,
     393,   754,     0,   844,     0,   755,   756,     0,     0,     0,
       0,   845,   846,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   753,   836,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   837,     0,     0,     0,     0,
       0,   838,   839,   840,   841,     0,   842,   843,   393,   754,
       0,   844,     0,   755,   756,     0,     0,     0,     0,   866,
     846,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   753,   836,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   837,     0,     0,     0,     0,
       0,   838,   839,   840,   841,     0,   842,   843,   393,   754,
       0,   844,     0,   755,   756,     0,     0,     0,     0,   868,
     846,   705,   706,   707,   708,   709,   710,   711,     0,     0,
       0,     0,   716,   717,   718,     0,     0,     0,     0,     0,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,     0,   736,     0,
       0,   738,   739,   740,   741,   742,   743,   744,     0,     0,
       0,     0,     0,     0,     0,   747,   748,   749,   750,   751,
     752,   818,   819,   820,   821,   822,   823,   824,   825,   826,
     827,   828,   829,   830,   831,   832,   833,   834,   835,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,     0,     0,     0,     0,     0,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,     0,   736,   737,     0,   738,
     739,   740,   741,   742,   743,   744,   745,     0,     0,   746,
       0,     0,     0,   747,   748,   749,   750,   751,   752,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,     0,     0,     0,     0,     0,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,     0,   736,   737,     0,   738,
     739,   740,   741,   742,   743,   744,   745,     0,     0,   746,
       0,     0,     0,   747,   748,   749,   750,   751,   752,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   753,   836,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   837,     0,     0,     0,     0,     0,   838,   839,
     840,   841,     0,   842,   843,   393,   754,     0,   844,     0,
     755,   756,     0,     0,     0,     0,   905,   846,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   753,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1049,  1050,  1051,  1052,  1053,
    1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,
    1064,  1065,  1066,  1067,  1068,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   754,     0,     0,     0,   755,   756,
       0,     0,   757,     0,     0,  1112,     0,     0,     0,   753,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   754,     0,     0,     0,   755,   756,
       0,     0,   757,     0,  1033,  1112,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
       0,     0,     0,     0,     0,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,     0,   736,   737,     0,   738,   739,   740,   741,
     742,   743,   744,   745,     0,     0,   746,     0,     0,     0,
     747,   748,   749,   750,   751,   752,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
       0,     0,     0,     0,     0,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,     0,   736,   737,     0,   738,   739,   740,   741,
     742,   743,   744,   745,     0,     0,   746,     0,     0,     0,
     747,   748,   749,   750,   751,   752,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   753,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   754,     0,     0,     0,   755,   756,     0,     0,   757,
       0,     0,     0,     0,     0,     0,   753,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   754,     0,     0,     0,   755,   756,     0,     0,   757
};

static const yytype_int16 yycheck[] =
{
     174,   148,   329,   173,   677,   919,     1,   680,   759,     1,
     683,   967,   180,   686,     1,    55,   830,   191,   832,   193,
     834,   195,     1,   197,   712,   713,   714,   805,   779,   807,
     781,   809,   783,   811,   785,   813,   850,   815,     1,   817,
       1,    55,     1,    52,     1,   278,     1,   280,     1,   737,
     264,   264,     1,     1,     1,    55,     1,   745,   746,   712,
     713,   714,     1,   277,   277,   264,     1,   264,   248,     1,
     244,   245,   246,   248,   268,   274,   248,   274,     1,   292,
       1,   248,   409,   277,   737,     1,     1,     1,     1,   285,
       1,   287,   745,   746,   268,   269,   270,     1,    51,    52,
       1,     1,    81,    82,    83,    84,     1,     1,   264,     1,
       1,   264,     1,     1,   845,     1,     1,   248,   274,     1,
     699,   700,     1,     1,   277,   264,   848,   280,     1,   285,
     852,   287,     1,     1,   248,   866,     1,   868,   277,     1,
       1,   280,   280,   317,   248,     1,   266,   267,   268,   287,
     324,   839,   840,   841,     1,   906,     1,   845,     1,   856,
     248,     1,   264,     1,   277,   278,   264,   280,   919,   285,
       1,   287,   274,   846,   905,     1,   864,     1,   866,   277,
     868,    54,   280,   285,   248,   287,   839,   840,   841,   248,
     248,     1,   845,   712,   713,   714,     1,   248,    54,     1,
       1,   248,   248,   253,   254,   248,     1,     1,   258,   259,
       0,   864,     1,   866,    17,   868,     1,   905,   737,     1,
     248,   248,     1,    54,     1,   248,   745,   746,   248,    16,
       1,     1,   248,     1,     1,   248,     1,   277,   248,   277,
     278,     1,   280,     1,   277,   278,   414,   280,     1,     1,
       1,   285,   905,   287,   248,    81,    82,    83,    84,   947,
      54,     1,   950,   277,     1,     1,   285,  1045,   287,   278,
     248,    81,    82,    83,    84,     1,   248,   277,   277,   278,
     248,   280,     1,  1034,    54,   277,   281,     1,     1,   268,
       1,     1,     1,   248,   947,   287,   291,   950,   277,   278,
     279,   280,   281,     1,   291,   712,   713,   714,     1,   288,
       1,     1,   291,     1,   277,   278,   279,   280,   281,   278,
     839,   840,   841,  1011,  1012,  1013,   845,   288,   291,   277,
     737,     1,   289,   281,   291,  1023,  1024,   290,   745,   746,
     289,   288,   291,   291,   289,   864,   291,   866,  1036,   868,
     289,     1,   291,   288,  1042,  1043,   288,  1045,  1011,  1012,
    1013,  1049,  1050,  1051,  1052,  1321,   289,   288,   291,   280,
    1023,  1024,   288,   288,   288,   288,  1064,  1065,  1066,  1067,
    1068,  1069,  1070,  1036,   288,   277,   905,   288,   288,  1042,
    1043,   280,  1045,   288,   288,   286,  1049,  1050,  1051,  1052,
     288,  1315,   288,   288,   277,   278,   288,   280,   281,   288,
     288,  1064,  1065,  1066,  1067,  1068,  1069,  1070,   291,   288,
     288,   277,   278,   288,   280,   281,   288,   288,   947,  1243,
       1,   950,   839,   840,   841,   291,  1250,     1,   845,  1112,
     278,   288,   268,   288,  1141,   288,   277,   278,   288,   280,
     281,   277,   278,   279,   280,   281,   287,   864,   268,   866,
     291,   868,   288,   790,   288,   291,   233,   277,   278,   279,
     280,   281,  1145,  1146,  1147,  1148,  1149,  1150,   280,   280,
     285,   291,   287,   277,   278,   280,   280,   281,   277,   278,
     248,   280,  1011,  1012,  1013,   280,   278,   291,   905,   278,
     277,   280,     1,   280,  1023,  1024,   277,   277,   278,   280,
     280,   281,   280,   280,  1470,   280,   283,  1036,   278,   666,
     280,   291,   280,  1042,  1043,   278,  1045,   280,   280,   280,
    1049,  1050,  1051,  1052,     1,     1,     1,   277,   278,   279,
     947,   278,   278,   280,   280,  1064,  1065,  1066,  1067,  1068,
    1069,  1070,   278,     1,   280,   712,   713,   714,   277,   278,
     279,   280,   281,  1314,  1315,   278,   280,   280,   278,   280,
     280,   280,   291,   264,     1,     1,   248,     1,     1,   248,
     737,   908,   280,     1,     1,   912,   277,   280,   745,   746,
     280,   248,   280,     1,     1,  1346,  1347,  1348,  1349,  1350,
    1351,     1,     1,   248,  1011,  1012,  1013,   277,   278,    55,
     280,   281,    55,     1,     1,     1,  1023,  1024,     1,   248,
    1398,   291,    51,    52,     1,     1,     1,   277,   278,  1036,
     280,   281,   248,   248,     1,  1042,  1043,  1325,  1045,     1,
       1,   291,  1049,  1050,  1051,  1052,   285,     1,   287,     1,
     248,     1,     1,     1,     1,     1,     1,  1064,  1065,  1066,
    1067,  1068,  1069,  1070,     1,     1,     1,     1,     1,     1,
       1,   248,  1325,     1,     1,     1,     1,     1,     1,     1,
       1,     1,   839,   840,   841,   248,     1,     1,   845,     1,
       1,     1,     1,   264,     1,   248,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,   277,   864,     1,   866,
       1,   868,     1,   277,   278,   279,     1,     1,     1,   248,
       1,     1,  1410,     1,  1475,     1,     1,   285,     1,   287,
       1,     1,  1483,     1,   904,     1,  1487,  1488,  1489,     1,
    1413,     1,   912,     1,     1,   285,   248,   287,   905,   248,
      81,    82,    83,    84,   264,   248,     1,  1410,     1,     1,
       1,     1,   248,     1,   274,     1,     1,     1,    18,   248,
     712,   713,   714,   248,   921,   285,   923,   287,   925,   248,
     285,     1,   287,   248,   248,   248,     1,   253,   254,   248,
     947,     1,   258,   259,   968,   737,   248,   264,  1471,   248,
      19,  1474,     1,   745,   746,   285,  1325,   287,     1,     1,
     277,  1484,  1485,     1,     1,     1,   264,     1,   248,   712,
     713,   714,     1,     1,   248,   248,     1,   248,     1,   277,
       1,   277,     1,   248,   277,     1,     1,   264,   264,     1,
     248,     1,  1012,  1013,   737,     1,   264,   264,     1,     1,
     277,   277,   745,   746,  1011,  1012,  1013,   264,     1,   277,
     277,   290,   248,   248,   248,   248,  1023,  1024,   268,   268,
     277,   285,    20,   287,     1,   248,   248,   277,   277,  1036,
       1,   248,     1,   248,   248,  1042,  1043,     1,  1045,   277,
     277,  1410,  1049,  1050,  1051,  1052,    21,   839,   840,   841,
     277,   277,   277,   845,     1,   248,     1,  1064,  1065,  1066,
    1067,  1068,  1069,  1070,   274,   277,   277,     1,  1325,     1,
       1,   277,   864,   277,   866,   277,   868,   277,   277,   277,
     277,   277,   277,     1,   248,   248,   277,   268,   277,   277,
     277,   277,   277,   277,   277,   277,   839,   840,   841,   277,
     277,   277,   277,   277,   277,   277,   277,   277,     1,   277,
     248,  1135,   277,   905,   280,   277,   277,   277,   277,     1,
     277,   864,   277,   277,   277,   277,   277,   277,   277,   277,
     277,   277,   277,   248,   277,   248,   277,   248,   277,   248,
     248,   248,   277,   277,   277,  1322,   277,   277,   285,   277,
     287,   277,   277,  1410,   277,   947,   277,   277,   248,   277,
     248,   277,   248,   248,   248,   277,     1,   277,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,   277,   248,   277,   277,   277,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,   947,    40,    41,   277,    43,    44,
      45,    46,    47,    48,    49,    50,   248,   277,    53,  1011,
    1012,  1013,    57,    58,    59,    60,    61,    62,   277,   248,
       1,  1023,  1024,  1257,   277,   277,   277,   248,   248,   277,
     277,   277,   248,   277,  1036,   248,   248,   248,   277,   277,
    1042,  1043,   277,  1045,   277,   248,   277,  1049,  1050,  1051,
    1052,   277,   277,   248,   248,   277,   248,   248,  1011,  1012,
    1013,   248,  1064,  1065,  1066,  1067,  1068,  1069,  1070,   248,
    1023,  1024,   253,   254,   248,     1,   248,   258,   259,   260,
     261,   262,   263,  1036,    81,    82,    83,    84,   248,  1042,
    1043,   248,  1045,   248,   248,   277,  1049,  1050,  1051,  1052,
      81,    82,    83,    84,   248,     1,   248,   248,  1325,   277,
     248,  1064,  1065,  1066,  1067,  1068,  1069,  1070,   678,   248,
     285,   681,   287,   248,   684,   253,   254,   687,   248,   257,
     258,   259,   285,   248,   287,  1342,   248,   807,  1345,   809,
     285,   811,   287,   813,   248,   815,   285,   817,   287,   248,
     253,   254,   248,   264,   257,   258,   259,   248,  1392,   248,
     248,   253,   254,   274,   277,   257,   258,   259,    64,    65,
      66,    67,   248,    69,   285,    71,   287,    73,   280,   264,
     264,   248,   248,  1417,   285,   285,   287,   287,   233,   274,
     274,   248,   248,  1410,   264,   265,   266,   267,   268,   248,
     285,   285,   287,   287,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   264,   285,   285,   287,   287,   274,
     285,   248,   287,   278,   274,   248,   277,   282,   283,   248,
     248,   286,   287,   288,   289,   285,   285,   287,   287,   294,
     248,   277,   178,   179,   180,   181,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   277,   278,   279,   280,   281,
     248,   268,   248,   248,   248,   248,   288,   248,   248,   291,
     277,   278,   279,   280,   281,   248,   248,   268,   248,   248,
     248,   288,   248,   277,   291,   248,   248,   277,   285,   278,
     277,   278,   279,   280,   281,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   291,   875,   277,   285,   285,   284,
     277,   248,   294,  1325,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   289,   277,   277,   277,   277,   277,
     277,   277,  1325,     0,     1,  1045,   277,   277,   277,   277,
     277,   294,   287,   277,   277,   274,   281,   277,   292,    16,
      17,    18,    19,    20,    21,   277,   287,   285,   248,   280,
     286,   288,   294,   288,   288,   288,   286,   274,  1410,    36,
     288,   288,    39,    40,   288,   288,   288,   288,   288,   294,
     285,   280,   288,   292,   292,    52,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   292,   292,   292,   292,
     288,   287,   287,   287,   287,   287,   287,  1410,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   287,   287,   274,   288,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   291,   230,   231,   232,   289,   289,   289,   289,
     289,   289,   229,   229,   277,   287,   287,   287,   245,   246,
     247,   287,   287,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   287,   287,   278,   287,   248,   248,   248,
     248,   278,   287,   290,    42,   291,   287,   285,   287,   286,
     294,   287,   287,   285,   287,     1,   293,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,   287,   287,   287,   287,   287,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,   287,    40,    41,   287,    43,    44,    45,
      46,    47,    48,    49,    50,   287,   287,    53,   287,   287,
     287,    57,    58,    59,    60,    61,    62,     1,   287,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,   287,   287,   287,   287,   287,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,   287,    40,    41,   287,    43,
      44,    45,    46,    47,    48,    49,    50,   287,   287,    53,
     287,   287,   287,    57,    58,    59,    60,    61,    62,     1,
     287,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,   287,   287,   287,   287,   287,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,   294,    40,    41,
     287,    43,    44,    45,    46,    47,    48,    49,    50,   287,
     287,    53,   287,   287,   287,    57,    58,    59,    60,    61,
      62,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   287,
     287,   278,   292,   285,   280,   280,   274,   233,   287,   280,
     277,   277,   277,   287,   277,   277,   277,   277,   277,   277,
     277,   277,   277,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   277,   277,   277,   277,   277,   277,   277,
     277,   291,   278,   277,   274,   267,   282,   283,   294,   280,
     286,   287,   288,   289,   287,   287,   280,   277,   294,   233,
     287,   290,   287,   156,   287,   790,   287,   697,   287,   287,
     287,   287,   287,   287,   287,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   287,   287,   287,   287,   287,
     287,   287,   287,   287,   278,   287,   287,   287,   282,   283,
     287,   287,   286,   287,   287,   289,   287,   287,   287,   287,
     294,   233,   287,   287,   287,   292,   287,   666,   294,   287,
     287,   287,   294,   292,   294,   274,   410,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   292,   294,   275,
     294,  1015,  1329,  1136,  1015,  1417,   278,   664,     1,   379,
     282,   283,    -1,  1410,   286,   287,    -1,   289,  1393,    -1,
      -1,    -1,   294,    16,    17,    18,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    39,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,    -1,   230,   231,   232,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   245,   246,   247,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,   278,     3,     4,     5,     6,
       7,     8,     9,   286,    -1,    -1,    -1,    14,    15,    16,
     293,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    -1,    -1,    43,    44,    45,    46,
      47,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    -1,    -1,    -1,
      57,    58,    59,    60,    61,    62,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      -1,    -1,    57,    58,    59,    60,    61,    62,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   233,   234,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,
      -1,    -1,    -1,   270,   271,   272,   273,    -1,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,    -1,    -1,    -1,
      -1,   288,   289,    -1,   291,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    -1,    -1,    -1,    -1,   233,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      -1,    -1,    57,    58,    59,    60,    61,    62,    -1,    -1,
      -1,   278,    -1,    -1,    -1,   282,   283,    -1,    -1,   286,
      -1,    -1,    -1,   290,    -1,    -1,    -1,    -1,   233,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   278,    -1,    -1,    -1,   282,   283,    -1,
      -1,   286,    -1,    -1,     1,   290,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    -1,    -1,    -1,
      57,    58,    59,    60,    61,    62,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    -1,    -1,    -1,    -1,   233,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    -1,    -1,    57,    58,    59,    60,    61,    62,
      -1,    -1,    -1,   278,    -1,    -1,    -1,   282,   283,    -1,
      -1,   286,    -1,    -1,     1,   290,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    -1,    -1,    -1,
      57,    58,    59,    60,    61,    62,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    -1,    -1,    -1,    -1,   233,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    -1,    53,    -1,
      -1,    -1,    57,    58,    59,    60,    61,    62,    -1,    -1,
      -1,   278,    -1,    -1,    -1,   282,   283,    -1,    -1,   286,
      -1,    -1,     1,   290,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    -1,    -1,
     233,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    -1,    53,    -1,    -1,    -1,    57,    58,
      59,    60,    61,    62,    -1,   278,    -1,    -1,    -1,   282,
     283,    -1,    -1,   286,    -1,    -1,     1,   290,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    -1,    -1,    -1,    -1,   233,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    -1,    53,    -1,
      -1,    -1,    57,    58,    59,    60,    61,    62,    -1,    -1,
      -1,   278,    -1,    -1,    -1,   282,   283,    -1,    -1,   286,
      -1,    -1,    -1,   290,    -1,    -1,    -1,    -1,   233,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   278,    -1,    -1,    -1,   282,   283,    -1,
      -1,   286,    -1,    -1,     1,   290,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    -1,   233,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    -1,    53,    -1,    -1,    -1,
      57,    58,    59,    60,    61,    62,    -1,    -1,    -1,   278,
      -1,    -1,    -1,   282,   283,    -1,    -1,   286,    -1,    -1,
       1,   290,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    -1,    -1,   233,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    -1,    53,    -1,    -1,    -1,    57,    58,    59,    60,
      61,    62,    -1,   278,    -1,    -1,    -1,   282,   283,    -1,
      -1,   286,    -1,    -1,     1,   290,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    -1,    53,    -1,    -1,    -1,
      57,    58,    59,    60,    61,    62,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    -1,    -1,    -1,    -1,   233,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    -1,    53,    -1,
      -1,    -1,    57,    58,    59,    60,    61,    62,    -1,    -1,
      -1,   278,    -1,    -1,    -1,   282,   283,    -1,    -1,   286,
      -1,    -1,     1,   290,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    -1,    -1,
      -1,    -1,   233,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    -1,    53,    -1,    -1,    -1,    57,    58,
      59,    60,    61,    62,    -1,    -1,    -1,   278,    -1,    -1,
      -1,   282,   283,    -1,    -1,   286,    -1,    -1,     1,   290,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    -1,    -1,   233,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    -1,
      53,    -1,    -1,    -1,    57,    58,    59,    60,    61,    62,
      -1,   278,    -1,    -1,    -1,   282,   283,    -1,    -1,   286,
      -1,    -1,    -1,   290,    -1,    -1,    -1,    -1,   233,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   278,    -1,    -1,    -1,   282,   283,    -1,
      -1,   286,    -1,    -1,     1,   290,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    -1,   233,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    -1,    53,    -1,    -1,    -1,
      57,    58,    59,    60,    61,    62,    -1,    -1,    -1,   278,
      -1,    -1,    -1,   282,   283,    -1,    -1,   286,    -1,    -1,
       1,   290,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    -1,    -1,    -1,    -1,
     233,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    -1,    53,    -1,    -1,    -1,    57,    58,    59,    60,
      61,    62,    -1,    -1,    -1,   278,    -1,    -1,    -1,   282,
     283,    -1,    -1,   286,    -1,    -1,     1,   290,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    -1,    53,    -1,
      -1,    -1,    57,    58,    59,    60,    61,    62,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    -1,    -1,   233,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    -1,
      53,    -1,    -1,    -1,    57,    58,    59,    60,    61,    62,
      -1,   278,    -1,    -1,    -1,   282,   283,    -1,    -1,   286,
      -1,    -1,    -1,   290,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   278,    -1,    -1,
      -1,   282,   283,    -1,    -1,   286,    -1,    -1,    -1,   290,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   278,    -1,    -1,    -1,   282,   283,    -1,
      -1,   286,    -1,    -1,    -1,   290,    -1,    -1,    -1,    -1,
     233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   278,    -1,    -1,    -1,   282,
     283,    -1,    -1,   286,    -1,    -1,     1,   290,     3,     4,
       5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,    14,
      15,    16,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    -1,    40,    -1,    -1,    43,    44,
      45,    46,    47,    48,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    -1,
      -1,    -1,    -1,    14,    15,    16,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
      -1,    -1,    43,    44,    45,    46,    47,    48,    49,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,    -1,    -1,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    -1,    -1,    43,    44,    45,    46,
      47,    48,    49,    -1,    -1,    -1,    -1,    -1,   233,   234,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,   264,
      -1,    -1,    -1,   268,    -1,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,    -1,   280,    -1,   282,   283,    -1,
      -1,    -1,    -1,   288,   289,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   233,   234,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   264,    -1,    -1,    -1,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,    -1,   280,
      -1,   282,   283,    -1,    -1,    -1,    -1,   288,   289,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   233,   234,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,
      -1,    -1,    -1,   270,   271,   272,   273,    -1,   275,   276,
     277,   278,    -1,   280,    -1,   282,   283,    -1,    -1,    -1,
     287,   288,   289,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    -1,    -1,    -1,    -1,    14,    15,    16,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    45,    46,    47,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    -1,    -1,    -1,    -1,    14,    15,    16,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    45,    46,    47,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,    14,    15,    16,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    45,    46,    47,    48,    49,
      -1,    -1,    -1,    -1,    -1,   233,   234,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,
      -1,    -1,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,    -1,   280,    -1,   282,   283,    -1,    -1,    -1,   287,
     288,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   233,   234,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,
      -1,    -1,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,    -1,   280,    -1,   282,   283,    -1,    -1,    -1,   287,
     288,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   233,   234,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   264,    -1,    -1,   267,    -1,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,    -1,
     280,    -1,   282,   283,    -1,    -1,    -1,    -1,   288,   289,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    -1,
      -1,    -1,    -1,    14,    15,    16,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
      -1,    -1,    43,    44,    45,    46,    47,    48,    49,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    -1,
      -1,    -1,    -1,    14,    15,    16,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
      -1,    -1,    43,    44,    45,    46,    47,    48,    49,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    14,    15,    16,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    -1,    40,    -1,    -1,
      43,    44,    45,    46,    47,    48,    49,    -1,    -1,    -1,
      -1,    -1,   233,   234,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    -1,
      -1,    -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,    -1,   280,
      -1,   282,   283,    -1,    -1,    -1,    -1,   288,   289,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   233,   234,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,    -1,   280,
      -1,   282,   283,    -1,    -1,    -1,    -1,   288,   289,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     233,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   264,    -1,    -1,    -1,    -1,    -1,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,    -1,   280,    -1,   282,
     283,    -1,    -1,    -1,    -1,   288,   289,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,
      14,    15,    16,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    45,    46,    47,    48,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,
      14,    15,    16,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    45,    46,    47,    48,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    14,    15,
      16,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    45,
      46,    47,    48,    49,    -1,    -1,    -1,    -1,    -1,   233,
     234,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,
     264,    -1,    -1,    -1,    -1,    -1,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,    -1,   280,    -1,   282,   283,
      -1,    -1,    -1,    -1,   288,   289,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,
     234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     264,    -1,    -1,    -1,    -1,    -1,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,    -1,   280,    -1,   282,   283,
      -1,    -1,    -1,    -1,   288,   289,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,   234,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,
      -1,    -1,    -1,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,    -1,   280,    -1,   282,   283,    -1,    -1,
      -1,    -1,   288,   289,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,    -1,    -1,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    -1,    -1,    43,    44,    45,    46,
      47,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,    -1,    -1,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    -1,    -1,    43,    44,    45,    46,
      47,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    14,    15,    16,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    -1,    -1,    43,    44,    45,    46,    47,    48,
      49,    -1,    -1,    -1,    -1,    -1,   233,   234,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,
      -1,    -1,    -1,   270,   271,   272,   273,    -1,   275,   276,
     277,   278,    -1,   280,    -1,   282,   283,    -1,    -1,    -1,
      -1,   288,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   233,   234,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,
      -1,    -1,    -1,   270,   271,   272,   273,    -1,   275,   276,
     277,   278,    -1,   280,    -1,   282,   283,    -1,    -1,    -1,
      -1,   288,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   233,   234,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,    -1,
      -1,   270,   271,   272,   273,    -1,   275,   276,   277,   278,
      -1,   280,    -1,   282,   283,    -1,    -1,    -1,    -1,   288,
     289,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,    14,    15,    16,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    45,    46,    47,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,    14,    15,    16,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    45,    46,    47,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    14,    15,    16,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    45,    46,    47,    48,    49,    -1,    -1,
      -1,    -1,    -1,   233,   234,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,    -1,
     280,    -1,   282,   283,    -1,    -1,    -1,    -1,   288,   289,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   233,   234,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,    -1,
     280,    -1,   282,   283,    -1,    -1,    -1,    -1,   288,   289,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   233,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,    -1,   280,    -1,
     282,   283,    -1,    -1,    -1,    -1,   288,   289,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    14,    15,    16,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    -1,    40,    -1,    -1,
      43,    44,    45,    46,    47,    48,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    14,    15,    16,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    -1,    40,    -1,    -1,
      43,    44,    45,    46,    47,    48,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,    14,
      15,    16,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    -1,    40,    -1,    -1,    43,    44,
      45,    46,    47,    48,    49,    -1,    -1,    -1,    -1,    -1,
     233,   234,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    -1,    -1,    -1,
      -1,   264,    -1,    -1,    -1,    -1,    -1,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,    -1,   280,    -1,   282,
     283,    -1,    -1,    -1,    -1,   288,   289,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     233,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   264,    -1,    -1,    -1,    -1,    -1,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,    -1,   280,    -1,   282,
     283,    -1,    -1,    -1,    -1,   288,   289,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,   234,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   264,
      -1,    -1,    -1,    -1,    -1,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,    -1,   280,    -1,   282,   283,    -1,
      -1,    -1,    -1,   288,   289,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    14,    15,
      16,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    45,
      46,    47,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    14,    15,
      16,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    45,
      46,    47,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    -1,    -1,    -1,    -1,    14,    15,    16,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    45,    46,    47,
      48,    49,    -1,    -1,    -1,    -1,    -1,   233,   234,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    -1,    -1,    -1,    -1,   264,    -1,
      -1,    -1,    -1,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,    -1,   280,    -1,   282,   283,    -1,    -1,
      -1,    -1,   288,   289,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,   234,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,
      -1,    -1,    -1,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,    -1,   280,    -1,   282,   283,    -1,    -1,
      -1,    -1,   288,   289,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   233,   234,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,
      -1,    -1,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,    -1,   280,    -1,   282,   283,    -1,    -1,    -1,    -1,
     288,   289,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    14,    15,    16,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    -1,    -1,    43,    44,    45,    46,    47,    48,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    14,    15,    16,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    -1,    -1,    43,    44,    45,    46,    47,    48,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    -1,
      -1,    -1,    -1,    14,    15,    16,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
      -1,    -1,    43,    44,    45,    46,    47,    48,    49,    -1,
      -1,    -1,    -1,    -1,   233,   234,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,    -1,
      -1,   270,   271,   272,   273,    -1,   275,   276,   277,   278,
      -1,   280,    -1,   282,   283,    -1,    -1,    -1,    -1,   288,
     289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   233,   234,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,    -1,
      -1,   270,   271,   272,   273,    -1,   275,   276,   277,   278,
      -1,   280,    -1,   282,   283,    -1,    -1,    -1,    -1,   288,
     289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   233,   234,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,    -1,   280,
      -1,   282,   283,    -1,    -1,    -1,    -1,   288,   289,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    14,    15,    16,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    45,    46,    47,    48,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    14,    15,    16,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    45,    46,    47,    48,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,
      14,    15,    16,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    45,    46,    47,    48,    49,    -1,    -1,    -1,    -1,
      -1,   233,   234,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    -1,    -1,
      -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,    -1,   280,    -1,
     282,   283,    -1,    -1,    -1,    -1,   288,   289,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   233,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,    -1,   280,    -1,
     282,   283,    -1,    -1,    -1,    -1,   288,   289,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,
     234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     264,    -1,    -1,    -1,    -1,    -1,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,    -1,   280,    -1,   282,   283,
      -1,    -1,    -1,    -1,   288,   289,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,    -1,    -1,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    -1,    -1,    43,    44,    45,    46,
      47,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,     3,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    14,    15,    16,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    -1,    -1,    43,    44,    45,    46,    47,    48,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    14,    15,    16,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    -1,    -1,    43,    44,    45,    46,    47,    48,
      49,    -1,    -1,    -1,    -1,    -1,   233,   234,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,
      -1,    -1,    -1,   270,   271,   272,   273,    -1,   275,   276,
     277,   278,    -1,   280,    -1,   282,   283,    -1,    -1,    -1,
      -1,   288,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   233,   234,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,    -1,
      -1,   270,   271,   272,   273,    -1,   275,   276,   277,   278,
      -1,   280,    -1,   282,   283,    -1,    -1,    -1,    -1,   288,
     289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   233,   234,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,    -1,
      -1,   270,   271,   272,   273,    -1,   275,   276,   277,   278,
      -1,   280,    -1,   282,   283,    -1,    -1,    -1,    -1,   288,
     289,     3,     4,     5,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    14,    15,    16,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    45,    46,    47,    48,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    -1,    53,
      -1,    -1,    -1,    57,    58,    59,    60,    61,    62,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    -1,    53,
      -1,    -1,    -1,    57,    58,    59,    60,    61,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   233,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,    -1,   280,    -1,
     282,   283,    -1,    -1,    -1,    -1,   288,   289,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   278,    -1,    -1,    -1,   282,   283,
      -1,    -1,   286,    -1,    -1,   289,    -1,    -1,    -1,   233,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   278,    -1,    -1,    -1,   282,   283,
      -1,    -1,   286,    -1,     1,   289,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    -1,    53,    -1,    -1,    -1,
      57,    58,    59,    60,    61,    62,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    -1,    53,    -1,    -1,    -1,
      57,    58,    59,    60,    61,    62,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   278,    -1,    -1,    -1,   282,   283,    -1,    -1,   286,
      -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   278,    -1,    -1,    -1,   282,   283,    -1,    -1,   286
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    36,    39,    40,    52,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   230,   231,   232,   245,
     246,   247,   278,   286,   293,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   314,   318,   321,   322,   323,   324,
     248,   248,   248,   248,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   248,     1,   248,     1,   248,     1,   248,
       1,   248,     1,   248,     1,   248,     1,   248,     1,   248,
       1,   248,     1,   248,     1,   248,     1,   248,     1,   248,
       1,   248,     1,   248,     1,   248,     1,   248,     1,   248,
       1,   248,     1,   248,     1,   248,     1,   248,     1,   248,
       1,   248,     1,   248,     1,   248,     1,   248,   248,   248,
     248,   248,   248,   248,   248,   248,   248,   248,   248,   248,
     248,   248,     1,   280,     1,   248,   280,     1,   288,   248,
     248,   248,   248,   248,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   248,   248,   248,   248,   248,     1,   248,
       1,   248,     1,   248,     1,   248,   248,   248,   248,   248,
     248,   248,   248,   248,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   248,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   248,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   248,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   248,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   248,   248,   248,     1,   248,   248,   248,
     248,     1,   278,   280,   315,   316,   317,     1,   317,   319,
     320,   248,   248,   248,     0,     1,   298,    16,   330,    17,
     331,    18,   332,    19,   333,    20,   334,    21,   335,   274,
       1,   277,     1,   277,     1,    81,    82,    83,    84,   268,
     308,     1,   264,   277,   313,     1,   277,     1,   277,     1,
     278,     1,   280,     1,   277,   278,   279,   280,   281,   288,
     291,   305,   307,   308,   311,   312,   325,   326,   327,   328,
     349,   350,     1,   312,     1,   277,     1,   277,     1,   277,
     277,   277,   277,   313,   313,   313,   313,   277,   277,   277,
     277,   277,   277,   277,   277,   277,   277,   277,   277,   277,
     277,   277,   277,   277,   277,   277,   277,     1,   277,   280,
       1,   277,     1,   277,     1,   277,     1,   277,     1,   313,
       1,   313,     1,   313,     1,   277,     1,   277,     1,   280,
       1,   280,     1,   277,     1,   280,   280,     1,   277,     1,
     278,   280,     1,   278,   280,     1,   278,   280,     1,   278,
     280,     1,   277,     1,   277,     1,   277,     1,   277,     1,
     313,     1,   313,     1,   313,     1,   278,   280,     1,   277,
       1,   277,     1,   277,   326,     1,   328,     1,   277,     1,
     277,   277,   277,   277,   277,     1,   277,     1,   277,     1,
     277,     1,   277,     1,   277,     1,   277,     1,   277,     1,
     277,     1,   277,     1,   277,     1,   277,     1,   277,     1,
     277,     1,   178,   179,   180,   181,     1,   277,     1,   277,
       1,   277,     1,   277,     1,   280,     1,   280,     1,   280,
       1,   277,     1,   277,     1,   277,     1,   277,     1,   277,
       1,   277,     1,   277,     1,   277,     1,   277,     1,   277,
       1,   313,     1,   277,     1,   277,     1,   277,     1,   277,
       1,   277,     1,   277,     1,   313,     1,   277,     1,   277,
       1,   277,     1,   277,     1,   305,     1,   277,     1,   277,
       1,   277,     1,   277,     1,   277,     1,   277,     1,   277,
       1,   277,     1,   277,     1,   277,     1,   277,     1,   277,
       1,   277,     1,   277,     1,   277,     1,   277,   277,     1,
     277,     1,   277,   277,   285,   294,   285,     1,   277,     1,
     277,     1,   277,     1,   289,   291,     1,   289,   291,     1,
     289,   291,     1,   289,   291,     1,   289,   291,     1,   291,
     322,   277,   274,   305,   306,   327,   294,   294,   312,   264,
     274,   285,   315,   277,   319,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    40,    41,    43,    44,
      45,    46,    47,    48,    49,    50,    53,    57,    58,    59,
      60,    61,    62,   233,   278,   282,   283,   286,   351,   353,
     354,   355,   359,   360,   368,   369,   371,   372,   375,   376,
     378,   382,   383,   384,   388,   277,   278,   280,   329,   353,
     329,   353,   329,   353,   329,   353,   329,   284,   248,   277,
     285,   287,   292,     1,   268,   277,   309,   307,     1,   277,
     349,     1,   349,   280,     1,   288,     1,   288,     1,   288,
       1,   288,     1,   288,     1,   288,     1,   288,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,   234,   264,   270,   271,
     272,   273,   275,   276,   280,   288,   289,   313,   341,   342,
     343,   344,   345,   346,   351,   363,   368,   369,   370,   371,
     373,   375,   376,   379,   380,   381,   288,   381,   288,   381,
       1,   288,     1,   288,     1,   288,   288,     1,   288,     1,
     288,     1,   288,     1,   288,     1,   288,     1,   288,     1,
     288,   288,     1,   288,     1,   288,     1,   288,     1,   288,
     288,   288,   288,   288,   288,   288,   381,     1,   288,     1,
     288,     1,   288,   288,   288,   288,   288,     1,   381,   381,
       1,   288,     1,   288,     1,   288,     1,   385,     1,   286,
       1,   290,   354,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   278,   365,   366,   367,   248,   377,   286,     1,
     288,   286,   292,   290,   292,   290,   292,   290,   292,   290,
     292,   292,     1,   277,   280,   274,   306,   294,   285,     1,
      54,   278,   280,   287,   325,   348,     1,    54,   280,   325,
     348,     1,    54,   280,   325,   348,     1,    54,   280,   325,
     348,     1,    54,   280,   325,   348,     1,   280,   325,   348,
       1,   280,   325,   348,     1,   253,   254,   257,   258,   259,
     336,   338,   336,   336,     1,   336,   364,     1,   381,     1,
     381,     1,   381,   288,   288,     1,   287,   369,   371,   375,
     376,   381,   382,     1,   353,     1,   338,     1,   260,   261,
     262,   263,   336,   337,     1,   338,   367,     1,   381,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   339,
     340,   287,   287,     1,   277,   280,     1,   280,     1,   329,
     280,     1,   280,     1,   280,     1,   280,     1,   280,     1,
     277,     1,   277,   287,   280,   287,     1,   280,     1,   280,
       1,   280,     1,   280,   287,   287,   287,     1,   277,   287,
       1,   308,   289,   352,   354,     1,   305,     1,   277,     1,
     305,   308,   310,   287,   287,   287,   287,   289,   352,   277,
     317,   277,   317,   277,   317,   288,   274,   291,   381,     1,
     280,   368,   369,   374,   376,   289,   289,   289,   289,   289,
     289,   229,   229,   277,   309,   280,   313,   287,   285,   287,
     285,   287,   285,   287,   264,   274,   285,   287,   287,   285,
     287,   285,   287,   285,   287,   285,   287,   287,   285,   287,
     285,   287,   285,   287,   285,   287,   287,   285,   287,   285,
     287,   285,   287,   285,   287,   287,   285,   287,   285,   287,
     285,   287,   285,   287,   287,   285,   287,   285,   287,   285,
     287,   287,   285,   287,   285,   287,   285,   287,     1,   278,
     381,     1,   308,   381,     1,   308,   381,     1,   341,   345,
     278,   361,   362,     1,   381,     1,   381,   287,   287,   287,
     290,   290,     1,    79,   381,     1,   381,     1,   381,     1,
      79,   277,   278,   325,   347,   348,   381,   291,     1,   381,
       1,   381,     1,   381,     1,   381,     1,   381,     1,   381,
       1,   381,     1,   381,     1,   381,     1,   381,     1,   381,
     287,   285,   287,   287,   285,   287,   287,   287,   287,   287,
     287,   287,   287,   287,   287,   287,   287,   287,   287,   287,
     285,   287,   287,   287,   287,   287,   287,   287,   287,   287,
     287,   287,   287,   287,   353,    42,   287,   287,   287,   287,
     287,   294,   294,   287,     1,    51,    52,   290,   357,   358,
     287,   287,   287,   287,   287,   287,   280,   313,   386,   387,
     366,   292,   285,   287,   367,   285,   353,   353,   353,   353,
     353,   353,   280,   280,   274,   287,   287,    55,   277,   277,
     277,     1,   278,     1,   278,   277,    55,   277,   277,   277,
     277,    55,   277,   277,   277,   277,    55,   277,   277,   277,
     277,    55,   277,   277,   277,   277,   277,   277,   277,   277,
     277,   277,   291,   274,   287,   287,   287,   287,   267,   313,
     280,   280,   280,   290,   352,     1,   309,   305,   290,     1,
     267,   356,   381,   294,   290,   357,     1,   285,   287,   317,
       1,   317,   290,   290,   290,   290,   290,   290,   277,   287,
     287,   287,   287,   287,   287,   287,   287,   287,   287,   287,
     287,   287,   287,   287,   287,   287,   287,   287,   287,   287,
     287,   287,   287,   287,   287,   287,   287,   287,   287,   287,
     280,   313,   361,     1,   277,   325,   292,   287,   287,   287,
     294,   294,     1,   356,   294,   353,   387,   287,   287,   287,
     292,   292,   309,   353,   294,   294,     1,   353,   353,   353
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:

/* Line 1455 of yacc.c  */
#line 636 "cfg.y"
    {;}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 637 "cfg.y"
    {;}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 638 "cfg.y"
    { yyerror(""); YYABORT;;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 645 "cfg.y"
    {rt=REQUEST_ROUTE;;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 646 "cfg.y"
    {rt=FAILURE_ROUTE;;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 647 "cfg.y"
    {rt=ONREPLY_ROUTE;;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 648 "cfg.y"
    {rt=BRANCH_ROUTE;;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 649 "cfg.y"
    {rt=ONSEND_ROUTE;;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 650 "cfg.y"
    {rt=EVENT_ROUTE;;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 655 "cfg.y"
    {
		if ((yyvsp[(1) - (1)].ipaddr)){
			tmp=ip_addr2a((yyvsp[(1) - (1)].ipaddr));
			if (tmp==0) {
				LOG(L_CRIT, "ERROR: cfg. parser: bad ip "
						"address.\n");
				(yyval.strval)=0;
			} else {
				(yyval.strval)=pkg_malloc(strlen(tmp)+1);
				if ((yyval.strval)==0) {
					LOG(L_CRIT, "ERROR: cfg. parser: out of "
							"memory.\n");
				} else {
					strncpy((yyval.strval), tmp, strlen(tmp)+1);
				}
			}
		}
	;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 673 "cfg.y"
    {
		(yyval.strval)=pkg_malloc(strlen((yyvsp[(1) - (1)].strval))+1);
		if ((yyval.strval)==0) {
				LOG(L_CRIT, "ERROR: cfg. parser: out of "
						"memory.\n");
		} else {
				strncpy((yyval.strval), (yyvsp[(1) - (1)].strval), strlen((yyvsp[(1) - (1)].strval))+1);
		}
	;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 682 "cfg.y"
    {
		if ((yyvsp[(1) - (1)].strval)){
			(yyval.strval)=pkg_malloc(strlen((yyvsp[(1) - (1)].strval))+1);
			if ((yyval.strval)==0) {
					LOG(L_CRIT, "ERROR: cfg. parser: out of "
							"memory.\n");
			} else {
					strncpy((yyval.strval), (yyvsp[(1) - (1)].strval), strlen((yyvsp[(1) - (1)].strval))+1);
			}
		}
	;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 697 "cfg.y"
    { (yyval.name_l)=mk_name_lst((yyvsp[(1) - (1)].strval), SI_IS_MHOMED); ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 698 "cfg.y"
    { (yyval.name_l)=mk_name_lst((yyvsp[(1) - (3)].strval), SI_IS_MHOMED); 
										if ((yyval.name_l)) (yyval.name_l)->next=(yyvsp[(3) - (3)].name_l);
									;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 704 "cfg.y"
    { (yyval.name_l)=(yyvsp[(2) - (3)].name_l); ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 705 "cfg.y"
    { (yyval.name_l)=mk_name_lst((yyvsp[(1) - (1)].strval), 0); ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 709 "cfg.y"
    { (yyval.intval)=PROTO_UDP; ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 710 "cfg.y"
    { (yyval.intval)=PROTO_TCP; ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 711 "cfg.y"
    { (yyval.intval)=PROTO_TLS; ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 712 "cfg.y"
    { (yyval.intval)=PROTO_SCTP; ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 713 "cfg.y"
    { (yyval.intval)=0; ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 716 "cfg.y"
    { (yyval.intval)=(yyvsp[(1) - (1)].intval); ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 717 "cfg.y"
    { (yyval.intval)=0; ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 720 "cfg.y"
    { (yyval.sockid)=mk_listen_id((yyvsp[(1) - (1)].strval), 0, 0); ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 721 "cfg.y"
    { (yyval.sockid)=mk_listen_id((yyvsp[(1) - (3)].strval), 0, (yyvsp[(3) - (3)].intval)); ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 722 "cfg.y"
    { (yyval.sockid)=mk_listen_id((yyvsp[(3) - (3)].strval), (yyvsp[(1) - (3)].intval), 0); ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 723 "cfg.y"
    { (yyval.sockid)=mk_listen_id((yyvsp[(3) - (5)].strval), (yyvsp[(1) - (5)].intval), (yyvsp[(5) - (5)].intval));;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 724 "cfg.y"
    { (yyval.sockid)=0; yyerror(" port number expected"); ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 728 "cfg.y"
    { (yyval.sockid)=mk_listen_id2((yyvsp[(1) - (1)].name_l), 0, 0); ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 729 "cfg.y"
    { (yyval.sockid)=mk_listen_id2((yyvsp[(1) - (3)].name_l), 0, (yyvsp[(3) - (3)].intval)); ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 730 "cfg.y"
    { (yyval.sockid)=mk_listen_id2((yyvsp[(3) - (3)].name_l), (yyvsp[(1) - (3)].intval), 0); ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 731 "cfg.y"
    { (yyval.sockid)=mk_listen_id2((yyvsp[(3) - (5)].name_l), (yyvsp[(1) - (5)].intval), (yyvsp[(5) - (5)].intval));;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 732 "cfg.y"
    { (yyval.sockid)=0; yyerror(" port number expected"); ;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 736 "cfg.y"
    {  (yyval.sockid)=(yyvsp[(1) - (1)].sockid) ; ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 737 "cfg.y"
    { (yyval.sockid)=(yyvsp[(1) - (2)].sockid);  if ((yyval.sockid)) (yyval.sockid)->next=(yyvsp[(2) - (2)].sockid); ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 741 "cfg.y"
    { (yyval.intval)=-(yyvsp[(2) - (2)].intval); ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 745 "cfg.y"
    { yyerror("flag list expected\n"); ;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 751 "cfg.y"
    { if (register_flag((yyvsp[(1) - (1)].strval),-1)<0)
								yyerror("register flag failed");
						;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 754 "cfg.y"
    {
						if (register_flag((yyvsp[(1) - (3)].strval), (yyvsp[(3) - (3)].intval))<0)
								yyerror("register flag failed");
										;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 760 "cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); ;}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 761 "cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); ;}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 766 "cfg.y"
    { yyerror("avpflag list expected\n"); ;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 773 "cfg.y"
    {
		if (register_avpflag((yyvsp[(1) - (1)].strval))==0)
			yyerror("cannot declare avpflag");
	;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 779 "cfg.y"
    { default_core_cfg.debug=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 780 "cfg.y"
    { yyerror("number  expected"); ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 781 "cfg.y"
    { dont_fork= ! (yyvsp[(3) - (3)].intval); ;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 782 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 783 "cfg.y"
    { if (!config_check) log_stderr=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 784 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 785 "cfg.y"
    {
		if ( (i_tmp=str2facility((yyvsp[(3) - (3)].strval)))==-1)
			yyerror("bad facility (see syslog(3) man page)");
		if (!config_check)
			default_core_cfg.log_facility=i_tmp;
	;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 791 "cfg.y"
    { yyerror("ID expected"); ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 792 "cfg.y"
    { log_name=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 793 "cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 794 "cfg.y"
    { received_dns|= ((yyvsp[(3) - (3)].intval))?DO_DNS:0; ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 795 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 796 "cfg.y"
    { received_dns|= ((yyvsp[(3) - (3)].intval))?DO_REV_DNS:0; ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 797 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 798 "cfg.y"
    { default_core_cfg.dns_try_ipv6=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 799 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 800 "cfg.y"
    { IF_NAPTR(default_core_cfg.dns_try_naptr=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 801 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 802 "cfg.y"
    { IF_DNS_FAILOVER(default_core_cfg.dns_srv_lb=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 803 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 804 "cfg.y"
    { IF_NAPTR(default_core_cfg.dns_udp_pref=(yyvsp[(3) - (3)].intval));;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 805 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 806 "cfg.y"
    { IF_NAPTR(default_core_cfg.dns_tcp_pref=(yyvsp[(3) - (3)].intval));;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 807 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 808 "cfg.y"
    { IF_NAPTR(default_core_cfg.dns_tls_pref=(yyvsp[(3) - (3)].intval));;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 809 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 810 "cfg.y"
    { 
								IF_NAPTR(default_core_cfg.dns_sctp_pref=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 812 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 813 "cfg.y"
    { default_core_cfg.dns_retr_time=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 814 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 815 "cfg.y"
    { default_core_cfg.dns_retr_no=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 816 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 817 "cfg.y"
    { default_core_cfg.dns_servers_no=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 818 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 819 "cfg.y"
    { default_core_cfg.dns_search_list=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 820 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 821 "cfg.y"
    { default_core_cfg.dns_search_fmatch=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 822 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 823 "cfg.y"
    { IF_DNS_CACHE(dns_cache_init=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 824 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 825 "cfg.y"
    { IF_DNS_CACHE(default_core_cfg.use_dns_cache=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 826 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 827 "cfg.y"
    { IF_DNS_FAILOVER(default_core_cfg.use_dns_failover=(yyvsp[(3) - (3)].intval));;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 828 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 829 "cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_flags=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 830 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 831 "cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_neg_cache_ttl=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 832 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 833 "cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_ttl=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 834 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 835 "cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_min_ttl=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 836 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 837 "cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_mem=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 838 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 839 "cfg.y"
    { IF_DNS_CACHE(dns_timer_interval=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 840 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 841 "cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_del_nonexp=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 842 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 843 "cfg.y"
    { IF_DST_BLACKLIST(dst_blacklist_init=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 844 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 845 "cfg.y"
    { IF_DST_BLACKLIST(default_core_cfg.use_dst_blacklist=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 846 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 847 "cfg.y"
    { IF_DST_BLACKLIST(default_core_cfg.blst_max_mem=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 848 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 849 "cfg.y"
    { IF_DST_BLACKLIST(default_core_cfg.blst_timeout=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 850 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 851 "cfg.y"
    { IF_DST_BLACKLIST(blst_timer_interval=(yyvsp[(3) - (3)].intval));;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 852 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 853 "cfg.y"
    { port_no=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 854 "cfg.y"
    {
		#ifdef STATS
				stat_file=(yyvsp[(3) - (3)].strval);
		#endif
	;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 859 "cfg.y"
    { maxbuffer=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 860 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 861 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 862 "cfg.y"
    { children_no=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 863 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 864 "cfg.y"
    { check_via=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 865 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 866 "cfg.y"
    { phone2tel=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 867 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 868 "cfg.y"
    { syn_branch=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 869 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 870 "cfg.y"
    { default_core_cfg.memlog=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 871 "cfg.y"
    { yyerror("int value expected"); ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 872 "cfg.y"
    { default_core_cfg.memdbg=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 873 "cfg.y"
    { yyerror("int value expected"); ;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 874 "cfg.y"
    { default_core_cfg.mem_summary=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 875 "cfg.y"
    { yyerror("int value expected"); ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 876 "cfg.y"
    { sip_warning=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 877 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 878 "cfg.y"
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[(3) - (3)].strval); 
	;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 885 "cfg.y"
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[(3) - (3)].strval);
	;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 892 "cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 893 "cfg.y"
    { group=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 894 "cfg.y"
    { group=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 895 "cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 896 "cfg.y"
    { chroot_dir=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 897 "cfg.y"
    { chroot_dir=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 898 "cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 899 "cfg.y"
    { working_dir=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 900 "cfg.y"
    { working_dir=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 901 "cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 902 "cfg.y"
    { mhomed=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 903 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 904 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_disable=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 911 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 912 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_aliases=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 919 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 920 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_children_no=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 927 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 928 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.connect_timeout_s=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 935 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 936 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.send_timeout=S_TO_TICKS((yyvsp[(3) - (3)].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 943 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 944 "cfg.y"
    {
		#ifdef USE_TCP
			if ((yyvsp[(3) - (3)].intval)<0)
				tcp_default_cfg.con_lifetime=-1;
			else
				tcp_default_cfg.con_lifetime=S_TO_TICKS((yyvsp[(3) - (3)].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 954 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 955 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[(3) - (3)].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[(3) - (3)].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 969 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[(3) - (3)].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[(3) - (3)].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 983 "cfg.y"
    { yyerror("poll method name expected"); ;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 984 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_max_connections=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 991 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 992 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.no_connect=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 999 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1000 "cfg.y"
    {
		#ifdef USE_TCP
			if (tcp_set_src_addr((yyvsp[(3) - (3)].ipaddr))<0)
				warn("tcp_source_ipv4 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[(3) - (3)].ipaddr));
	;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1009 "cfg.y"
    { yyerror("IPv4 address expected"); ;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1010 "cfg.y"
    {
		#ifdef USE_TCP
			#ifdef USE_IPV6
				if (tcp_set_src_addr((yyvsp[(3) - (3)].ipaddr))<0)
					warn("tcp_source_ipv6 failed");
			#else
				warn("IPv6 support not compiled in");
			#endif
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[(3) - (3)].ipaddr));
	;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1023 "cfg.y"
    { yyerror("IPv6 address expected"); ;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1024 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.fd_cache=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1031 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1032 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.async=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1039 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1040 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcpconn_wq_max=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1047 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1048 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcp_wq_max=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1055 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1056 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.rd_buf_size=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1063 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1064 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.wq_blk_size=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1071 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1072 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.defer_accept=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1079 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1080 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.delayed_ack=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1087 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1088 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.syncnt=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1095 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1096 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.linger2=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1103 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1104 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepalive=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1111 "cfg.y"
    { yyerror("boolean value expected");;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1112 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepidle=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1119 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1120 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepintvl=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1127 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1128 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepcnt=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1135 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1136 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.crlf_ping=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1143 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1144 "cfg.y"
    {
		#ifdef USE_TLS
			tls_disable=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls support not compiled in");
		#endif
	;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1151 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1152 "cfg.y"
    {
		#ifdef USE_TLS
			tls_disable=!((yyvsp[(3) - (3)].intval));
		#else
			warn("tls support not compiled in");
		#endif
	;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1159 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1160 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_log=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1167 "cfg.y"
    { yyerror("int value expected"); ;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1168 "cfg.y"
    {
		#ifdef USE_TLS
			tls_port_no=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls support not compiled in");
		#endif
	;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1175 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1176 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv23;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1183 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv2;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1190 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv3;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1197 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_TLSv1;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1204 "cfg.y"
    {
		#ifdef CORE_TLS
			yyerror("SSLv23, SSLv2, SSLv3 or TLSv1 expected");
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1211 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_verify_cert=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1218 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1219 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_require_cert=(yyvsp[(3) - (3)].intval);
		#else
			warn( "tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1226 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1227 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_cert_file=(yyvsp[(3) - (3)].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1234 "cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1235 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_pkey_file=(yyvsp[(3) - (3)].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1242 "cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1243 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_ca_file=(yyvsp[(3) - (3)].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1250 "cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1251 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_handshake_timeout=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1258 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1259 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_send_timeout=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1266 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1267 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_disable=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1274 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1275 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_disable=((yyvsp[(3) - (3)].intval)<=1)?!(yyvsp[(3) - (3)].intval):(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1282 "cfg.y"
    { yyerror("boolean or number expected"); ;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1283 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_children_no=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1290 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1291 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_default_cfg.so_rcvbuf=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1298 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1299 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_default_cfg.so_sndbuf=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1306 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1307 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_default_cfg.autoclose=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1314 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1315 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_default_cfg.send_ttl=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1322 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1323 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_default_cfg.send_retries=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1330 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1331 "cfg.y"
    {
		#ifdef USE_SCTP
			#ifdef SCTP_CONN_REUSE
				sctp_default_cfg.assoc_tracking=(yyvsp[(3) - (3)].intval);
			#else
				if ((yyvsp[(3) - (3)].intval))
					warn("sctp association tracking/reuse (SCTP_CONN_REUSE) "
							"support not compiled in");
			#endif /* SCTP_CONN_REUSE */
		#else
			warn("sctp support not compiled in");
		#endif /* USE_SCTP */
	;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1344 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1345 "cfg.y"
    {
		#ifdef USE_SCTP
			#ifdef SCTP_CONN_REUSE
				sctp_default_cfg.assoc_reuse=(yyvsp[(3) - (3)].intval);
			#else
				if ((yyvsp[(3) - (3)].intval))
					warn("sctp association reuse (SCTP_CONN_REUSE) support"
							" not compiled in");
			#endif /* SCTP_CONN_REUSE */
		#else
			warn("sctp support not compiled in");
		#endif /* USE_SCTP */
	;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1358 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1359 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.max_assocs=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1362 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1363 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.srto_initial=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1366 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1367 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.srto_max=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1370 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1371 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.srto_min=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1374 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1375 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.asocmaxrxt=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1378 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1379 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.init_max_attempts=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1382 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1383 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.init_max_timeo=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1386 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1387 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.hbinterval=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1390 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1391 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.pathmaxrxt=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1394 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1395 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.sack_delay=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1398 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1399 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.sack_freq=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1402 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1403 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.max_burst=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1406 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1407 "cfg.y"
    { server_signature=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1408 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 1409 "cfg.y"
    { server_hdr.s=(yyvsp[(3) - (3)].strval);
			server_hdr.len=strlen(server_hdr.s);
	;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 1412 "cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 1413 "cfg.y"
    { user_agent_hdr.s=(yyvsp[(3) - (3)].strval);
			user_agent_hdr.len=strlen(user_agent_hdr.s);
	;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 1416 "cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 1417 "cfg.y"
    { reply_to_via=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 1418 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 1419 "cfg.y"
    {
		for(lst_tmp=(yyvsp[(3) - (3)].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									lst_tmp->flags)!=0) {
				LOG(L_CRIT,  "ERROR: cfg. parser: failed to add listen"
								" address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[(3) - (3)].sockid));
	;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 1432 "cfg.y"
    { yyerror("ip address, interface name or"
									" hostname expected"); ;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 1434 "cfg.y"
    {
		for(lst_tmp=(yyvsp[(3) - (3)].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[(3) - (3)].sockid));
	;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 1445 "cfg.y"
    { yyerror(" hostname expected"); ;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 1446 "cfg.y"
    { sr_auto_aliases=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 1447 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 1448 "cfg.y"
    {
		if ((yyvsp[(3) - (3)].strval)){
			default_global_address.s=(yyvsp[(3) - (3)].strval);
			default_global_address.len=strlen((yyvsp[(3) - (3)].strval));
		}
	;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 1454 "cfg.y"
    {yyerror("ip address or hostname expected"); ;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 1455 "cfg.y"
    {
		tmp=int2str((yyvsp[(3) - (3)].intval), &i_tmp);
		if ((default_global_port.s=pkg_malloc(i_tmp))==0) {
			LOG(L_CRIT, "ERROR: cfg. parser: out of memory.\n");
			default_global_port.len=0;
		} else {
			default_global_port.len=i_tmp;
			memcpy(default_global_port.s, tmp, default_global_port.len);
		};
	;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 1465 "cfg.y"
    {yyerror("ip address or hostname expected"); ;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 1466 "cfg.y"
    { disable_core_dump=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 1467 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 1468 "cfg.y"
    { open_files_limit=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 1469 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 1470 "cfg.y"
    {
		if (shm_initialized())
			yyerror("shm/shm_mem_size must be before any modparam or the"
					" route blocks");
		else if (shm_mem_size == 0)
			shm_mem_size=(yyvsp[(3) - (3)].intval) * 1024 * 1024;
	;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 1477 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 1478 "cfg.y"
    {
		if (shm_initialized())
			yyerror("shm_force_alloc must be before any modparam or the"
					" route blocks");
		else
			shm_force_alloc=(yyvsp[(3) - (3)].intval);
	;}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 1485 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 1486 "cfg.y"
    { mlock_pages=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 1487 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 1488 "cfg.y"
    { real_time=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 1489 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 1490 "cfg.y"
    { rt_prio=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 1491 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 1492 "cfg.y"
    { rt_policy=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 1493 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 1494 "cfg.y"
    { rt_timer1_prio=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 1495 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 1496 "cfg.y"
    { rt_timer1_policy=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 1497 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 1498 "cfg.y"
    { rt_timer2_prio=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 1499 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 1500 "cfg.y"
    { rt_timer2_policy=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 1501 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 1502 "cfg.y"
    {
		#ifdef USE_MCAST
			mcast_loopback=(yyvsp[(3) - (3)].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 1509 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 1510 "cfg.y"
    {
		#ifdef USE_MCAST
			mcast_ttl=(yyvsp[(3) - (3)].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 1517 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 1518 "cfg.y"
    { tos=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 1519 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 1520 "cfg.y"
    { pmtu_discovery=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 1521 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 1522 "cfg.y"
    { ser_kill_timeout=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 1523 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 1524 "cfg.y"
    { default_core_cfg.max_while_loops=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 1525 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 1526 "cfg.y"
    { IF_STUN(stun_refresh_interval=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 1527 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 1528 "cfg.y"
    { IF_STUN(stun_allow_stun=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 1529 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 1530 "cfg.y"
    { IF_STUN(stun_allow_fp=(yyvsp[(3) - (3)].intval)) ; ;}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 1531 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 1532 "cfg.y"
    { server_id=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 1533 "cfg.y"
    { default_core_cfg.udp_mtu=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 1534 "cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 1536 "cfg.y"
    { default_core_cfg.force_rport=(yyvsp[(3) - (3)].intval); fix_global_req_flags(0, 0); ;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 1537 "cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 1539 "cfg.y"
    { default_core_cfg.udp_mtu_try_proto=(yyvsp[(3) - (3)].intval); fix_global_req_flags(0, 0); ;}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 1541 "cfg.y"
    { yyerror("TCP, TLS, SCTP or UDP expected"); ;}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 1543 "cfg.y"
    { yyerror("unknown config variable"); ;}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 1547 "cfg.y"
    { (yyval.strval)="default" ; ;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 1551 "cfg.y"
    {
		if (cfg_declare_int((yyvsp[(1) - (5)].strval), (yyvsp[(3) - (5)].strval), (yyvsp[(5) - (5)].intval), 0, 0, NULL)) {
			yyerror("variable cannot be declared");
		}
	;}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 1556 "cfg.y"
    {
		if (cfg_declare_str((yyvsp[(1) - (5)].strval), (yyvsp[(3) - (5)].strval), (yyvsp[(5) - (5)].strval), NULL)) {
			yyerror("variable cannot be declared");
		}
	;}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 1561 "cfg.y"
    {
		if (cfg_declare_int((yyvsp[(1) - (7)].strval), (yyvsp[(3) - (7)].strval), (yyvsp[(5) - (7)].intval), 0, 0, (yyvsp[(7) - (7)].strval))) {
			yyerror("variable cannot be declared");
		}
	;}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 1566 "cfg.y"
    {
		if (cfg_declare_str((yyvsp[(1) - (7)].strval), (yyvsp[(3) - (7)].strval), (yyvsp[(5) - (7)].strval), (yyvsp[(7) - (7)].strval))) {
			yyerror("variable cannot be declared");
		}
	;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 1571 "cfg.y"
    { 
		yyerror("number or string expected"); 
	;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 1577 "cfg.y"
    {
		DBG("loading module %s\n", (yyvsp[(2) - (2)].strval));
			if (load_module((yyvsp[(2) - (2)].strval))!=0) {
				yyerror("failed to load module");
			}
	;}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 1583 "cfg.y"
    { yyerror("string expected"); ;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 1584 "cfg.y"
    {
		DBG("loading modules under %s\n", (yyvsp[(2) - (2)].strval));
		printf("loading modules under %s\n", (yyvsp[(2) - (2)].strval));
		mods_dir = (yyvsp[(2) - (2)].strval);
	;}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 1589 "cfg.y"
    { yyerror("string expected"); ;}
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 1590 "cfg.y"
    {
		DBG("loading modules under %s\n", (yyvsp[(3) - (3)].strval));
		printf("loading modules under %s\n", (yyvsp[(3) - (3)].strval));
		mods_dir = (yyvsp[(3) - (3)].strval);
	;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 1595 "cfg.y"
    { yyerror("string expected"); ;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 1596 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		if (set_mod_param_regex((yyvsp[(3) - (8)].strval), (yyvsp[(5) - (8)].strval), PARAM_STRING, (yyvsp[(7) - (8)].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 1607 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		if (set_mod_param_regex((yyvsp[(3) - (8)].strval), (yyvsp[(5) - (8)].strval), PARAM_INT, (void*)(yyvsp[(7) - (8)].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 1618 "cfg.y"
    { yyerror("Invalid arguments"); ;}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 1621 "cfg.y"
    { (yyval.ipaddr)=(yyvsp[(1) - (1)].ipaddr); ;}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 1622 "cfg.y"
    { (yyval.ipaddr)=(yyvsp[(1) - (1)].ipaddr); ;}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 1625 "cfg.y"
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			LOG(L_CRIT, "ERROR: cfg. parser: out of memory.\n");
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET;
			(yyval.ipaddr)->len=4;
			if (((yyvsp[(1) - (7)].intval)>255) || ((yyvsp[(1) - (7)].intval)<0) ||
				((yyvsp[(3) - (7)].intval)>255) || ((yyvsp[(3) - (7)].intval)<0) ||
				((yyvsp[(5) - (7)].intval)>255) || ((yyvsp[(5) - (7)].intval)<0) ||
				((yyvsp[(7) - (7)].intval)>255) || ((yyvsp[(7) - (7)].intval)<0)) {
				yyerror("invalid ipv4 address");
				(yyval.ipaddr)->u.addr32[0]=0;
				/* $$=0; */
			} else {
				(yyval.ipaddr)->u.addr[0]=(yyvsp[(1) - (7)].intval);
				(yyval.ipaddr)->u.addr[1]=(yyvsp[(3) - (7)].intval);
				(yyval.ipaddr)->u.addr[2]=(yyvsp[(5) - (7)].intval);
				(yyval.ipaddr)->u.addr[3]=(yyvsp[(7) - (7)].intval);
				/*
				$$=htonl( ($1<<24)|
				($3<<16)| ($5<<8)|$7 );
				*/
			}
		}
	;}
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 1654 "cfg.y"
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			LOG(L_CRIT, "ERROR: cfg. parser: out of memory.\n");
		} else {
		#ifdef USE_IPV6
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET6;
			(yyval.ipaddr)->len=16;
			if (inet_pton(AF_INET6, (yyvsp[(1) - (1)].strval), (yyval.ipaddr)->u.addr)<=0) {
				yyerror("bad ipv6 address");
			}
		#else
			yyerror("ipv6 address & no ipv6 support compiled in");
			YYABORT;
		#endif
		}
	;}
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 1674 "cfg.y"
    { (yyval.ipaddr)=(yyvsp[(1) - (1)].ipaddr); ;}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 1675 "cfg.y"
    {(yyval.ipaddr)=(yyvsp[(2) - (3)].ipaddr); ;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 1679 "cfg.y"
    {
					tmp=int2str((yyvsp[(1) - (1)].intval), &i_tmp);
					if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
						yyerror("out of  memory");
						YYABORT;
					} else {
						memcpy((yyval.strval), tmp, i_tmp);
						(yyval.strval)[i_tmp]=0;
					}
						;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 1689 "cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); ;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 1690 "cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); ;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 1694 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[(3) - (4)].action), &main_rt.rlist[DEFAULT_RT]);
	;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 1703 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&main_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (main_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &main_rt.rlist[i_tmp]);
	;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 1721 "cfg.y"
    { yyerror("invalid  route  statement"); ;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 1724 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[(3) - (4)].action), &failure_rt.rlist[DEFAULT_RT]);
	;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 1733 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&failure_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (failure_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &failure_rt.rlist[i_tmp]);
	;}
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 1751 "cfg.y"
    { yyerror("invalid failure_route statement"); ;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 1754 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[(3) - (4)].action), &onreply_rt.rlist[DEFAULT_RT]);
	;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 1763 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&onreply_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (onreply_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &onreply_rt.rlist[i_tmp]);
	;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 1781 "cfg.y"
    { yyerror("invalid onreply_route statement"); ;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 1784 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[(3) - (4)].action), &branch_rt.rlist[DEFAULT_RT]);
	;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 1793 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&branch_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (branch_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &branch_rt.rlist[i_tmp]);
	;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 1811 "cfg.y"
    { yyerror("invalid branch_route statement"); ;}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 1813 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[(3) - (4)].action), &onsend_rt.rlist[DEFAULT_RT]);
	;}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 1822 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&onsend_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (onsend_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &onsend_rt.rlist[i_tmp]);
	;}
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 1840 "cfg.y"
    { yyerror("invalid onsend_route statement"); ;}
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 1842 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&event_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (event_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &event_rt.rlist[i_tmp]);
	;}
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 1861 "cfg.y"
    { yyerror("invalid event_route statement"); ;}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 1883 "cfg.y"
    {(yyval.intval)=EQUAL_OP; ;}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 1884 "cfg.y"
    {(yyval.intval)=DIFF_OP; ;}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 1885 "cfg.y"
    {(yyval.intval)=EQUAL_OP; ;}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 1886 "cfg.y"
    {(yyval.intval)=DIFF_OP; ;}
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 1889 "cfg.y"
    {(yyval.intval)=GT_OP; ;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 1890 "cfg.y"
    {(yyval.intval)=LT_OP; ;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 1891 "cfg.y"
    {(yyval.intval)=GTE_OP; ;}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 1892 "cfg.y"
    {(yyval.intval)=LTE_OP; ;}
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 1895 "cfg.y"
    {(yyval.intval)=(yyvsp[(1) - (1)].intval); ;}
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 1896 "cfg.y"
    {(yyval.intval)=MATCH_OP; ;}
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 1902 "cfg.y"
    {(yyval.intval)=RVE_EQ_OP; ;}
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 1903 "cfg.y"
    {(yyval.intval)=RVE_DIFF_OP; ;}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 1904 "cfg.y"
    {(yyval.intval)=RVE_IEQ_OP; ;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 1905 "cfg.y"
    {(yyval.intval)=RVE_IDIFF_OP; ;}
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 1906 "cfg.y"
    {(yyval.intval)=RVE_STREQ_OP; ;}
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 1907 "cfg.y"
    {(yyval.intval)=RVE_STRDIFF_OP; ;}
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 1908 "cfg.y"
    {(yyval.intval)=RVE_MATCH_OP; ;}
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 1911 "cfg.y"
    {(yyval.intval)=RVE_GT_OP; ;}
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 1912 "cfg.y"
    {(yyval.intval)=RVE_LT_OP; ;}
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 1913 "cfg.y"
    {(yyval.intval)=RVE_GTE_OP; ;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 1914 "cfg.y"
    {(yyval.intval)=RVE_LTE_OP; ;}
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 1921 "cfg.y"
    {(yyval.intval)=URI_O;;}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 1922 "cfg.y"
    {(yyval.intval)=FROM_URI_O;;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 1923 "cfg.y"
    {(yyval.intval)=TO_URI_O;;}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 1930 "cfg.y"
    { (yyval.intval)=SNDPORT_O; ;}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 1931 "cfg.y"
    { (yyval.intval)=TOPORT_O; ;}
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 1932 "cfg.y"
    { (yyval.intval)=SNDAF_O; ;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 1936 "cfg.y"
    { (yyval.intval)=SRCPORT_O; ;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 1937 "cfg.y"
    { (yyval.intval)=DSTPORT_O; ;}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 1938 "cfg.y"
    { (yyval.intval)=AF_O; ;}
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 1939 "cfg.y"
    { (yyval.intval)=MSGLEN_O; ;}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 1945 "cfg.y"
    { onsend_check("snd_ip"); (yyval.intval)=SNDIP_O; ;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 1946 "cfg.y"
    { onsend_check("to_ip");  (yyval.intval)=TOIP_O; ;}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 1949 "cfg.y"
    { (yyval.intval)=SRCIP_O; ;}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 1950 "cfg.y"
    { (yyval.intval)=DSTIP_O; ;}
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 1958 "cfg.y"
    {(yyval.expr)= mk_elem((yyvsp[(2) - (3)].intval), METHOD_O, 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr));;}
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 1960 "cfg.y"
    {(yyval.expr) = mk_elem((yyvsp[(2) - (3)].intval), METHOD_O, 0, STRING_ST,(yyvsp[(3) - (3)].strval)); ;}
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 1961 "cfg.y"
    { (yyval.expr)=0; yyerror("string expected"); ;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 1963 "cfg.y"
    { (yyval.expr)=0; yyerror("invalid operator,== , !=, or =~ expected"); ;}
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 1965 "cfg.y"
    {(yyval.expr) = mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr)); ;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 1967 "cfg.y"
    {(yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, MYSELF_ST, 0); ;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 1969 "cfg.y"
    { (yyval.expr)=0; yyerror("string or MYSELF expected"); ;}
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 1971 "cfg.y"
    { (yyval.expr)=0; yyerror("invalid operator, == , != or =~ expected"); ;}
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 1972 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr) ); ;}
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 1974 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr) ); ;}
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 1975 "cfg.y"
    { (yyval.expr)=0; yyerror("number expected"); ;}
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 1976 "cfg.y"
    { (yyval.expr)=0; yyerror("number expected"); ;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 1977 "cfg.y"
    { (yyval.expr)=0; yyerror("==, !=, <,>, >= or <=  expected"); ;}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 1979 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), PROTO_O, 0, NUMBER_ST, (void*)(yyvsp[(3) - (3)].intval) ); ;}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 1981 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), PROTO_O, 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr) ); ;}
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 1983 "cfg.y"
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls or sctp)"); ;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 1985 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), SNDPROTO_O, 0, NUMBER_ST, (void*)(yyvsp[(3) - (3)].intval) ); ;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 1987 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), SNDPROTO_O, 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr) ); ;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 1989 "cfg.y"
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls or sctp)"); ;}
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 1990 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, NET_ST, (yyvsp[(3) - (3)].ipnet)); ;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 1991 "cfg.y"
    {
			s_tmp.s=0;
			(yyval.expr)=0;
			if (rve_is_constant((yyvsp[(3) - (3)].rv_expr))){
				i_tmp=rve_guess_type((yyvsp[(3) - (3)].rv_expr));
				if (i_tmp==RV_INT)
					yyerror("string expected");
				else if (i_tmp==RV_STR){
					if (((rval_tmp=rval_expr_eval(0, 0, (yyvsp[(3) - (3)].rv_expr)))==0) ||
								(rval_get_str(0, 0, &s_tmp, rval_tmp, 0)<0)){
						rval_destroy(rval_tmp);
						yyerror("bad rvalue expression");
					}else{
						rval_destroy(rval_tmp);
					}
				}else{
					yyerror("BUG: unexpected dynamic type");
				}
			}else{
					warn("non constant rvalue in ip comparison");
			}
			if (s_tmp.s){
				ip_tmp=str2ip(&s_tmp);
			#ifdef USE_IPV6
				if (ip_tmp==0)
					ip_tmp=str2ip6(&s_tmp);
			#endif
				pkg_free(s_tmp.s);
				if (ip_tmp) {
					(yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, NET_ST, 
								mk_net_bitlen(ip_tmp, ip_tmp->len*8) );
				} else {
					(yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr));
				}
			}else{
				(yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr));
			}
		;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 2030 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, STRING_ST, (yyvsp[(3) - (3)].strval)); ;}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 2032 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, MYSELF_ST, 0); ;}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 2034 "cfg.y"
    { (yyval.expr)=0; yyerror( "ip address or hostname expected" ); ;}
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 2036 "cfg.y"
    { (yyval.expr)=0; yyerror("invalid operator, ==, != or =~ expected");;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 2039 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].intval), 0, MYSELF_ST, 0); ;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 2041 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].intval), 0, MYSELF_ST, 0); ;}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 2043 "cfg.y"
    { (yyval.expr)=0; yyerror(" URI, SRCIP or DSTIP expected"); ;}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 2044 "cfg.y"
    { (yyval.expr)=0; yyerror ("invalid operator, == or != expected"); ;}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 2061 "cfg.y"
    { (yyval.ipnet)=mk_net((yyvsp[(1) - (3)].ipaddr), (yyvsp[(3) - (3)].ipaddr)); ;}
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 2062 "cfg.y"
    {
		if (((yyvsp[(3) - (3)].intval)<0) || ((yyvsp[(3) - (3)].intval)>(yyvsp[(1) - (3)].ipaddr)->len*8)) {
			yyerror("invalid bit number in netmask");
			(yyval.ipnet)=0;
		} else {
			(yyval.ipnet)=mk_net_bitlen((yyvsp[(1) - (3)].ipaddr), (yyvsp[(3) - (3)].intval));
		/*
			$$=mk_net($1, htonl( ($3)?~( (1<<(32-$3))-1 ):0 ) );
		*/
		}
	;}
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 2073 "cfg.y"
    { (yyval.ipnet)=mk_net_bitlen((yyvsp[(1) - (1)].ipaddr), (yyvsp[(1) - (1)].ipaddr)->len*8); ;}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 2074 "cfg.y"
    { (yyval.ipnet)=0; yyerror("netmask (eg:255.0.0.0 or 8) expected"); ;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 2078 "cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); ;}
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 2079 "cfg.y"
    {
		if ((yyvsp[(1) - (3)].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))+1);
			if ((yyval.strval)==0) {
				LOG(L_CRIT, "ERROR: cfg. parser: memory allocation"
							" failure while parsing host\n");
			} else {
				memcpy((yyval.strval), (yyvsp[(1) - (3)].strval), strlen((yyvsp[(1) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[(1) - (3)].strval))+1, (yyvsp[(3) - (3)].strval), strlen((yyvsp[(3) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))]=0;
			}
			pkg_free((yyvsp[(1) - (3)].strval));
		}
		if ((yyvsp[(3) - (3)].strval)) pkg_free((yyvsp[(3) - (3)].strval));
	;}
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 2095 "cfg.y"
    {
		if ((yyvsp[(1) - (3)].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))+1);
			if ((yyval.strval)==0) {
				LOG(L_CRIT, "ERROR: cfg. parser: memory allocation"
							" failure while parsing host\n");
			} else {
				memcpy((yyval.strval), (yyvsp[(1) - (3)].strval), strlen((yyvsp[(1) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[(1) - (3)].strval))+1, (yyvsp[(3) - (3)].strval), strlen((yyvsp[(3) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))]=0;
			}
			pkg_free((yyvsp[(1) - (3)].strval));
		}
		if ((yyvsp[(3) - (3)].strval)) pkg_free((yyvsp[(3) - (3)].strval));
	;}
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 2111 "cfg.y"
    { (yyval.strval)=0; pkg_free((yyvsp[(1) - (3)].strval)); yyerror("invalid hostname"); ;}
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 2112 "cfg.y"
    { (yyval.strval)=0; pkg_free((yyvsp[(1) - (3)].strval)); yyerror("invalid hostname"); ;}
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 2117 "cfg.y"
    {
			/* get string version */
			(yyval.strval)=pkg_malloc(strlen(yy_number_str)+1);
			if ((yyval.strval))
				strcpy((yyval.strval), yy_number_str);
		;}
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 2126 "cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); ;}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 2127 "cfg.y"
    {
		if ((yyvsp[(1) - (3)].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))+1);
			if ((yyval.strval)==0) {
				LOG(L_CRIT, "ERROR: cfg. parser: memory allocation"
							" failure while parsing host/interface name\n");
			} else {
				memcpy((yyval.strval), (yyvsp[(1) - (3)].strval), strlen((yyvsp[(1) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[(1) - (3)].strval))+1, (yyvsp[(3) - (3)].strval), strlen((yyvsp[(3) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))]=0;
			}
			pkg_free((yyvsp[(1) - (3)].strval));
		}
		if ((yyvsp[(3) - (3)].strval)) pkg_free((yyvsp[(3) - (3)].strval));
	;}
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 2143 "cfg.y"
    {
		if ((yyvsp[(1) - (3)].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))+1);
			if ((yyval.strval)==0) {
				LOG(L_CRIT, "ERROR: cfg. parser: memory allocation"
							" failure while parsing host/interface name\n");
			} else {
				memcpy((yyval.strval), (yyvsp[(1) - (3)].strval), strlen((yyvsp[(1) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[(1) - (3)].strval))+1, (yyvsp[(3) - (3)].strval), strlen((yyvsp[(3) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))]=0;
			}
			pkg_free((yyvsp[(1) - (3)].strval));
		}
		if ((yyvsp[(3) - (3)].strval)) pkg_free((yyvsp[(3) - (3)].strval));
	;}
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 2159 "cfg.y"
    { (yyval.strval)=0; pkg_free((yyvsp[(1) - (3)].strval));
								yyerror("invalid host or interface name"); ;}
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 2161 "cfg.y"
    { (yyval.strval)=0; pkg_free((yyvsp[(1) - (3)].strval));
								yyerror("invalid host or interface name"); ;}
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 2168 "cfg.y"
    {
		/* check if allowed */
		if ((yyvsp[(1) - (1)].action) && rt==ONSEND_ROUTE) {
			switch((yyvsp[(1) - (1)].action)->type) {
				case DROP_T:
				case SEND_T:
				case SEND_TCP_T:
				case LOG_T:
				case SETFLAG_T:
				case RESETFLAG_T:
				case ISFLAGSET_T:
				case IF_T:
				case MODULE_T:
				case SET_FWD_NO_CONNECT_T:
				case SET_RPL_NO_CONNECT_T:
				case SET_FWD_CLOSE_T:
				case SET_RPL_CLOSE_T:
					(yyval.action)=(yyvsp[(1) - (1)].action);
					break;
				default:
					(yyval.action)=0;
					yyerror("command not allowed in onsend_route\n");
			}
		} else {
			(yyval.action)=(yyvsp[(1) - (1)].action);
		}
	;}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 2205 "cfg.y"
    { (yyval.action)=(yyvsp[(1) - (1)].action); ;}
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 2206 "cfg.y"
    { (yyval.action)=(yyvsp[(2) - (3)].action); ;}
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 2209 "cfg.y"
    {(yyval.action)=append_action((yyvsp[(1) - (2)].action), (yyvsp[(2) - (2)].action)); ;}
    break;

  case 490:

/* Line 1455 of yacc.c  */
#line 2210 "cfg.y"
    {(yyval.action)=(yyvsp[(1) - (1)].action);;}
    break;

  case 491:

/* Line 1455 of yacc.c  */
#line 2211 "cfg.y"
    { (yyval.action)=0; yyerror("bad command"); ;}
    break;

  case 492:

/* Line 1455 of yacc.c  */
#line 2214 "cfg.y"
    {(yyval.action)=(yyvsp[(1) - (2)].action);;}
    break;

  case 493:

/* Line 1455 of yacc.c  */
#line 2215 "cfg.y"
    {(yyval.action)=(yyvsp[(1) - (1)].action);;}
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 2216 "cfg.y"
    {(yyval.action)=(yyvsp[(1) - (1)].action);;}
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 2217 "cfg.y"
    { (yyval.action)=(yyvsp[(1) - (1)].action); ;}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 2218 "cfg.y"
    { (yyval.action)=(yyvsp[(1) - (2)].action); ;}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 2219 "cfg.y"
    {(yyval.action)=(yyvsp[(1) - (2)].action);;}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 2220 "cfg.y"
    {(yyval.action)=0;;}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 2221 "cfg.y"
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); ;}
    break;

  case 500:

/* Line 1455 of yacc.c  */
#line 2224 "cfg.y"
    {
		if ((yyvsp[(2) - (3)].rv_expr) && rval_expr_int_check((yyvsp[(2) - (3)].rv_expr))>=0){
			warn_ct_rve((yyvsp[(2) - (3)].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[(2) - (3)].rv_expr), ACTIONS_ST, (yyvsp[(3) - (3)].action), NOSUBTYPE, 0);
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	;}
    break;

  case 501:

/* Line 1455 of yacc.c  */
#line 2232 "cfg.y"
    { 
		if ((yyvsp[(2) - (5)].rv_expr) && rval_expr_int_check((yyvsp[(2) - (5)].rv_expr))>=0){
			warn_ct_rve((yyvsp[(2) - (5)].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[(2) - (5)].rv_expr), ACTIONS_ST, (yyvsp[(3) - (5)].action), ACTIONS_ST, (yyvsp[(5) - (5)].action));
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	;}
    break;

  case 502:

/* Line 1455 of yacc.c  */
#line 2242 "cfg.y"
    {
			(yyval.rv_expr)=0;
			if ((yyvsp[(1) - (1)].rv_expr) && !rve_is_constant((yyvsp[(1) - (1)].rv_expr))){
				yyerror("constant expected");
				YYERROR;
			/*
			} else if ($1 &&
						!rve_check_type((enum rval_type*)&i_tmp, $1, 0, 0 ,0)){
				yyerror("invalid expression (bad type)");
			}else if ($1 && i_tmp!=RV_INT){
				yyerror("invalid expression type, int expected\n");
			*/
			}else
				(yyval.rv_expr)=(yyvsp[(1) - (1)].rv_expr);
		;}
    break;

  case 503:

/* Line 1455 of yacc.c  */
#line 2259 "cfg.y"
    {
		(yyval.case_stms)=0;
		if ((yyvsp[(2) - (4)].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[(2) - (4)].rv_expr), 0, (yyvsp[(4) - (4)].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	;}
    break;

  case 504:

/* Line 1455 of yacc.c  */
#line 2266 "cfg.y"
    {
		(yyval.case_stms)=0;
		if ((yyvsp[(3) - (5)].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[(3) - (5)].rv_expr), 1, (yyvsp[(5) - (5)].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	;}
    break;

  case 505:

/* Line 1455 of yacc.c  */
#line 2273 "cfg.y"
    {
		(yyval.case_stms)=0;
		if ((yyvsp[(2) - (3)].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[(2) - (3)].rv_expr), 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	;}
    break;

  case 506:

/* Line 1455 of yacc.c  */
#line 2280 "cfg.y"
    {
		(yyval.case_stms)=0;
		if ((yyvsp[(3) - (4)].rv_expr)==0) { yyerror ("bad regex case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[(3) - (4)].rv_expr), 1, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	;}
    break;

  case 507:

/* Line 1455 of yacc.c  */
#line 2287 "cfg.y"
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, (yyvsp[(3) - (3)].action), &i_tmp))==0) && (i_tmp=-10)){
				YYABORT;
		}
	;}
    break;

  case 508:

/* Line 1455 of yacc.c  */
#line 2292 "cfg.y"
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	;}
    break;

  case 509:

/* Line 1455 of yacc.c  */
#line 2297 "cfg.y"
    { (yyval.case_stms)=0; yyerror("bad case label"); ;}
    break;

  case 510:

/* Line 1455 of yacc.c  */
#line 2298 "cfg.y"
    { (yyval.case_stms)=0; yyerror("bad case regex label"); ;}
    break;

  case 511:

/* Line 1455 of yacc.c  */
#line 2299 "cfg.y"
    { (yyval.case_stms)=0; yyerror("bad case label"); ;}
    break;

  case 512:

/* Line 1455 of yacc.c  */
#line 2300 "cfg.y"
    { (yyval.case_stms)=0; yyerror("bad case regex label"); ;}
    break;

  case 513:

/* Line 1455 of yacc.c  */
#line 2301 "cfg.y"
    { (yyval.case_stms)=0; yyerror ("bad case body"); ;}
    break;

  case 514:

/* Line 1455 of yacc.c  */
#line 2304 "cfg.y"
    {
		(yyval.case_stms)=(yyvsp[(1) - (2)].case_stms);
		if ((yyvsp[(2) - (2)].case_stms)==0) yyerror ("bad case");
		if ((yyval.case_stms)){
			*((yyval.case_stms)->append)=(yyvsp[(2) - (2)].case_stms);
			if (*((yyval.case_stms)->append)!=0)
				(yyval.case_stms)->append=&((*((yyval.case_stms)->append))->next);
		}
	;}
    break;

  case 515:

/* Line 1455 of yacc.c  */
#line 2313 "cfg.y"
    {
		(yyval.case_stms)=(yyvsp[(1) - (1)].case_stms);
		if ((yyvsp[(1) - (1)].case_stms)==0) yyerror ("bad case");
		else (yyval.case_stms)->append=&((yyval.case_stms)->next);
	;}
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 2320 "cfg.y"
    { 
		(yyval.action)=0;
		if ((yyvsp[(2) - (5)].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else if ((yyvsp[(4) - (5)].case_stms)==0){
			yyerror ("bad switch body");
			YYERROR;
		}else if (case_check_default((yyvsp[(4) - (5)].case_stms))!=0){
			yyerror_at(&(yyvsp[(2) - (5)].rv_expr)->fpos, "bad switch(): too many "
							"\"default:\" labels\n");
			YYERROR;
		}else if (case_check_type((yyvsp[(4) - (5)].case_stms))!=0){
			yyerror_at(&(yyvsp[(2) - (5)].rv_expr)->fpos, "bad switch(): mixed integer and"
							" string/RE cases not allowed\n");
			YYERROR;
		}else{
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[(2) - (5)].rv_expr), CASE_ST, (yyvsp[(4) - (5)].case_stms));
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	;}
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 2345 "cfg.y"
    {
		(yyval.action)=0;
		warn("empty switch()");
		if ((yyvsp[(2) - (4)].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else{
			/* it might have sideffects, so leave it for the optimizer */
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[(2) - (4)].rv_expr), CASE_ST, 0);
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	;}
    break;

  case 518:

/* Line 1455 of yacc.c  */
#line 2361 "cfg.y"
    { (yyval.action)=0; yyerror ("bad expression in switch(...)"); ;}
    break;

  case 519:

/* Line 1455 of yacc.c  */
#line 2363 "cfg.y"
    {(yyval.action)=0; yyerror ("bad switch body"); ;}
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 2367 "cfg.y"
    {
		if ((yyvsp[(2) - (3)].rv_expr) && rval_expr_int_check((yyvsp[(2) - (3)].rv_expr))>=0){
			warn_ct_rve((yyvsp[(2) - (3)].rv_expr), "while");
			(yyval.action)=mk_action( WHILE_T, 2, RVE_ST, (yyvsp[(2) - (3)].rv_expr), ACTIONS_ST, (yyvsp[(3) - (3)].action));
			set_cfg_pos((yyval.action));
		}else{
			yyerror_at(&(yyvsp[(2) - (3)].rv_expr)->fpos, "bad while(...) expression");
			YYERROR;
		}
	;}
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 2386 "cfg.y"
    {
		if (sel.n >= MAX_SELECT_PARAMS-1) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[(1) - (1)].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[(1) - (1)].strval));
		sel.n++;
	;}
    break;

  case 522:

/* Line 1455 of yacc.c  */
#line 2395 "cfg.y"
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[(1) - (4)].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[(1) - (4)].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_INT;
		sel.params[sel.n].v.i = (yyvsp[(3) - (4)].intval);
		sel.n++;
	;}
    break;

  case 523:

/* Line 1455 of yacc.c  */
#line 2407 "cfg.y"
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[(1) - (4)].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[(1) - (4)].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[(3) - (4)].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[(3) - (4)].strval));
		sel.n++;
	;}
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 2426 "cfg.y"
    { sel.n = 0; sel.f[0] = 0; ;}
    break;

  case 527:

/* Line 1455 of yacc.c  */
#line 2426 "cfg.y"
    {
		sel_ptr = (select_t*)pkg_malloc(sizeof(select_t));
		if (!sel_ptr) {
			yyerror("No memory left to allocate select structure\n");
		}
		memcpy(sel_ptr, &sel, sizeof(select_t));
		(yyval.select) = sel_ptr;
	;}
    break;

  case 528:

/* Line 1455 of yacc.c  */
#line 2436 "cfg.y"
    { s_attr->type |= AVP_TRACK_FROM; ;}
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 2437 "cfg.y"
    { s_attr->type |= AVP_TRACK_TO; ;}
    break;

  case 530:

/* Line 1455 of yacc.c  */
#line 2438 "cfg.y"
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_URI; ;}
    break;

  case 531:

/* Line 1455 of yacc.c  */
#line 2439 "cfg.y"
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_URI; ;}
    break;

  case 532:

/* Line 1455 of yacc.c  */
#line 2440 "cfg.y"
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_USER; ;}
    break;

  case 533:

/* Line 1455 of yacc.c  */
#line 2441 "cfg.y"
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_USER; ;}
    break;

  case 534:

/* Line 1455 of yacc.c  */
#line 2442 "cfg.y"
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_DOMAIN; ;}
    break;

  case 535:

/* Line 1455 of yacc.c  */
#line 2443 "cfg.y"
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_DOMAIN; ;}
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 2444 "cfg.y"
    { s_attr->type |= AVP_TRACK_ALL | AVP_CLASS_GLOBAL; ;}
    break;

  case 537:

/* Line 1455 of yacc.c  */
#line 2447 "cfg.y"
    { s_attr->type |= AVP_NAME_STR; s_attr->name.s.s = (yyvsp[(1) - (1)].strval); s_attr->name.s.len = strlen ((yyvsp[(1) - (1)].strval)); ;}
    break;

  case 540:

/* Line 1455 of yacc.c  */
#line 2454 "cfg.y"
    {
		s_attr = (struct avp_spec*)pkg_malloc(sizeof(struct avp_spec));
		if (!s_attr) { yyerror("No memory left"); YYABORT; }
		else s_attr->type = 0;
	;}
    break;

  case 541:

/* Line 1455 of yacc.c  */
#line 2461 "cfg.y"
    { (yyval.attr) = s_attr; ;}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 2464 "cfg.y"
    {
		s_attr->type|= (AVP_NAME_STR | ((yyvsp[(4) - (5)].intval)<0?AVP_INDEX_BACKWARD:AVP_INDEX_FORWARD));
		s_attr->index = ((yyvsp[(4) - (5)].intval)<0?-(yyvsp[(4) - (5)].intval):(yyvsp[(4) - (5)].intval));
		(yyval.attr) = s_attr;
	;}
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 2471 "cfg.y"
    {
		s_attr->type|= AVP_INDEX_ALL;
		(yyval.attr) = s_attr;
	;}
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 2493 "cfg.y"
    {
		if ((yyvsp[(1) - (1)].lval)->type==LV_AVP){
			s_attr = pkg_malloc(sizeof(struct avp_spec));
			if (!s_attr) { yyerror("No memory left"); YYABORT; }
			else{
				*s_attr=(yyvsp[(1) - (1)].lval)->lv.avps;
			}
			(yyval.attr)=s_attr;
		}else
			(yyval.attr)=0; /* not an avp, a pvar */
		pkg_free((yyvsp[(1) - (1)].lval));
	;}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 2505 "cfg.y"
    {
		avp_spec_t *avp_spec;
		str s;
		int type, idx;
		avp_spec = pkg_malloc(sizeof(*avp_spec));
		if (!avp_spec) {
			yyerror("Not enough memory");
			YYABORT;
		}
		s.s = (yyvsp[(1) - (1)].strval);
		if (s.s[0] == '$')
			s.s++;
		s.len = strlen(s.s);
		if (parse_avp_name(&s, &type, &avp_spec->name, &idx)) {
			yyerror("error when parsing AVP");
			pkg_free(avp_spec);
			YYABORT;
		}
		avp_spec->type = type;
		avp_spec->index = idx;
		(yyval.attr) = avp_spec;
	;}
    break;

  case 552:

/* Line 1455 of yacc.c  */
#line 2529 "cfg.y"
    {
			pv_spec=pkg_malloc(sizeof(*pv_spec));
			if (!pv_spec) {
				yyerror("Not enough memory");
				YYABORT;
			}
			memset(pv_spec, 0, sizeof(*pv_spec));
			s_tmp.s=(yyvsp[(1) - (1)].strval); s_tmp.len=strlen((yyvsp[(1) - (1)].strval));
			if (pv_parse_spec(&s_tmp, pv_spec)==0){
				yyerror("unknown script pseudo variable %s", (yyvsp[(1) - (1)].strval) );
				pkg_free(pv_spec);
				pv_spec=0;
				YYABORT;
			}
			(yyval.pvar)=pv_spec;
		;}
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 2547 "cfg.y"
    {
				lval_tmp=pkg_malloc(sizeof(*lval_tmp));
				if (!lval_tmp) {
					yyerror("Not enough memory");
					YYABORT;
				}
				memset(lval_tmp, 0, sizeof(*lval_tmp));
				s_tmp.s=(yyvsp[(1) - (1)].strval); s_tmp.len=strlen(s_tmp.s);
				if (pv_parse_spec2(&s_tmp, &lval_tmp->lv.pvs, 1)==0){
					/* not a pvar, try avps */
					/* lval_tmp might be partially filled by the failed
					   pv_parse_spec2() (especially if the avp name is the
					   same as a pv class) => clean it again */
					memset(lval_tmp, 0, sizeof(*lval_tmp));
					lval_tmp->lv.avps.type|= AVP_NAME_STR;
					lval_tmp->lv.avps.name.s.s = s_tmp.s+1;
					lval_tmp->lv.avps.name.s.len = s_tmp.len-1;
					lval_tmp->type=LV_AVP;
				}else{
					lval_tmp->type=LV_PVAR;
				}
				(yyval.lval) = lval_tmp;
				DBG("parsed ambigous avp/pvar \"%.*s\" to %d\n",
							s_tmp.len, s_tmp.s, lval_tmp->type);
			;}
    break;

  case 554:

/* Line 1455 of yacc.c  */
#line 2582 "cfg.y"
    { (yyval.intval) = ASSIGN_T; ;}
    break;

  case 555:

/* Line 1455 of yacc.c  */
#line 2586 "cfg.y"
    {
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_AVP; lval_tmp->lv.avps=*(yyvsp[(1) - (1)].attr);
					pkg_free((yyvsp[(1) - (1)].attr)); /* free the avp spec we just copied */
					(yyval.lval)=lval_tmp;
				;}
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 2596 "cfg.y"
    {
					if (!pv_is_w((yyvsp[(1) - (1)].pvar)))
						yyerror("read only pvar in assignment left side");
					if ((yyvsp[(1) - (1)].pvar)->trans!=0)
						yyerror("pvar with transformations in assignment"
								" left side");
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_PVAR; lval_tmp->lv.pvs=*((yyvsp[(1) - (1)].pvar));
					pkg_free((yyvsp[(1) - (1)].pvar)); /* free the pvar spec we just copied */
					(yyval.lval)=lval_tmp;
				;}
    break;

  case 557:

/* Line 1455 of yacc.c  */
#line 2611 "cfg.y"
    {
					if (((yyvsp[(1) - (1)].lval))->type==LV_PVAR){
						if (!pv_is_w(&((yyvsp[(1) - (1)].lval))->lv.pvs))
							yyerror("read only pvar in assignment left side");
						if ((yyvsp[(1) - (1)].lval)->lv.pvs.trans!=0)
							yyerror("pvar with transformations in assignment"
									" left side");
					}
					(yyval.lval)=(yyvsp[(1) - (1)].lval);
				;}
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 2623 "cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_INT, (void*)(yyvsp[(1) - (1)].intval)); ;}
    break;

  case 559:

/* Line 1455 of yacc.c  */
#line 2624 "cfg.y"
    {	s_tmp.s=(yyvsp[(1) - (1)].strval); s_tmp.len=strlen((yyvsp[(1) - (1)].strval));
							(yyval.rv_expr)=mk_rve_rval(RV_STR, &s_tmp); ;}
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 2626 "cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_AVP, (yyvsp[(1) - (1)].attr)); pkg_free((yyvsp[(1) - (1)].attr)); ;}
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 2627 "cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[(1) - (1)].pvar)); pkg_free((yyvsp[(1) - (1)].pvar)); ;}
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 2628 "cfg.y"
    {
							switch((yyvsp[(1) - (1)].lval)->type){
								case LV_AVP:
									(yyval.rv_expr)=mk_rve_rval(RV_AVP, &(yyvsp[(1) - (1)].lval)->lv.avps);
									break;
								case LV_PVAR:
									(yyval.rv_expr)=mk_rve_rval(RV_PVAR, &(yyvsp[(1) - (1)].lval)->lv.pvs);
									break;
								default:
									yyerror("BUG: invalid lvalue type ");
									YYABORT;
							}
							pkg_free((yyvsp[(1) - (1)].lval)); /* not needed anymore */
						;}
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 2642 "cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_SEL, (yyvsp[(1) - (1)].select)); pkg_free((yyvsp[(1) - (1)].select)); ;}
    break;

  case 564:

/* Line 1455 of yacc.c  */
#line 2643 "cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[(1) - (1)].action)); ;}
    break;

  case 565:

/* Line 1455 of yacc.c  */
#line 2644 "cfg.y"
    { (yyval.rv_expr)=mk_rve_rval(RV_BEXPR, (yyvsp[(1) - (1)].expr)); ;}
    break;

  case 566:

/* Line 1455 of yacc.c  */
#line 2645 "cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[(2) - (3)].action)); ;}
    break;

  case 567:

/* Line 1455 of yacc.c  */
#line 2646 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad command block"); ;}
    break;

  case 568:

/* Line 1455 of yacc.c  */
#line 2647 "cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[(2) - (3)].action)); ;}
    break;

  case 569:

/* Line 1455 of yacc.c  */
#line 2648 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 2652 "cfg.y"
    { (yyval.intval)=RVE_LNOT_OP; ;}
    break;

  case 571:

/* Line 1455 of yacc.c  */
#line 2653 "cfg.y"
    { (yyval.intval)=RVE_UMINUS_OP; ;}
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 2666 "cfg.y"
    { (yyval.rv_expr)=(yyvsp[(1) - (1)].rv_expr);
										if ((yyval.rv_expr)==0){
											/*yyerror("out of memory\n");*/
											YYERROR;
										}
									;}
    break;

  case 573:

/* Line 1455 of yacc.c  */
#line 2672 "cfg.y"
    {(yyval.rv_expr)=mk_rve1((yyvsp[(1) - (2)].intval), (yyvsp[(2) - (2)].rv_expr)); ;}
    break;

  case 574:

/* Line 1455 of yacc.c  */
#line 2673 "cfg.y"
    {(yyval.rv_expr)=mk_rve1(RVE_INT_OP, (yyvsp[(2) - (2)].rv_expr)); ;}
    break;

  case 575:

/* Line 1455 of yacc.c  */
#line 2674 "cfg.y"
    {(yyval.rv_expr)=mk_rve1(RVE_STR_OP, (yyvsp[(2) - (2)].rv_expr)); ;}
    break;

  case 576:

/* Line 1455 of yacc.c  */
#line 2675 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_PLUS_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr)); ;}
    break;

  case 577:

/* Line 1455 of yacc.c  */
#line 2676 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_MINUS_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr)); ;}
    break;

  case 578:

/* Line 1455 of yacc.c  */
#line 2677 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_MUL_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr)); ;}
    break;

  case 579:

/* Line 1455 of yacc.c  */
#line 2678 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_DIV_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr)); ;}
    break;

  case 580:

/* Line 1455 of yacc.c  */
#line 2679 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_MOD_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr)); ;}
    break;

  case 581:

/* Line 1455 of yacc.c  */
#line 2680 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_BOR_OP, (yyvsp[(1) - (3)].rv_expr),  (yyvsp[(3) - (3)].rv_expr)); ;}
    break;

  case 582:

/* Line 1455 of yacc.c  */
#line 2681 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_BAND_OP, (yyvsp[(1) - (3)].rv_expr),  (yyvsp[(3) - (3)].rv_expr));;}
    break;

  case 583:

/* Line 1455 of yacc.c  */
#line 2682 "cfg.y"
    { (yyval.rv_expr)=mk_rve2( (yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr));;}
    break;

  case 584:

/* Line 1455 of yacc.c  */
#line 2684 "cfg.y"
    { (yyval.rv_expr)=mk_rve2( (yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr));;}
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 2685 "cfg.y"
    { (yyval.rv_expr)=mk_rve2(RVE_LAND_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr));;}
    break;

  case 586:

/* Line 1455 of yacc.c  */
#line 2686 "cfg.y"
    { (yyval.rv_expr)=mk_rve2(RVE_LOR_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr));;}
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 2687 "cfg.y"
    { (yyval.rv_expr)=(yyvsp[(2) - (3)].rv_expr);;}
    break;

  case 588:

/* Line 1455 of yacc.c  */
#line 2688 "cfg.y"
    { (yyval.rv_expr)=mk_rve1(RVE_STRLEN_OP, (yyvsp[(3) - (4)].rv_expr));;}
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 2689 "cfg.y"
    {(yyval.rv_expr)=mk_rve1(RVE_STREMPTY_OP, (yyvsp[(3) - (4)].rv_expr));;}
    break;

  case 590:

/* Line 1455 of yacc.c  */
#line 2690 "cfg.y"
    { (yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[(2) - (2)].rv_expr));;}
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 2691 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 592:

/* Line 1455 of yacc.c  */
#line 2692 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 2693 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 594:

/* Line 1455 of yacc.c  */
#line 2694 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 2695 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 2696 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 2697 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 2698 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 2699 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 2700 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 601:

/* Line 1455 of yacc.c  */
#line 2702 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 602:

/* Line 1455 of yacc.c  */
#line 2704 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 603:

/* Line 1455 of yacc.c  */
#line 2705 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 604:

/* Line 1455 of yacc.c  */
#line 2706 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 605:

/* Line 1455 of yacc.c  */
#line 2707 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 606:

/* Line 1455 of yacc.c  */
#line 2708 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 607:

/* Line 1455 of yacc.c  */
#line 2709 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 608:

/* Line 1455 of yacc.c  */
#line 2712 "cfg.y"
    { (yyval.action)=mk_action((yyvsp[(2) - (3)].intval), 2, LVAL_ST, (yyvsp[(1) - (3)].lval), 
														 	  RVE_ST, (yyvsp[(3) - (3)].rv_expr));
											set_cfg_pos((yyval.action));
										;}
    break;

  case 609:

/* Line 1455 of yacc.c  */
#line 2730 "cfg.y"
    { (yyval.intval) = 1; ;}
    break;

  case 610:

/* Line 1455 of yacc.c  */
#line 2731 "cfg.y"
    { (yyval.intval) = 0; ;}
    break;

  case 611:

/* Line 1455 of yacc.c  */
#line 2732 "cfg.y"
    { (yyval.intval) = -1; ;}
    break;

  case 612:

/* Line 1455 of yacc.c  */
#line 2735 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 613:

/* Line 1455 of yacc.c  */
#line 2736 "cfg.y"
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 614:

/* Line 1455 of yacc.c  */
#line 2737 "cfg.y"
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 615:

/* Line 1455 of yacc.c  */
#line 2738 "cfg.y"
    { (yyval.action)=mk_action(	FORWARD_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 616:

/* Line 1455 of yacc.c  */
#line 2739 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 617:

/* Line 1455 of yacc.c  */
#line 2740 "cfg.y"
    {(yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 618:

/* Line 1455 of yacc.c  */
#line 2741 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 619:

/* Line 1455 of yacc.c  */
#line 2742 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 620:

/* Line 1455 of yacc.c  */
#line 2743 "cfg.y"
    {(yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 621:

/* Line 1455 of yacc.c  */
#line 2744 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 622:

/* Line 1455 of yacc.c  */
#line 2745 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 623:

/* Line 1455 of yacc.c  */
#line 2746 "cfg.y"
    { (yyval.action)=0; yyerror("bad forward argument"); ;}
    break;

  case 624:

/* Line 1455 of yacc.c  */
#line 2747 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 625:

/* Line 1455 of yacc.c  */
#line 2748 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 626:

/* Line 1455 of yacc.c  */
#line 2749 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 627:

/* Line 1455 of yacc.c  */
#line 2750 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 628:

/* Line 1455 of yacc.c  */
#line 2751 "cfg.y"
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 629:

/* Line 1455 of yacc.c  */
#line 2752 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 630:

/* Line 1455 of yacc.c  */
#line 2753 "cfg.y"
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 631:

/* Line 1455 of yacc.c  */
#line 2754 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 632:

/* Line 1455 of yacc.c  */
#line 2755 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 633:

/* Line 1455 of yacc.c  */
#line 2756 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 634:

/* Line 1455 of yacc.c  */
#line 2757 "cfg.y"
    { (yyval.action)=0; yyerror("bad forward_udp argument"); ;}
    break;

  case 635:

/* Line 1455 of yacc.c  */
#line 2758 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 636:

/* Line 1455 of yacc.c  */
#line 2759 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 637:

/* Line 1455 of yacc.c  */
#line 2760 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 638:

/* Line 1455 of yacc.c  */
#line 2761 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 639:

/* Line 1455 of yacc.c  */
#line 2762 "cfg.y"
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 640:

/* Line 1455 of yacc.c  */
#line 2763 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 641:

/* Line 1455 of yacc.c  */
#line 2764 "cfg.y"
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 642:

/* Line 1455 of yacc.c  */
#line 2765 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 643:

/* Line 1455 of yacc.c  */
#line 2766 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 644:

/* Line 1455 of yacc.c  */
#line 2767 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 645:

/* Line 1455 of yacc.c  */
#line 2768 "cfg.y"
    { (yyval.action)=0; yyerror("bad forward_tcp argument"); ;}
    break;

  case 646:

/* Line 1455 of yacc.c  */
#line 2769 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 647:

/* Line 1455 of yacc.c  */
#line 2777 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 648:

/* Line 1455 of yacc.c  */
#line 2785 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 649:

/* Line 1455 of yacc.c  */
#line 2793 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 650:

/* Line 1455 of yacc.c  */
#line 2801 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 651:

/* Line 1455 of yacc.c  */
#line 2809 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
					;}
    break;

  case 652:

/* Line 1455 of yacc.c  */
#line 2817 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 653:

/* Line 1455 of yacc.c  */
#line 2825 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 654:

/* Line 1455 of yacc.c  */
#line 2833 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 655:

/* Line 1455 of yacc.c  */
#line 2841 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 656:

/* Line 1455 of yacc.c  */
#line 2842 "cfg.y"
    { (yyval.action)=0; 
									yyerror("bad forward_tls argument"); ;}
    break;

  case 657:

/* Line 1455 of yacc.c  */
#line 2844 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	;}
    break;

  case 658:

/* Line 1455 of yacc.c  */
#line 2852 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	;}
    break;

  case 659:

/* Line 1455 of yacc.c  */
#line 2860 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	;}
    break;

  case 660:

/* Line 1455 of yacc.c  */
#line 2868 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST,
							(void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	;}
    break;

  case 661:

/* Line 1455 of yacc.c  */
#line 2877 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST,
							(void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	;}
    break;

  case 662:

/* Line 1455 of yacc.c  */
#line 2886 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, 
							(void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
					;}
    break;

  case 663:

/* Line 1455 of yacc.c  */
#line 2895 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	;}
    break;

  case 664:

/* Line 1455 of yacc.c  */
#line 2903 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST,
							(void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	;}
    break;

  case 665:

/* Line 1455 of yacc.c  */
#line 2912 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 666:

/* Line 1455 of yacc.c  */
#line 2920 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 667:

/* Line 1455 of yacc.c  */
#line 2921 "cfg.y"
    { (yyval.action)=0; 
									yyerror("bad forward_tls argument"); ;}
    break;

  case 668:

/* Line 1455 of yacc.c  */
#line 2923 "cfg.y"
    { (yyval.action)=mk_action(SEND_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 669:

/* Line 1455 of yacc.c  */
#line 2924 "cfg.y"
    { (yyval.action)=mk_action(SEND_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 670:

/* Line 1455 of yacc.c  */
#line 2925 "cfg.y"
    { (yyval.action)=mk_action(SEND_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 671:

/* Line 1455 of yacc.c  */
#line 2926 "cfg.y"
    { (yyval.action)=mk_action(SEND_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 672:

/* Line 1455 of yacc.c  */
#line 2927 "cfg.y"
    {(yyval.action)=mk_action(SEND_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 673:

/* Line 1455 of yacc.c  */
#line 2928 "cfg.y"
    { (yyval.action)=mk_action(SEND_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 674:

/* Line 1455 of yacc.c  */
#line 2929 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 675:

/* Line 1455 of yacc.c  */
#line 2930 "cfg.y"
    { (yyval.action)=0; yyerror("bad send argument"); ;}
    break;

  case 676:

/* Line 1455 of yacc.c  */
#line 2931 "cfg.y"
    { (yyval.action)=mk_action(SEND_TCP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 677:

/* Line 1455 of yacc.c  */
#line 2932 "cfg.y"
    { (yyval.action)=mk_action(SEND_TCP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 678:

/* Line 1455 of yacc.c  */
#line 2933 "cfg.y"
    { (yyval.action)=mk_action(SEND_TCP_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 679:

/* Line 1455 of yacc.c  */
#line 2934 "cfg.y"
    { (yyval.action)=mk_action(	SEND_TCP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));;}
    break;

  case 680:

/* Line 1455 of yacc.c  */
#line 2935 "cfg.y"
    {(yyval.action)=mk_action(SEND_TCP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 681:

/* Line 1455 of yacc.c  */
#line 2936 "cfg.y"
    { (yyval.action)=mk_action(SEND_TCP_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 682:

/* Line 1455 of yacc.c  */
#line 2937 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 683:

/* Line 1455 of yacc.c  */
#line 2938 "cfg.y"
    { (yyval.action)=0; yyerror("bad send_tcp argument"); ;}
    break;

  case 684:

/* Line 1455 of yacc.c  */
#line 2939 "cfg.y"
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST,
										(void*)(L_DBG+1), STRING_ST, (yyvsp[(3) - (4)].strval));
									set_cfg_pos((yyval.action)); ;}
    break;

  case 685:

/* Line 1455 of yacc.c  */
#line 2942 "cfg.y"
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST, (void*)(yyvsp[(3) - (6)].intval), STRING_ST, (yyvsp[(5) - (6)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 686:

/* Line 1455 of yacc.c  */
#line 2943 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 687:

/* Line 1455 of yacc.c  */
#line 2944 "cfg.y"
    { (yyval.action)=0; yyerror("bad log argument"); ;}
    break;

  case 688:

/* Line 1455 of yacc.c  */
#line 2945 "cfg.y"
    {
							if (check_flag((yyvsp[(3) - (4)].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
													(void*)(yyvsp[(3) - (4)].intval));
							set_cfg_pos((yyval.action));
									;}
    break;

  case 689:

/* Line 1455 of yacc.c  */
#line 2952 "cfg.y"
    {
							i_tmp=get_flag_no((yyvsp[(3) - (4)].strval), strlen((yyvsp[(3) - (4)].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									;}
    break;

  case 690:

/* Line 1455 of yacc.c  */
#line 2959 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); ;}
    break;

  case 691:

/* Line 1455 of yacc.c  */
#line 2960 "cfg.y"
    {
							if (check_flag((yyvsp[(3) - (4)].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST, (void*)(yyvsp[(3) - (4)].intval));
							set_cfg_pos((yyval.action));
									;}
    break;

  case 692:

/* Line 1455 of yacc.c  */
#line 2966 "cfg.y"
    {
							i_tmp=get_flag_no((yyvsp[(3) - (4)].strval), strlen((yyvsp[(3) - (4)].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									;}
    break;

  case 693:

/* Line 1455 of yacc.c  */
#line 2973 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); ;}
    break;

  case 694:

/* Line 1455 of yacc.c  */
#line 2974 "cfg.y"
    {
							if (check_flag((yyvsp[(3) - (4)].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST, (void*)(yyvsp[(3) - (4)].intval));
							set_cfg_pos((yyval.action));
									;}
    break;

  case 695:

/* Line 1455 of yacc.c  */
#line 2980 "cfg.y"
    {
							i_tmp=get_flag_no((yyvsp[(3) - (4)].strval), strlen((yyvsp[(3) - (4)].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									;}
    break;

  case 696:

/* Line 1455 of yacc.c  */
#line 2987 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); ;}
    break;

  case 697:

/* Line 1455 of yacc.c  */
#line 2988 "cfg.y"
    {
		i_tmp=get_avpflag_no((yyvsp[(5) - (6)].strval));
		if (i_tmp==0) yyerror("avpflag not declared");
		(yyval.action)=mk_action(AVPFLAG_OPER_T, 3, AVP_ST, (yyvsp[(3) - (6)].attr), NUMBER_ST, (void*)(long)i_tmp, NUMBER_ST, (void*)(yyvsp[(1) - (6)].intval));
		set_cfg_pos((yyval.action));
	;}
    break;

  case 698:

/* Line 1455 of yacc.c  */
#line 2994 "cfg.y"
    {
		(yyval.action)=0; yyerror("error parsing flag name");
	;}
    break;

  case 699:

/* Line 1455 of yacc.c  */
#line 2997 "cfg.y"
    {
		(yyval.action)=0; yyerror("error parsing first parameter (avp or string)");
	;}
    break;

  case 700:

/* Line 1455 of yacc.c  */
#line 3000 "cfg.y"
    { (yyval.action)=0; yyerror("bad parameters"); ;}
    break;

  case 701:

/* Line 1455 of yacc.c  */
#line 3001 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); ;}
    break;

  case 702:

/* Line 1455 of yacc.c  */
#line 3002 "cfg.y"
    {(yyval.action)=mk_action(ERROR_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), STRING_ST, (yyvsp[(5) - (6)].strval));
			set_cfg_pos((yyval.action));
	;}
    break;

  case 703:

/* Line 1455 of yacc.c  */
#line 3005 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 704:

/* Line 1455 of yacc.c  */
#line 3006 "cfg.y"
    { (yyval.action)=0; yyerror("bad error argument"); ;}
    break;

  case 705:

/* Line 1455 of yacc.c  */
#line 3007 "cfg.y"
    {
						i_tmp=route_get(&main_rt, (yyvsp[(3) - (4)].strval));
						if (i_tmp==-1){
							yyerror("internal error");
							YYABORT;
						}
						(yyval.action)=mk_action(ROUTE_T, 1, NUMBER_ST,(void*)(long)i_tmp);
						set_cfg_pos((yyval.action));
										;}
    break;

  case 706:

/* Line 1455 of yacc.c  */
#line 3016 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 707:

/* Line 1455 of yacc.c  */
#line 3017 "cfg.y"
    { (yyval.action)=0; yyerror("bad route argument"); ;}
    break;

  case 708:

/* Line 1455 of yacc.c  */
#line 3018 "cfg.y"
    { (yyval.action)=mk_action(EXEC_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 709:

/* Line 1455 of yacc.c  */
#line 3019 "cfg.y"
    { (yyval.action)=mk_action(SET_HOST_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 710:

/* Line 1455 of yacc.c  */
#line 3020 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 711:

/* Line 1455 of yacc.c  */
#line 3021 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 712:

/* Line 1455 of yacc.c  */
#line 3022 "cfg.y"
    { (yyval.action)=mk_action(PREFIX_T, 1, STRING_ST,  (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 713:

/* Line 1455 of yacc.c  */
#line 3023 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 714:

/* Line 1455 of yacc.c  */
#line 3024 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 715:

/* Line 1455 of yacc.c  */
#line 3025 "cfg.y"
    { (yyval.action)=mk_action(STRIP_TAIL_T, 1, NUMBER_ST, (void*)(yyvsp[(3) - (4)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 716:

/* Line 1455 of yacc.c  */
#line 3026 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 717:

/* Line 1455 of yacc.c  */
#line 3027 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, number expected"); ;}
    break;

  case 718:

/* Line 1455 of yacc.c  */
#line 3028 "cfg.y"
    { (yyval.action)=mk_action(STRIP_T, 1, NUMBER_ST, (void*) (yyvsp[(3) - (4)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 719:

/* Line 1455 of yacc.c  */
#line 3029 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 720:

/* Line 1455 of yacc.c  */
#line 3030 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, number expected"); ;}
    break;

  case 721:

/* Line 1455 of yacc.c  */
#line 3031 "cfg.y"
    { (yyval.action)=mk_action(SET_USERPHONE_T, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 722:

/* Line 1455 of yacc.c  */
#line 3032 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 723:

/* Line 1455 of yacc.c  */
#line 3033 "cfg.y"
    {
		qvalue_t q;
		if (str2q(&q, (yyvsp[(5) - (6)].strval), strlen((yyvsp[(5) - (6)].strval))) < 0) {
			yyerror("bad argument, q value expected");
		}
		(yyval.action)=mk_action(APPEND_BRANCH_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void *)(long)q);
		set_cfg_pos((yyval.action));
	;}
    break;

  case 724:

/* Line 1455 of yacc.c  */
#line 3041 "cfg.y"
    { (yyval.action)=mk_action(APPEND_BRANCH_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, (void *)Q_UNSPECIFIED); set_cfg_pos((yyval.action)); ;}
    break;

  case 725:

/* Line 1455 of yacc.c  */
#line 3042 "cfg.y"
    { (yyval.action)=mk_action(APPEND_BRANCH_T, 2, STRING_ST, 0, NUMBER_ST, (void *)Q_UNSPECIFIED); set_cfg_pos((yyval.action)); ;}
    break;

  case 726:

/* Line 1455 of yacc.c  */
#line 3043 "cfg.y"
    {  (yyval.action)=mk_action( APPEND_BRANCH_T, 1, STRING_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 727:

/* Line 1455 of yacc.c  */
#line 3044 "cfg.y"
    { (yyval.action)=mk_action(SET_HOSTPORT_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 728:

/* Line 1455 of yacc.c  */
#line 3045 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 729:

/* Line 1455 of yacc.c  */
#line 3046 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 730:

/* Line 1455 of yacc.c  */
#line 3047 "cfg.y"
    { (yyval.action)=mk_action(SET_HOSTPORTTRANS_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 731:

/* Line 1455 of yacc.c  */
#line 3048 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 732:

/* Line 1455 of yacc.c  */
#line 3049 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 733:

/* Line 1455 of yacc.c  */
#line 3050 "cfg.y"
    { (yyval.action)=mk_action(SET_PORT_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 734:

/* Line 1455 of yacc.c  */
#line 3051 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 735:

/* Line 1455 of yacc.c  */
#line 3052 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 736:

/* Line 1455 of yacc.c  */
#line 3053 "cfg.y"
    { (yyval.action)=mk_action(SET_USER_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 737:

/* Line 1455 of yacc.c  */
#line 3054 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 738:

/* Line 1455 of yacc.c  */
#line 3055 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 739:

/* Line 1455 of yacc.c  */
#line 3056 "cfg.y"
    { (yyval.action)=mk_action(SET_USERPASS_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 740:

/* Line 1455 of yacc.c  */
#line 3057 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 741:

/* Line 1455 of yacc.c  */
#line 3058 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 742:

/* Line 1455 of yacc.c  */
#line 3059 "cfg.y"
    { (yyval.action)=mk_action(SET_URI_T, 1, STRING_ST,(yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 743:

/* Line 1455 of yacc.c  */
#line 3060 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 744:

/* Line 1455 of yacc.c  */
#line 3061 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 745:

/* Line 1455 of yacc.c  */
#line 3062 "cfg.y"
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 746:

/* Line 1455 of yacc.c  */
#line 3063 "cfg.y"
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 747:

/* Line 1455 of yacc.c  */
#line 3064 "cfg.y"
    { (yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 748:

/* Line 1455 of yacc.c  */
#line 3065 "cfg.y"
    {(yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 749:

/* Line 1455 of yacc.c  */
#line 3066 "cfg.y"
    { (yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 750:

/* Line 1455 of yacc.c  */
#line 3067 "cfg.y"
    {(yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 751:

/* Line 1455 of yacc.c  */
#line 3068 "cfg.y"
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 1, NUMBER_ST, (void*)(yyvsp[(3) - (4)].intval));
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	;}
    break;

  case 752:

/* Line 1455 of yacc.c  */
#line 3076 "cfg.y"
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	;}
    break;

  case 753:

/* Line 1455 of yacc.c  */
#line 3084 "cfg.y"
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	;}
    break;

  case 754:

/* Line 1455 of yacc.c  */
#line 3092 "cfg.y"
    {(yyval.action)=0; yyerror("bad argument, number expected"); ;}
    break;

  case 755:

/* Line 1455 of yacc.c  */
#line 3094 "cfg.y"
    { (yyval.action)=mk_action(UDP_MTU_TRY_PROTO_T, 1, NUMBER_ST, (yyvsp[(3) - (4)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 756:

/* Line 1455 of yacc.c  */
#line 3096 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, UDP, TCP, TLS or SCTP expected"); ;}
    break;

  case 757:

/* Line 1455 of yacc.c  */
#line 3097 "cfg.y"
    {
		(yyval.action)=0;
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			LOG(L_CRIT, "ERROR: cfg. parser: out of memory.\n");
		} else {
			str_tmp->s=(yyvsp[(3) - (4)].strval);
			str_tmp->len=(yyvsp[(3) - (4)].strval)?strlen((yyvsp[(3) - (4)].strval)):0;
			(yyval.action)=mk_action(SET_ADV_ADDR_T, 1, STR_ST, str_tmp);
			set_cfg_pos((yyval.action));
		}
	;}
    break;

  case 758:

/* Line 1455 of yacc.c  */
#line 3108 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 759:

/* Line 1455 of yacc.c  */
#line 3109 "cfg.y"
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 760:

/* Line 1455 of yacc.c  */
#line 3110 "cfg.y"
    {
		(yyval.action)=0;
		tmp=int2str((yyvsp[(3) - (4)].intval), &i_tmp);
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			LOG(L_CRIT, "ERROR: cfg. parser: out of memory.\n");
		} else {
			if ((str_tmp->s=pkg_malloc(i_tmp))==0) {
				LOG(L_CRIT, "ERROR: cfg. parser: out of memory.\n");
			} else {
				memcpy(str_tmp->s, tmp, i_tmp);
				str_tmp->len=i_tmp;
				(yyval.action)=mk_action(SET_ADV_PORT_T, 1, STR_ST, str_tmp);
				set_cfg_pos((yyval.action));
			}
		}
	;}
    break;

  case 761:

/* Line 1455 of yacc.c  */
#line 3126 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 762:

/* Line 1455 of yacc.c  */
#line 3127 "cfg.y"
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 763:

/* Line 1455 of yacc.c  */
#line 3128 "cfg.y"
    { 
		(yyval.action)=mk_action(FORCE_SEND_SOCKET_T, 1, SOCKID_ST, (yyvsp[(3) - (4)].sockid));
		set_cfg_pos((yyval.action));
	;}
    break;

  case 764:

/* Line 1455 of yacc.c  */
#line 3132 "cfg.y"
    {
		(yyval.action)=0; yyerror("bad argument, [proto:]host[:port] expected");
	;}
    break;

  case 765:

/* Line 1455 of yacc.c  */
#line 3135 "cfg.y"
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 766:

/* Line 1455 of yacc.c  */
#line 3136 "cfg.y"
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 767:

/* Line 1455 of yacc.c  */
#line 3139 "cfg.y"
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 768:

/* Line 1455 of yacc.c  */
#line 3142 "cfg.y"
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 769:

/* Line 1455 of yacc.c  */
#line 3145 "cfg.y"
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 770:

/* Line 1455 of yacc.c  */
#line 3148 "cfg.y"
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 771:

/* Line 1455 of yacc.c  */
#line 3151 "cfg.y"
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 772:

/* Line 1455 of yacc.c  */
#line 3154 "cfg.y"
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 773:

/* Line 1455 of yacc.c  */
#line 3157 "cfg.y"
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 774:

/* Line 1455 of yacc.c  */
#line 3160 "cfg.y"
    {mod_func_action = mk_action(MODULE_T, 2, MODEXP_ST, NULL, NUMBER_ST,
			0); ;}
    break;

  case 775:

/* Line 1455 of yacc.c  */
#line 3161 "cfg.y"
    {
		mod_func_action->val[0].u.data = 
			find_export_record((yyvsp[(1) - (5)].strval), mod_func_action->val[1].u.number, rt,
								&u_tmp);
		if (mod_func_action->val[0].u.data == 0) {
			if (find_export_record((yyvsp[(1) - (5)].strval), mod_func_action->val[1].u.number, 0,
									&u_tmp) ) {
					yyerror("Command cannot be used in the block\n");
			} else {
				yyerror("unknown command, missing loadmodule?\n");
			}
			pkg_free(mod_func_action);
			mod_func_action=0;
		}else{
			switch( ((union cmd_export_u*)
						mod_func_action->val[0].u.data)->c.param_no){
				case 0:
				case 1:
				case 2:
					/* MODULE_T used for 0-2 params */
					break;
				case 3:
					mod_func_action->type=MODULE3_T;
					break;
				case 4:
					mod_func_action->type=MODULE4_T;
					break;
				case 5:
					mod_func_action->type=MODULE5_T;
					break;
				case 6:
					mod_func_action->type=MODULE6_T;
					break;
				case VAR_PARAM_NO:
					mod_func_action->type=MODULEX_T;
					break;
				default:
					yyerror("too many parameters for function\n");
					break;
			}
		}
		(yyval.action) = mod_func_action;
		set_cfg_pos((yyval.action));
	;}
    break;

  case 776:

/* Line 1455 of yacc.c  */
#line 3205 "cfg.y"
    { yyerror("'('')' expected (function call)");;}
    break;

  case 778:

/* Line 1455 of yacc.c  */
#line 3209 "cfg.y"
    { ;}
    break;

  case 779:

/* Line 1455 of yacc.c  */
#line 3210 "cfg.y"
    {;}
    break;

  case 780:

/* Line 1455 of yacc.c  */
#line 3211 "cfg.y"
    { yyerror("call params error\n"); ;}
    break;

  case 781:

/* Line 1455 of yacc.c  */
#line 3214 "cfg.y"
    {
		if (mod_func_action->val[1].u.number < MAX_ACTIONS-2) {
			mod_func_action->val[mod_func_action->val[1].u.number+2].type =
				NUMBER_ST;
			mod_func_action->val[mod_func_action->val[1].u.number+2].u.number =
				(yyvsp[(1) - (1)].intval);
			mod_func_action->val[1].u.number++;
		} else {
			yyerror("Too many arguments\n");
		}
	;}
    break;

  case 782:

/* Line 1455 of yacc.c  */
#line 3225 "cfg.y"
    {
		if (mod_func_action->val[1].u.number < MAX_ACTIONS-2) {
			mod_func_action->val[mod_func_action->val[1].u.number+2].type = STRING_ST;
			mod_func_action->val[mod_func_action->val[1].u.number+2].u.string = (yyvsp[(1) - (1)].strval);
			mod_func_action->val[1].u.number++;
		} else {
			yyerror("Too many arguments\n");
		}
	;}
    break;

  case 783:

/* Line 1455 of yacc.c  */
#line 3237 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	;}
    break;

  case 784:

/* Line 1455 of yacc.c  */
#line 3241 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[(2) - (2)].rv_expr), NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	;}
    break;

  case 785:

/* Line 1455 of yacc.c  */
#line 3245 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, 
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	;}
    break;

  case 786:

/* Line 1455 of yacc.c  */
#line 3249 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, (void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	;}
    break;

  case 787:

/* Line 1455 of yacc.c  */
#line 3253 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[(2) - (2)].rv_expr), NUMBER_ST, (void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	;}
    break;

  case 788:

/* Line 1455 of yacc.c  */
#line 3257 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, (void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	;}
    break;

  case 789:

/* Line 1455 of yacc.c  */
#line 3261 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	;}
    break;

  case 790:

/* Line 1455 of yacc.c  */
#line 3265 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	;}
    break;

  case 791:

/* Line 1455 of yacc.c  */
#line 3269 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[(2) - (2)].rv_expr), NUMBER_ST, (void*)RETURN_R_F);
		set_cfg_pos((yyval.action));
	;}
    break;

  case 792:

/* Line 1455 of yacc.c  */
#line 3273 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, (void*)BREAK_R_F);
		set_cfg_pos((yyval.action));
	;}
    break;



/* Line 1455 of yacc.c  */
#line 11853 "cfg.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 3279 "cfg.y"


static void get_cpos(struct cfg_pos* pos)
{
	pos->s_line=startline;
	pos->e_line=line;
	pos->s_col=startcolumn;
	pos->e_col=column-1;
	if(finame==0)
		finame = (cfg_file!=0)?cfg_file:"default";
	pos->fname=finame;
}


static void warn_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];
	
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LOG(L_WARN, "warning in config file %s, from line %d, column %d to"
					" line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LOG(L_WARN, "warning in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LOG(L_WARN, "warning in config file %s, line %d, column %d: %s\n",
				p->fname, p->s_line, p->s_col, s);
	cfg_warnings++;
}



static void yyerror_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];
	
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LOG(L_CRIT, "parse error in config file %s, from line %d, column %d"
					" to line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LOG(L_CRIT,"parse error in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LOG(L_CRIT, "parse error in config file %s, line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, s);
	cfg_errors++;
}



static void warn(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;
	
	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	warn_at(&pos, s);
}



static void yyerror(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;
	
	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	yyerror_at(&pos, s);
}



/** mk_rval_expr_v wrapper.
 *  checks mk_rval_expr_v return value and sets the cfg. pos
 *  (line and column numbers)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr_v)
 */
static struct rval_expr* mk_rve_rval(enum rval_type type, void* v)
{
	struct rval_expr* ret;
	struct cfg_pos pos;

	get_cpos(&pos);
	ret=mk_rval_expr_v(type, v, &pos);
	if (ret==0){
		yyerror("internal error: failed to create rval expr");
		/* YYABORT; */
	}
	return ret;
}


/** mk_rval_expr1 wrapper.
 *  checks mk_rval_expr1 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr1)
 */
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	
	if (rve1==0)
		return 0;
	ret=mk_rval_expr1(op, rve1, &rve1->fpos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		yyerror_at(&rve1->fpos, "bad expression: type mismatch"
					" (%s instead of %s)", rval_type_name(bad_t),
					rval_type_name(exp_t));
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** mk_rval_expr2 wrapper.
 *  checks mk_rval_expr2 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr2)
 */
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	struct cfg_pos pos;
	
	if ((rve1==0) || (rve2==0))
		return 0;
	bad_rve=0;
	bad_t=0;
	exp_t=0;
	cfg_pos_join(&pos, &rve1->fpos, &rve2->fpos);
	ret=mk_rval_expr2(op, rve1, rve2, &pos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		if (bad_rve)
			yyerror_at(&pos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** check if the expression is an int.
 * if the expression does not evaluate to an int return -1 and
 * log an error.
 * @return 0 success, no warnings; 1 success but warnings; -1 on error */
static int rval_expr_int_check(struct rval_expr *rve)
{
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	
	if (rve==0){
		yyerror("invalid expression");
		return -1;
	}else if (!rve_check_type(&type, rve, &bad_rve, &bad_t ,&exp_t)){
		if (bad_rve)
			yyerror_at(&rve->fpos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		return -1;
	}else if (type!=RV_INT && type!=RV_NONE){
		warn_at(&rve->fpos, "non-int expression (you might want to use"
				" casts)\n");
		return 1;
	}
	return 0;
}


/** warn if the expression is constant.
 * @return 0 on success (no warning), 1 when warning */
static int warn_ct_rve(struct rval_expr *rve, char* name)
{
	if (rve && rve_is_constant(rve)){
		warn_at(&rve->fpos, "constant value in %s%s",
				name?name:"expression", name?"(...)":"");
		return 1;
	}
	return 0;
}


static struct name_lst* mk_name_lst(char* host, int flags)
{
	struct name_lst* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct name_lst));
	if (l==0) {
		LOG(L_CRIT,"ERROR: cfg. parser: out of memory.\n");
	} else {
		l->name=host;
		l->flags=flags;
		l->next=0;
	}
	return l;
}


static struct socket_id* mk_listen_id(char* host, int proto, int port)
{
	struct socket_id* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		LOG(L_CRIT,"ERROR: cfg. parser: out of memory.\n");
	} else {
		l->addr_lst=mk_name_lst(host, 0);
		if (l->addr_lst==0){
			pkg_free(l);
			return 0;
		}
		l->flags=0;
		l->port=port;
		l->proto=proto;
		l->next=0;
	}
	return l;
}


static void free_name_lst(struct name_lst* lst)
{
	struct name_lst* tmp;
	
	while(lst){
		tmp=lst;
		lst=lst->next;
		pkg_free(tmp);
	}
}


static struct socket_id* mk_listen_id2(struct name_lst* addr_l, int proto,
										int port)
{
	struct socket_id* l;
	if (addr_l==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		LOG(L_CRIT,"ERROR: cfg. parser: out of memory.\n");
	} else {
		l->flags=addr_l->flags;
		l->port=port;
		l->proto=proto;
		l->addr_lst=addr_l;
		l->next=0;
	}
	return l;
}


static void free_socket_id(struct socket_id* i)
{
	free_name_lst(i->addr_lst);
	pkg_free(i);
}


static void free_socket_id_lst(struct socket_id* lst)
{
	struct socket_id* tmp;
	
	while(lst){
		tmp=lst;
		lst=lst->next;
		free_socket_id(tmp);
	}
}


/** create a temporary case statmenet structure.
 *  *err will be filled in case of error (return == 0):
 *   -1 - non constant expression
 *   -2 - expression error (bad type)
 *   -10 - memory allocation error
 */
static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
											struct action* a, int* err)
{
	struct case_stms* s;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	enum match_str_type t;
	
	t=MATCH_UNKNOWN;
	if (ct){
		/* if ct!=0 => case, else if ct==0 is a default */
		if (!rve_is_constant(ct)){
			yyerror_at(&ct->fpos, "non constant expression in case");
			*err=-1;
			return 0;
		}
		if (rve_check_type(&type, ct, &bad_rve, &bad_t, &exp_t)!=1){
			yyerror_at(&ct->fpos, "bad expression: type mismatch:"
							" %s instead of %s at (%d,%d)",
							rval_type_name(bad_t), rval_type_name(exp_t),
							bad_rve->fpos.s_line, bad_rve->fpos.s_col);
			*err=-2;
			return 0;
		}
		if (is_re)
			t=MATCH_RE;
		else if (type==RV_STR)
			t=MATCH_STR;
		else
			t=MATCH_INT;
	}

	s=pkg_malloc(sizeof(*s));
	if (s==0) {
		yyerror("internal error: memory allocation failure");
		*err=-10;
	} else {
		memset(s, 0, sizeof(*s));
		s->ct_rve=ct;
		s->type=t;
		s->actions=a;
		s->next=0;
		s->append=0;
	}
	return s;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_type(struct case_stms* stms)
{
	struct case_stms* c;
	struct case_stms* s;
	
	for(c=stms; c ; c=c->next){
		if (!c->ct_rve) continue;
		for (s=c->next; s; s=s->next){
			if (!s->ct_rve) continue;
			if ((s->type!=c->type) &&
				!(	(c->type==MATCH_STR || c->type==MATCH_RE) &&
					(s->type==MATCH_STR || s->type==MATCH_RE) ) ){
					yyerror_at(&s->ct_rve->fpos, "type mismatch in case");
					return -1;
			}
		}
	}
	return 0;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_default(struct case_stms* stms)
{
	struct case_stms* c;
	int default_no;
	
	default_no=0;
	for(c=stms; c ; c=c->next)
		if (c->ct_rve==0) default_no++;
	return (default_no<=1)?0:-1;
}



/*
int main(int argc, char ** argv)
{
	if (yyparse()!=0)
		fprintf(stderr, "parsing error\n");
}
*/

